%<<<<<<<<<<<<<STAGE 1>>>>>>>>>>>>>%
        [a,b,c]=size(positionlinks);
        timesim=0:35/(c-1):35;
        Ts_pos=35/(c-1);                     %We will have a sample the position frecuency of 4 Hz with the GPS
        Ts2=35/(c-1);
        filt_speed=Ts_pos/100;          %Filter speed selection
        Ts_2=35/(c-1);

        
        posx0=-1.75;                %Initial condition for the position.
        velx0=0;                    %Initial condition for the velocity.
        accelx0= 0;                 %Initial condition for the acceleration.
        angle0=0;                   %Initial condition for the head angle.
        angle_vel0=0;
        
        posy0=0;                    %Initial condition for the position.
        vely0=0;                    %Initial condition for the velocity.
        accely0=0;                  %Initial condition for the acceleration.     
%Noise covariance definition
        w1=0.002;                     %Position noise. 
        w2=0.002;                    %Acceleration noise.
        w3=1/(2*pi);                   %Angle velocity error
%<<<<<<<<<<<<<END STAGE 1>>>>>>>>>>>>>% 


%<<<<<<<<<<<<<STAGE 2>>>>>>>>>>>>>%

        
        t2=timesim;       %Time vector.
        
        t_pos=timesim;    %Time vector.
       
        
        posx=eye(1,c);
        posx(:)=positionlinks(1,1,:);                  % Real x position  
                
        posy=eye(1,c);
        posy(:)=positionlinks(7,1,:);                  % Real y position
                
        accelxrel=eye(1,c);
        accelxrel(:)=accelx__rel_real(1,1,:);                  % Real x acceleration  
                
        accelyrel=eye(1,c);
        accelxrel(:)=accely__rel_real(1,1,:);                  % Real y acceleration
        
        
        
        
        
        
        
        %Position sensor  vector load from the ideal model
                pos_senx=eye(1,c);
                pos_senx(:)=positionlinks_ideal(1,1,:);                  % Measured x position  
                
                pos_seny=eye(1,c);
                pos_seny(:)=positionlinks_ideal(7,1,:);                  % Measured y position
                
                
                %Acceleration sensor load from the accelerometer
                accel_senx=eye(1,c);       
                accel_senx(:)=accelx_sen_real(1,1,:);                 % Measured  x acceleration
                
                accel_seny=eye(1,c);
                accel_seny(:)=accely_sen_real(1,1,:);                 % Measured y acceleration  
                
                %Angle velocity load from the gyroscope
                anglevel_sen=eye(1,c);
                anglevel_sen(:)=anglevelsen(1,1,:);
                

 %<<<<<<<<<<<<<END STAGE 2>>>>>>>>>>>>>%  
 
 
 %<<<<<<<<<<<<<STAGE 3>>>>>>>>>>>>>%
 
        A_=[0 0 1 0 0 0 0 0;0 0 0 1 0 0 0 0;0 0 0 0 1 0 0 0;0 0 0 0 0 1 0 0;0 0 0 0 0 0 0 0;0 0 0 0 0 0 0 0;0 0 0 0 0 0 0 1;0 0 0 0 0 0 0 0];
        B_=[0 0 0 0 0 0 0 0;0 0 0 0 0 0 0 0;0 0 0 0 0 0 0 0;0 0 0 0 0 0 0 0;0 0 0 0 0 0 0 0;0 0 0 0 0 0 0 0;0 0 0 0 0 0 0 0;0 0 0 0 0 0 0 0];
        C_=[1 0 0 0 0 0 0 0;0 1 0 0 0 0 0 0;0 0 0 0 1 0 0 0;0 0 0 0 0 1 0 0;0 0 0 0 0 0 0 1];                                                                 %Continuous system definition
        D_=[0 0 0 0 0 0 0 0;0 0 0 0 0 0 0 0;0 0 0 0 0 0 0 0;0 0 0 0 0 0 0 0;0 0 0 0 0 0 0 0];
        
        sys=ss(A_,B_,C_,D_);
        sys=c2d(sys,Ts_pos,'zoh');  % Discretization 
        [F_,G_,H_,Kd]=ssdata(sys);
        
        %Sensor matrix covariance. The elements that arent in the diagonal
        %are thero because the noise is uncorrelated.
        R=[w1^2  0  0  0  0;0  w1^2  0  0 0;0  0  w2^2 0 0;0  0  0  w2^2 0;0 0 0 0 w3^2];
        
        Q=[ Ts_pos^5/20       0       Ts_pos^4/8          0         Ts_pos^3/6        0            0         0;
            0            Ts_pos^5/20       0         Ts_pos^4/8         0        Ts_pos^3/6        0         0;
          Ts_pos^4/8          0       Ts_pos^3/3          0         Ts_pos^2/2        0            0         0; 
            0            Ts_pos^4/8        0         Ts_pos^3/3         0        Ts_pos^2/2        0         0;
          Ts_pos^3/6          0        Ts_pos^2/2         0          Ts_pos           0            0         0;
            0            Ts_pos^3/6        0         Ts_pos^2/2         0          Ts_pos          0         0;
            0                 0            0              0             0             0        Ts_pos^3/3    Ts_pos^2/2;
            0                 0            0              0             0             0        Ts_pos^2/2      Ts_pos];
        
        
        Q=filt_speed*Q/norm(Q);
     
        
 %<<<<<<<<<<<<<END STAGE 3>>>>>>>>>>>>>%  
 
  %<<<<<<<<<<<<<STAGE 4>>>>>>>>>>>>>%
  
  %Seting the estimated variables starting value
  
    pos_estx(1)=pos_senx(1);
    vel_estx(1)=0;
    accel_estx(1)=accel_senx(1);
    angle_est(1)=0;
    anglevel_est(1)=anglevel_sen(1);
    pos_esty(1)=pos_seny(1);
    vel_esty(1)=0;
    accel_esty(1)=accel_seny(1);
    
    P(:,:,1)= Q;
    XKK= [pos_estx(1);pos_esty(1); vel_estx(1);vel_esty(1); accel_estx(1);accel_esty(1);angle_est(1);anglevel_sen(1)];    %X(k|k) (estimated)
    PKK=P(:,:,1);                                   %P(k|k) initial value
    
    % Calling the Kallman  loop
    
        for  k=1:length(accel_seny)-1

            ZK1=[pos_senx(k+1); pos_seny(k+1); accel_senx(k+1); accel_seny(k+1);anglevel_sen(k+1)];             %Z(k+1) measured at k+1
            
            H_=[1 0 0 0 0 0 0 0;0 1 0 0 0 0 0 0;0 0 0 0 cos(XKK(7)) sin(XKK(7)) -sin(XKK(7))*XKK(5)+cos(XKK(7))*XKK(6) 0;0 0 0 0 -sin(XKK(7)) cos(XKK(7)) -cos(XKK(7))*XKK(5)-sin(XKK(7))*XKK(6) 0;0 0 0 0 0 0 0 1];
            
            [XK1K1,PK1K1,KK1]=fkloop_extended(XKK,PKK,ZK1,F_,H_,Q,R); 
            
            
            
             Ka(:,:,k+1)=KK1;                       %Ka represents the evolution of the kalman gain    
             pos_estx(k+1)=XK1K1(1);
             pos_esty(k+1)=XK1K1(2);                %Estimated position given for the Kalman filter for the next step
             vel_estx(k+1)=XK1K1(3);
             vel_esty(k+1)=XK1K1(4);                %Estimated velocity given for the Kalman filter for the next step     
             accel_estx(k+1)=XK1K1(5);
             accel_esty(k+1)=XK1K1(6);              %Estimated acceleration given for the Kalman filter for the next step
             angle_est(k+1)=XK1K1(7);               %Estimated head angle given for the Kalman filter for the next step
             anglevel_est(k+1)=XK1K1(8);            %Estimated head angle velocity given for the Kalman filter for the next step
             
             P(:,:,k+1)=PK1K1;
        
        %t+1 will be t in the next step in the loop
              PKK=PK1K1;
              XKK=XK1K1;
        
        end
        
errorx=sqrt((posx-pos_estx).^2);
errory=sqrt((posy-pos_esty).^2);
      


figure('Name','Real state vs estimated state in the x axis')

        
        plot(t2,posx,t_pos,pos_estx)
        ylabel('x position (m)')
        xlabel('time (s)')
        legend('Real x position','Estimated x position')
        
        grid on


        
        
 figure('Name','Real state vd estimated state y axis')

        
        plot(t2,posy,t_pos,pos_esty)
        ylabel('y position (m)')
        xlabel('time (s)')
        legend('Real y position','Estimated y position')
        grid on

        
figure('Name','Absolute error')        
        plot(t2,errorx,t_pos,errory)
        ylabel(' error (m)')
        xlabel('time (s)')
        legend('Absolute error x component','Absolute error y component')
        grid on
        
figure('Name','Real trajectory vs estimated trajectory')
    plot(posx,posy,pos_estx,pos_esty)
    xlabel('X position [m]')
    ylabel('Y position [m]')
    legend('Real trajectory','Estimated trajectory')
    grid on

