/* Include files */

#include "discrete_sfun.h"
#include "c1_discrete.h"
#include "c3_discrete.h"
#include "c4_discrete.h"
#include "c5_discrete.h"
#include "c6_discrete.h"
#include "c7_discrete.h"
#include "c8_discrete.h"

/* Type Definitions */

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */
uint8_T _sfEvent_;
uint32_T _discreteMachineNumber_;
real_T _sfTime_;

/* Function Declarations */

/* Function Definitions */
void discrete_initializer(void)
{
  _sfEvent_ = CALL_EVENT;
}

void discrete_terminator(void)
{
}

/* SFunction Glue Code */
unsigned int sf_discrete_method_dispatcher(SimStruct *simstructPtr, unsigned int
  chartFileNumber, int_T method, void *data)
{
  if (chartFileNumber==1) {
    c1_discrete_method_dispatcher(simstructPtr, method, data);
    return 1;
  }

  if (chartFileNumber==3) {
    c3_discrete_method_dispatcher(simstructPtr, method, data);
    return 1;
  }

  if (chartFileNumber==4) {
    c4_discrete_method_dispatcher(simstructPtr, method, data);
    return 1;
  }

  if (chartFileNumber==5) {
    c5_discrete_method_dispatcher(simstructPtr, method, data);
    return 1;
  }

  if (chartFileNumber==6) {
    c6_discrete_method_dispatcher(simstructPtr, method, data);
    return 1;
  }

  if (chartFileNumber==7) {
    c7_discrete_method_dispatcher(simstructPtr, method, data);
    return 1;
  }

  if (chartFileNumber==8) {
    c8_discrete_method_dispatcher(simstructPtr, method, data);
    return 1;
  }

  return 0;
}

unsigned int sf_discrete_process_check_sum_call( int nlhs, mxArray * plhs[], int
  nrhs, const mxArray * prhs[] )
{

#ifdef MATLAB_MEX_FILE

  char commandName[20];
  if (nrhs<1 || !mxIsChar(prhs[0]) )
    return 0;

  /* Possible call to get the checksum */
  mxGetString(prhs[0], commandName,sizeof(commandName)/sizeof(char));
  commandName[(sizeof(commandName)/sizeof(char)-1)] = '\0';
  if (strcmp(commandName,"sf_get_check_sum"))
    return 0;
  plhs[0] = mxCreateDoubleMatrix( 1,4,mxREAL);
  if (nrhs>1 && mxIsChar(prhs[1])) {
    mxGetString(prhs[1], commandName,sizeof(commandName)/sizeof(char));
    commandName[(sizeof(commandName)/sizeof(char)-1)] = '\0';
    if (!strcmp(commandName,"machine")) {
      ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(4155552517U);
      ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(1614244130U);
      ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(3625719763U);
      ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(4196790722U);
    } else if (!strcmp(commandName,"exportedFcn")) {
      ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(0U);
      ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(0U);
      ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(0U);
      ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(0U);
    } else if (!strcmp(commandName,"makefile")) {
      ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(114085835U);
      ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(1455456746U);
      ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(1270505835U);
      ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(2883648882U);
    } else if (nrhs==3 && !strcmp(commandName,"chart")) {
      unsigned int chartFileNumber;
      chartFileNumber = (unsigned int)mxGetScalar(prhs[2]);
      switch (chartFileNumber) {
       case 1:
        {
          extern void sf_c1_discrete_get_check_sum(mxArray *plhs[]);
          sf_c1_discrete_get_check_sum(plhs);
          break;
        }

       case 3:
        {
          extern void sf_c3_discrete_get_check_sum(mxArray *plhs[]);
          sf_c3_discrete_get_check_sum(plhs);
          break;
        }

       case 4:
        {
          extern void sf_c4_discrete_get_check_sum(mxArray *plhs[]);
          sf_c4_discrete_get_check_sum(plhs);
          break;
        }

       case 5:
        {
          extern void sf_c5_discrete_get_check_sum(mxArray *plhs[]);
          sf_c5_discrete_get_check_sum(plhs);
          break;
        }

       case 6:
        {
          extern void sf_c6_discrete_get_check_sum(mxArray *plhs[]);
          sf_c6_discrete_get_check_sum(plhs);
          break;
        }

       case 7:
        {
          extern void sf_c7_discrete_get_check_sum(mxArray *plhs[]);
          sf_c7_discrete_get_check_sum(plhs);
          break;
        }

       case 8:
        {
          extern void sf_c8_discrete_get_check_sum(mxArray *plhs[]);
          sf_c8_discrete_get_check_sum(plhs);
          break;
        }

       default:
        ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(0.0);
        ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(0.0);
        ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(0.0);
        ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(0.0);
      }
    } else if (!strcmp(commandName,"target")) {
      ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(3901255494U);
      ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(3502312195U);
      ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(312011709U);
      ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(2399046860U);
    } else {
      return 0;
    }
  } else {
    ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(1596344345U);
    ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(3501317974U);
    ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(3236621236U);
    ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(4135588983U);
  }

  return 1;

#else

  return 0;

#endif

}

unsigned int sf_discrete_autoinheritance_info( int nlhs, mxArray * plhs[], int
  nrhs, const mxArray * prhs[] )
{

#ifdef MATLAB_MEX_FILE

  char commandName[32];
  if (nrhs<2 || !mxIsChar(prhs[0]) )
    return 0;

  /* Possible call to get the autoinheritance_info */
  mxGetString(prhs[0], commandName,sizeof(commandName)/sizeof(char));
  commandName[(sizeof(commandName)/sizeof(char)-1)] = '\0';
  if (strcmp(commandName,"get_autoinheritance_info"))
    return 0;

  {
    unsigned int chartFileNumber;
    chartFileNumber = (unsigned int)mxGetScalar(prhs[1]);
    switch (chartFileNumber) {
     case 1:
      {
        extern mxArray *sf_c1_discrete_get_autoinheritance_info(void);
        plhs[0] = sf_c1_discrete_get_autoinheritance_info();
        break;
      }

     case 3:
      {
        extern mxArray *sf_c3_discrete_get_autoinheritance_info(void);
        plhs[0] = sf_c3_discrete_get_autoinheritance_info();
        break;
      }

     case 4:
      {
        extern mxArray *sf_c4_discrete_get_autoinheritance_info(void);
        plhs[0] = sf_c4_discrete_get_autoinheritance_info();
        break;
      }

     case 5:
      {
        extern mxArray *sf_c5_discrete_get_autoinheritance_info(void);
        plhs[0] = sf_c5_discrete_get_autoinheritance_info();
        break;
      }

     case 6:
      {
        extern mxArray *sf_c6_discrete_get_autoinheritance_info(void);
        plhs[0] = sf_c6_discrete_get_autoinheritance_info();
        break;
      }

     case 7:
      {
        extern mxArray *sf_c7_discrete_get_autoinheritance_info(void);
        plhs[0] = sf_c7_discrete_get_autoinheritance_info();
        break;
      }

     case 8:
      {
        extern mxArray *sf_c8_discrete_get_autoinheritance_info(void);
        plhs[0] = sf_c8_discrete_get_autoinheritance_info();
        break;
      }

     default:
      plhs[0] = mxCreateDoubleMatrix(0,0,mxREAL);
    }
  }

  return 1;

#else

  return 0;

#endif

}

unsigned int sf_discrete_get_eml_resolved_functions_info( int nlhs, mxArray *
  plhs[], int nrhs, const mxArray * prhs[] )
{

#ifdef MATLAB_MEX_FILE

  char commandName[64];
  if (nrhs<2 || !mxIsChar(prhs[0]))
    return 0;

  /* Possible call to get the get_eml_resolved_functions_info */
  mxGetString(prhs[0], commandName,sizeof(commandName)/sizeof(char));
  commandName[(sizeof(commandName)/sizeof(char)-1)] = '\0';
  if (strcmp(commandName,"get_eml_resolved_functions_info"))
    return 0;

  {
    unsigned int chartFileNumber;
    chartFileNumber = (unsigned int)mxGetScalar(prhs[1]);
    switch (chartFileNumber) {
     case 1:
      {
        extern const mxArray *sf_c1_discrete_get_eml_resolved_functions_info
          (void);
        mxArray *persistentMxArray = (mxArray *)
          sf_c1_discrete_get_eml_resolved_functions_info();
        plhs[0] = mxDuplicateArray(persistentMxArray);
        mxDestroyArray(persistentMxArray);
        break;
      }

     case 3:
      {
        extern const mxArray *sf_c3_discrete_get_eml_resolved_functions_info
          (void);
        mxArray *persistentMxArray = (mxArray *)
          sf_c3_discrete_get_eml_resolved_functions_info();
        plhs[0] = mxDuplicateArray(persistentMxArray);
        mxDestroyArray(persistentMxArray);
        break;
      }

     case 4:
      {
        extern const mxArray *sf_c4_discrete_get_eml_resolved_functions_info
          (void);
        mxArray *persistentMxArray = (mxArray *)
          sf_c4_discrete_get_eml_resolved_functions_info();
        plhs[0] = mxDuplicateArray(persistentMxArray);
        mxDestroyArray(persistentMxArray);
        break;
      }

     case 5:
      {
        extern const mxArray *sf_c5_discrete_get_eml_resolved_functions_info
          (void);
        mxArray *persistentMxArray = (mxArray *)
          sf_c5_discrete_get_eml_resolved_functions_info();
        plhs[0] = mxDuplicateArray(persistentMxArray);
        mxDestroyArray(persistentMxArray);
        break;
      }

     case 6:
      {
        extern const mxArray *sf_c6_discrete_get_eml_resolved_functions_info
          (void);
        mxArray *persistentMxArray = (mxArray *)
          sf_c6_discrete_get_eml_resolved_functions_info();
        plhs[0] = mxDuplicateArray(persistentMxArray);
        mxDestroyArray(persistentMxArray);
        break;
      }

     case 7:
      {
        extern const mxArray *sf_c7_discrete_get_eml_resolved_functions_info
          (void);
        mxArray *persistentMxArray = (mxArray *)
          sf_c7_discrete_get_eml_resolved_functions_info();
        plhs[0] = mxDuplicateArray(persistentMxArray);
        mxDestroyArray(persistentMxArray);
        break;
      }

     case 8:
      {
        extern const mxArray *sf_c8_discrete_get_eml_resolved_functions_info
          (void);
        mxArray *persistentMxArray = (mxArray *)
          sf_c8_discrete_get_eml_resolved_functions_info();
        plhs[0] = mxDuplicateArray(persistentMxArray);
        mxDestroyArray(persistentMxArray);
        break;
      }

     default:
      plhs[0] = mxCreateDoubleMatrix(0,0,mxREAL);
    }
  }

  return 1;

#else

  return 0;

#endif

}

void discrete_debug_initialize(void)
{
  _discreteMachineNumber_ = sf_debug_initialize_machine("discrete","sfun",0,7,0,
    0,0);
  sf_debug_set_machine_event_thresholds(_discreteMachineNumber_,0,0);
  sf_debug_set_machine_data_thresholds(_discreteMachineNumber_,0);
}

void discrete_register_exported_symbols(SimStruct* S)
{
}
