/* Include files */

#include "blascompat32.h"
#include "het_coeff_model_sfun.h"
#include "c1_het_coeff_model.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance.chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance.instanceNumber)
#include "het_coeff_model_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define c1_IN_NO_ACTIVE_CHILD          (0)

/* Variable Declarations */

/* Variable Definitions */
static SFc1_het_coeff_modelInstanceStruct chartInstance;

/* Function Declarations */
static void initialize_c1_het_coeff_model(void);
static void initialize_params_c1_het_coeff_model(void);
static void enable_c1_het_coeff_model(void);
static void disable_c1_het_coeff_model(void);
static void c1_update_debugger_state_c1_het_coeff_model(void);
static const mxArray *get_sim_state_c1_het_coeff_model(void);
static void set_sim_state_c1_het_coeff_model(const mxArray *c1_st);
static void finalize_c1_het_coeff_model(void);
static void sf_c1_het_coeff_model(void);
static void init_script_number_translation(uint32_T c1_machineNumber, uint32_T
  c1_chartNumber);
static void c1_eml_warning(void);
static const mxArray *c1_sf_marshall(void *c1_chartInstance, void *c1_u);
static const mxArray *c1_b_sf_marshall(void *c1_chartInstance, void *c1_u);
static void c1_info_helper(c1_ResolvedFunctionInfo c1_info[24]);
static const mxArray *c1_emlrt_marshallOut(uint8_T c1_u);
static void c1_emlrt_marshallIn(const mxArray *c1_friction, char *c1_name,
  real_T c1_y[6]);
static uint8_T c1_b_emlrt_marshallIn(const mxArray
  *c1_b_is_active_c1_het_coeff_model, char *c1_name);
static void init_io_bus_offset(void);
static void init_dsm_address_info(void);

/* Function Definitions */
static void initialize_c1_het_coeff_model(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  chartInstance.c1_is_active_c1_het_coeff_model = 0U;
}

static void initialize_params_c1_het_coeff_model(void)
{
}

static void enable_c1_het_coeff_model(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void disable_c1_het_coeff_model(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void c1_update_debugger_state_c1_het_coeff_model(void)
{
}

static const mxArray *get_sim_state_c1_het_coeff_model(void)
{
  const mxArray *c1_st = NULL;
  const mxArray *c1_y = NULL;
  int32_T c1_i0;
  real_T c1_u[6];
  const mxArray *c1_b_y = NULL;
  real_T (*c1_friction)[6];
  c1_friction = (real_T (*)[6])ssGetOutputPortSignal(chartInstance.S, 1);
  c1_st = NULL;
  c1_y = NULL;
  sf_mex_assign(&c1_y, sf_mex_createcellarray(2));
  for (c1_i0 = 0; c1_i0 < 6; c1_i0 = c1_i0 + 1) {
    c1_u[c1_i0] = (*c1_friction)[c1_i0];
  }

  c1_b_y = NULL;
  sf_mex_assign(&c1_b_y, sf_mex_create("y", &c1_u, 0, 0U, 1U, 0U, 1, 6));
  sf_mex_setcell(c1_y, 0, c1_b_y);
  sf_mex_setcell(c1_y, 1, c1_emlrt_marshallOut
                 (chartInstance.c1_is_active_c1_het_coeff_model));
  sf_mex_assign(&c1_st, c1_y);
  return c1_st;
}

static void set_sim_state_c1_het_coeff_model(const mxArray *c1_st)
{
  const mxArray *c1_u;
  real_T c1_dv0[6];
  int32_T c1_i1;
  real_T (*c1_friction)[6];
  c1_friction = (real_T (*)[6])ssGetOutputPortSignal(chartInstance.S, 1);
  chartInstance.c1_doneDoubleBufferReInit = true;
  c1_u = sf_mex_dup(c1_st);
  c1_emlrt_marshallIn(sf_mex_dup(sf_mex_getcell(c1_u, 0)), "friction", c1_dv0);
  for (c1_i1 = 0; c1_i1 < 6; c1_i1 = c1_i1 + 1) {
    (*c1_friction)[c1_i1] = c1_dv0[c1_i1];
  }

  chartInstance.c1_is_active_c1_het_coeff_model = c1_b_emlrt_marshallIn
    (sf_mex_dup(sf_mex_getcell(c1_u, 1)),
     "is_active_c1_het_coeff_model");
  sf_mex_destroy(&c1_u);
  c1_update_debugger_state_c1_het_coeff_model();
  sf_mex_destroy(&c1_st);
}

static void finalize_c1_het_coeff_model(void)
{
}

static void sf_c1_het_coeff_model(void)
{
  int32_T c1_i2;
  int32_T c1_i3;
  int32_T c1_i4;
  int32_T c1_i5;
  uint8_T c1_previousEvent;
  int32_T c1_i6;
  real_T c1_V_tire[6];
  int32_T c1_i7;
  real_T c1_Vlong[6];
  int32_T c1_i8;
  real_T c1_alfa[6];
  real_T c1_nargout = 1.0;
  real_T c1_nargin = 3.0;
  real_T c1_i;
  real_T c1_m;
  real_T c1_n;
  real_T c1_friction[6];
  int32_T c1_i9;
  real_T c1_b_i;
  real_T c1_a;
  real_T c1_b;
  real_T c1_A;
  real_T c1_x;
  real_T c1_b_x;
  real_T c1_B;
  real_T c1_c_x;
  real_T c1_y;
  real_T c1_d_x;
  real_T c1_b_y;
  real_T c1_e_x;
  real_T c1_c_y;
  real_T c1_d_y;
  int32_T c1_i10;
  real_T (*c1_b_friction)[6];
  real_T (*c1_b_alfa)[6];
  real_T (*c1_b_Vlong)[6];
  real_T (*c1_b_V_tire)[6];
  c1_b_V_tire = (real_T (*)[6])ssGetInputPortSignal(chartInstance.S, 0);
  c1_b_alfa = (real_T (*)[6])ssGetInputPortSignal(chartInstance.S, 2);
  c1_b_Vlong = (real_T (*)[6])ssGetInputPortSignal(chartInstance.S, 1);
  c1_b_friction = (real_T (*)[6])ssGetOutputPortSignal(chartInstance.S, 1);
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG,0);
  for (c1_i2 = 0; c1_i2 < 6; c1_i2 = c1_i2 + 1) {
    _SFD_DATA_RANGE_CHECK((*c1_b_V_tire)[c1_i2], 0U);
  }

  for (c1_i3 = 0; c1_i3 < 6; c1_i3 = c1_i3 + 1) {
    _SFD_DATA_RANGE_CHECK((*c1_b_friction)[c1_i3], 1U);
  }

  for (c1_i4 = 0; c1_i4 < 6; c1_i4 = c1_i4 + 1) {
    _SFD_DATA_RANGE_CHECK((*c1_b_Vlong)[c1_i4], 2U);
  }

  for (c1_i5 = 0; c1_i5 < 6; c1_i5 = c1_i5 + 1) {
    _SFD_DATA_RANGE_CHECK((*c1_b_alfa)[c1_i5], 3U);
  }

  c1_previousEvent = _sfEvent_;
  _sfEvent_ = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG,0);
  for (c1_i6 = 0; c1_i6 < 6; c1_i6 = c1_i6 + 1) {
    c1_V_tire[c1_i6] = (*c1_b_V_tire)[c1_i6];
  }

  for (c1_i7 = 0; c1_i7 < 6; c1_i7 = c1_i7 + 1) {
    c1_Vlong[c1_i7] = (*c1_b_Vlong)[c1_i7];
  }

  for (c1_i8 = 0; c1_i8 < 6; c1_i8 = c1_i8 + 1) {
    c1_alfa[c1_i8] = (*c1_b_alfa)[c1_i8];
  }

  sf_debug_symbol_scope_push(9U, 0U);
  sf_debug_symbol_scope_add("nargout", &c1_nargout, c1_b_sf_marshall);
  sf_debug_symbol_scope_add("nargin", &c1_nargin, c1_b_sf_marshall);
  sf_debug_symbol_scope_add("i", &c1_i, c1_b_sf_marshall);
  sf_debug_symbol_scope_add("m", &c1_m, c1_b_sf_marshall);
  sf_debug_symbol_scope_add("n", &c1_n, c1_b_sf_marshall);
  sf_debug_symbol_scope_add("friction", &c1_friction, c1_sf_marshall);
  sf_debug_symbol_scope_add("alfa", &c1_alfa, c1_sf_marshall);
  sf_debug_symbol_scope_add("Vlong", &c1_Vlong, c1_sf_marshall);
  sf_debug_symbol_scope_add("V_tire", &c1_V_tire, c1_sf_marshall);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0,2);
  c1_n = 6.0;
  c1_m = 1.0;
  _SFD_EML_CALL(0,3);
  for (c1_i9 = 0; c1_i9 < 6; c1_i9 = c1_i9 + 1) {
    c1_friction[c1_i9] = 0.0;
  }

  c1_i = 1.0;
  c1_b_i = 1.0;
  while (c1_b_i <= 6.0) {
    c1_i = c1_b_i;
    CV_EML_FOR(0, 0, 1);
    _SFD_EML_CALL(0,5);
    if (CV_EML_COND(0, 0, c1_Vlong[_SFD_EML_ARRAY_BOUNDS_CHECK("Vlong", (int32_T)
          _SFD_INTEGER_CHECK("i", c1_i), 1, 6, 1, 0) - 1] == 0.0)) {
      if (CV_EML_COND(0, 1, c1_V_tire[_SFD_EML_ARRAY_BOUNDS_CHECK("V_tire",
            (int32_T)_SFD_INTEGER_CHECK("i", c1_i), 1, 6, 1, 0) - 1] == 0.0
                      )) {
        CV_EML_MCDC(0, 0, true);
        CV_EML_IF(0, 0, true);
        _SFD_EML_CALL(0,6);
        c1_friction[_SFD_EML_ARRAY_BOUNDS_CHECK("friction", (int32_T)
          _SFD_INTEGER_CHECK("i", c1_i), 1, 6, 1, 0) - 1] = 0.0;
        goto label_1;
      }
    }

    CV_EML_MCDC(0, 0, false);
    CV_EML_IF(0, 0, false);
    _SFD_EML_CALL(0,8);
    c1_a = c1_alfa[_SFD_EML_ARRAY_BOUNDS_CHECK("alfa", (int32_T)
      _SFD_INTEGER_CHECK("i", c1_i), 1, 6, 1, 0) - 1];
    c1_b = c1_V_tire[_SFD_EML_ARRAY_BOUNDS_CHECK("V_tire", (int32_T)
      _SFD_INTEGER_CHECK("i", c1_i), 1, 6, 1, 0) - 1] - c1_Vlong[
      _SFD_EML_ARRAY_BOUNDS_CHECK("Vlong", (int32_T)_SFD_INTEGER_CHECK("i", c1_i),
      1, 6, 1, 0) - 1];
    c1_A = c1_a * c1_b;
    c1_x = c1_Vlong[_SFD_EML_ARRAY_BOUNDS_CHECK("Vlong", (int32_T)
      _SFD_INTEGER_CHECK("i", c1_i), 1, 6, 1, 0) - 1];
    c1_b_x = c1_x;
    c1_B = muDoubleScalarAbs(c1_b_x);
    c1_c_x = c1_A;
    c1_y = c1_B;
    if (c1_y == 0.0) {
      c1_eml_warning();
    }

    c1_d_x = c1_c_x;
    c1_b_y = c1_y;
    c1_e_x = c1_d_x;
    c1_c_y = c1_b_y;
    c1_d_y = c1_e_x / c1_c_y;
    c1_friction[_SFD_EML_ARRAY_BOUNDS_CHECK("friction", (int32_T)
      _SFD_INTEGER_CHECK("i", c1_i), 1, 6, 1, 0) - 1] = c1_d_y;
   label_1:
    ;
    c1_b_i = c1_b_i + 1.0;
    sf_mex_listen_for_ctrl_c(chartInstance.S);
  }

  CV_EML_FOR(0, 0, 0);
  _SFD_EML_CALL(0,-8);
  sf_debug_symbol_scope_pop();
  for (c1_i10 = 0; c1_i10 < 6; c1_i10 = c1_i10 + 1) {
    (*c1_b_friction)[c1_i10] = c1_friction[c1_i10];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG,0);
  _sfEvent_ = c1_previousEvent;
  sf_debug_check_for_state_inconsistency(_het_coeff_modelMachineNumber_,
    chartInstance.chartNumber, chartInstance.instanceNumber);
}

static void init_script_number_translation(uint32_T c1_machineNumber, uint32_T
  c1_chartNumber)
{
}

static void c1_eml_warning(void)
{
  int32_T c1_i11;
  static char_T c1_cv0[15] = { 'D', 'i', 'v', 'i', 'd', 'e', ' ', 'b', 'y', ' ',
    'z', 'e', 'r', 'o', '.' };

  char_T c1_u[15];
  const mxArray *c1_y = NULL;
  int32_T c1_i12;
  static char_T c1_cv1[19] = { 'M', 'A', 'T', 'L', 'A', 'B', ':', 'd', 'i', 'v',
    'i', 'd', 'e', 'B', 'y', 'Z', 'e', 'r', 'o' };

  char_T c1_b_u[19];
  const mxArray *c1_b_y = NULL;
  for (c1_i11 = 0; c1_i11 < 15; c1_i11 = c1_i11 + 1) {
    c1_u[c1_i11] = c1_cv0[c1_i11];
  }

  c1_y = NULL;
  sf_mex_assign(&c1_y, sf_mex_create("y", &c1_u, 10, 0U, 1U, 0U, 2, 1, 15));
  for (c1_i12 = 0; c1_i12 < 19; c1_i12 = c1_i12 + 1) {
    c1_b_u[c1_i12] = c1_cv1[c1_i12];
  }

  c1_b_y = NULL;
  sf_mex_assign(&c1_b_y, sf_mex_create("y", &c1_b_u, 10, 0U, 1U, 0U, 2, 1, 19));
  sf_mex_call_debug("warning", 0U, 2U, 14, c1_b_y, 14, c1_y);
}

static const mxArray *c1_sf_marshall(void *c1_chartInstance, void *c1_u)
{
  const mxArray *c1_y = NULL;
  int32_T c1_i13;
  real_T c1_b_u[6];
  const mxArray *c1_b_y = NULL;
  c1_y = NULL;
  for (c1_i13 = 0; c1_i13 < 6; c1_i13 = c1_i13 + 1) {
    c1_b_u[c1_i13] = (*((real_T (*)[6])c1_u))[c1_i13];
  }

  c1_b_y = NULL;
  sf_mex_assign(&c1_b_y, sf_mex_create("y", &c1_b_u, 0, 0U, 1U, 0U, 1, 6));
  sf_mex_assign(&c1_y, c1_b_y);
  return c1_y;
}

static const mxArray *c1_b_sf_marshall(void *c1_chartInstance, void *c1_u)
{
  const mxArray *c1_y = NULL;
  real_T c1_b_u;
  const mxArray *c1_b_y = NULL;
  c1_y = NULL;
  c1_b_u = *((real_T *)c1_u);
  c1_b_y = NULL;
  sf_mex_assign(&c1_b_y, sf_mex_create("y", &c1_b_u, 0, 0U, 0U, 0U, 0));
  sf_mex_assign(&c1_y, c1_b_y);
  return c1_y;
}

const mxArray *sf_c1_het_coeff_model_get_eml_resolved_functions_info(void)
{
  const mxArray *c1_nameCaptureInfo = NULL;
  c1_ResolvedFunctionInfo c1_info[24];
  const mxArray *c1_m0 = NULL;
  int32_T c1_i14;
  c1_ResolvedFunctionInfo *c1_r0;
  c1_nameCaptureInfo = NULL;
  c1_info_helper(c1_info);
  sf_mex_assign(&c1_m0, sf_mex_createstruct("nameCaptureInfo", 1, 24));
  for (c1_i14 = 0; c1_i14 < 24; c1_i14 = c1_i14 + 1) {
    c1_r0 = &c1_info[c1_i14];
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", c1_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c1_r0->context)), "context",
                    "nameCaptureInfo", c1_i14);
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", c1_r0->name, 15, 0U,
      0U, 0U, 2, 1, strlen(c1_r0->name)), "name",
                    "nameCaptureInfo", c1_i14);
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", c1_r0->dominantType,
      15, 0U, 0U, 0U, 2, 1, strlen(c1_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c1_i14);
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", c1_r0->resolved, 15,
      0U, 0U, 0U, 2, 1, strlen(c1_r0->resolved)), "resolved"
                    , "nameCaptureInfo", c1_i14);
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", &c1_r0->fileLength,
      7, 0U, 0U, 0U, 0), "fileLength", "nameCaptureInfo",
                    c1_i14);
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", &c1_r0->fileTime1, 7,
      0U, 0U, 0U, 0), "fileTime1", "nameCaptureInfo", c1_i14
                    );
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", &c1_r0->fileTime2, 7,
      0U, 0U, 0U, 0), "fileTime2", "nameCaptureInfo", c1_i14
                    );
  }

  sf_mex_assign(&c1_nameCaptureInfo, c1_m0);
  return c1_nameCaptureInfo;
}

static void c1_info_helper(c1_ResolvedFunctionInfo c1_info[24])
{
  c1_info[0].context = "";
  c1_info[0].name = "size";
  c1_info[0].dominantType = "double";
  c1_info[0].resolved = "[B]size";
  c1_info[0].fileLength = 0U;
  c1_info[0].fileTime1 = 0U;
  c1_info[0].fileTime2 = 0U;
  c1_info[1].context = "";
  c1_info[1].name = "zeros";
  c1_info[1].dominantType = "double";
  c1_info[1].resolved = "[B]zeros";
  c1_info[1].fileLength = 0U;
  c1_info[1].fileTime1 = 0U;
  c1_info[1].fileTime2 = 0U;
  c1_info[2].context = "";
  c1_info[2].name = "eq";
  c1_info[2].dominantType = "double";
  c1_info[2].resolved = "[B]eq";
  c1_info[2].fileLength = 0U;
  c1_info[2].fileTime1 = 0U;
  c1_info[2].fileTime2 = 0U;
  c1_info[3].context = "";
  c1_info[3].name = "minus";
  c1_info[3].dominantType = "double";
  c1_info[3].resolved = "[B]minus";
  c1_info[3].fileLength = 0U;
  c1_info[3].fileTime1 = 0U;
  c1_info[3].fileTime2 = 0U;
  c1_info[4].context = "";
  c1_info[4].name = "mtimes";
  c1_info[4].dominantType = "double";
  c1_info[4].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c1_info[4].fileLength = 2408U;
  c1_info[4].fileTime1 = 1227613402U;
  c1_info[4].fileTime2 = 0U;
  c1_info[5].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c1_info[5].name = "nargin";
  c1_info[5].dominantType = "";
  c1_info[5].resolved = "[B]nargin";
  c1_info[5].fileLength = 0U;
  c1_info[5].fileTime1 = 0U;
  c1_info[5].fileTime2 = 0U;
  c1_info[6].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c1_info[6].name = "gt";
  c1_info[6].dominantType = "double";
  c1_info[6].resolved = "[B]gt";
  c1_info[6].fileLength = 0U;
  c1_info[6].fileTime1 = 0U;
  c1_info[6].fileTime2 = 0U;
  c1_info[7].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c1_info[7].name = "isa";
  c1_info[7].dominantType = "double";
  c1_info[7].resolved = "[B]isa";
  c1_info[7].fileLength = 0U;
  c1_info[7].fileTime1 = 0U;
  c1_info[7].fileTime2 = 0U;
  c1_info[8].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c1_info[8].name = "isinteger";
  c1_info[8].dominantType = "double";
  c1_info[8].resolved = "[B]isinteger";
  c1_info[8].fileLength = 0U;
  c1_info[8].fileTime1 = 0U;
  c1_info[8].fileTime2 = 0U;
  c1_info[9].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c1_info[9].name = "isscalar";
  c1_info[9].dominantType = "double";
  c1_info[9].resolved = "[B]isscalar";
  c1_info[9].fileLength = 0U;
  c1_info[9].fileTime1 = 0U;
  c1_info[9].fileTime2 = 0U;
  c1_info[10].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c1_info[10].name = "strcmp";
  c1_info[10].dominantType = "char";
  c1_info[10].resolved = "[B]strcmp";
  c1_info[10].fileLength = 0U;
  c1_info[10].fileTime1 = 0U;
  c1_info[10].fileTime2 = 0U;
  c1_info[11].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c1_info[11].name = "class";
  c1_info[11].dominantType = "double";
  c1_info[11].resolved = "[B]class";
  c1_info[11].fileLength = 0U;
  c1_info[11].fileTime1 = 0U;
  c1_info[11].fileTime2 = 0U;
  c1_info[12].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c1_info[12].name = "not";
  c1_info[12].dominantType = "logical";
  c1_info[12].resolved = "[B]not";
  c1_info[12].fileLength = 0U;
  c1_info[12].fileTime1 = 0U;
  c1_info[12].fileTime2 = 0U;
  c1_info[13].context = "";
  c1_info[13].name = "abs";
  c1_info[13].dominantType = "double";
  c1_info[13].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c1_info[13].fileLength = 566U;
  c1_info[13].fileTime1 = 1221267134U;
  c1_info[13].fileTime2 = 0U;
  c1_info[14].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c1_info[14].name = "ischar";
  c1_info[14].dominantType = "double";
  c1_info[14].resolved = "[B]ischar";
  c1_info[14].fileLength = 0U;
  c1_info[14].fileTime1 = 0U;
  c1_info[14].fileTime2 = 0U;
  c1_info[15].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c1_info[15].name = "islogical";
  c1_info[15].dominantType = "double";
  c1_info[15].resolved = "[B]islogical";
  c1_info[15].fileLength = 0U;
  c1_info[15].fileTime1 = 0U;
  c1_info[15].fileTime2 = 0U;
  c1_info[16].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c1_info[16].name = "eml_scalar_abs";
  c1_info[16].dominantType = "double";
  c1_info[16].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  c1_info[16].fileLength = 461U;
  c1_info[16].fileTime1 = 1203447960U;
  c1_info[16].fileTime2 = 0U;
  c1_info[17].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  c1_info[17].name = "isreal";
  c1_info[17].dominantType = "double";
  c1_info[17].resolved = "[B]isreal";
  c1_info[17].fileLength = 0U;
  c1_info[17].fileTime1 = 0U;
  c1_info[17].fileTime2 = 0U;
  c1_info[18].context = "";
  c1_info[18].name = "mrdivide";
  c1_info[18].dominantType = "double";
  c1_info[18].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.m";
  c1_info[18].fileLength = 771U;
  c1_info[18].fileTime1 = 1219752936U;
  c1_info[18].fileTime2 = 0U;
  c1_info[19].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.m";
  c1_info[19].name = "ge";
  c1_info[19].dominantType = "double";
  c1_info[19].resolved = "[B]ge";
  c1_info[19].fileLength = 0U;
  c1_info[19].fileTime1 = 0U;
  c1_info[19].fileTime2 = 0U;
  c1_info[20].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.m";
  c1_info[20].name = "rdivide";
  c1_info[20].dominantType = "double";
  c1_info[20].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c1_info[20].fileLength = 620U;
  c1_info[20].fileTime1 = 1213926766U;
  c1_info[20].fileTime2 = 0U;
  c1_info[21].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c1_info[21].name = "isempty";
  c1_info[21].dominantType = "double";
  c1_info[21].resolved = "[B]isempty";
  c1_info[21].fileLength = 0U;
  c1_info[21].fileTime1 = 0U;
  c1_info[21].fileTime2 = 0U;
  c1_info[22].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c1_info[22].name = "eml_warning";
  c1_info[22].dominantType = "char";
  c1_info[22].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_warning.m";
  c1_info[22].fileLength = 274U;
  c1_info[22].fileTime1 = 1227613396U;
  c1_info[22].fileTime2 = 0U;
  c1_info[23].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c1_info[23].name = "eml_div";
  c1_info[23].dominantType = "double";
  c1_info[23].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  c1_info[23].fileLength = 4269U;
  c1_info[23].fileTime1 = 1227613386U;
  c1_info[23].fileTime2 = 0U;
}

static const mxArray *c1_emlrt_marshallOut(uint8_T c1_u)
{
  const mxArray *c1_y = NULL;
  c1_y = NULL;
  sf_mex_assign(&c1_y, sf_mex_create("y", &c1_u, 3, 0U, 0U, 0U, 0));
  return c1_y;
}

static void c1_emlrt_marshallIn(const mxArray *c1_friction, char *c1_name,
  real_T c1_y[6])
{
  real_T c1_dv1[6];
  int32_T c1_i15;
  sf_mex_import(c1_name, sf_mex_dup(c1_friction), &c1_dv1, 1, 0, 0U, 1, 0U, 1, 6);
  for (c1_i15 = 0; c1_i15 < 6; c1_i15 = c1_i15 + 1) {
    c1_y[c1_i15] = c1_dv1[c1_i15];
  }

  sf_mex_destroy(&c1_friction);
}

static uint8_T c1_b_emlrt_marshallIn(const mxArray
  *c1_b_is_active_c1_het_coeff_model, char *c1_name)
{
  uint8_T c1_y;
  uint8_T c1_u0;
  sf_mex_import(c1_name, sf_mex_dup(c1_b_is_active_c1_het_coeff_model), &c1_u0,
                1, 3, 0U, 0, 0U, 0);
  c1_y = c1_u0;
  sf_mex_destroy(&c1_b_is_active_c1_het_coeff_model);
  return c1_y;
}

static void init_io_bus_offset(void)
{
}

static void init_dsm_address_info(void)
{
}

/* SFunction Glue Code */
void sf_c1_het_coeff_model_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(3000257773U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(343417487U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(3609394404U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(1225002956U);
}

mxArray *sf_c1_het_coeff_model_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,4,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(3356053377U);
    pr[1] = (double)(559709466U);
    pr[2] = (double)(634552602U);
    pr[3] = (double)(2624604767U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,3,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  return(mxAutoinheritanceInfo);
}

static mxArray *sf_get_sim_state_info_c1_het_coeff_model(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[5],T\"friction\",},{M[8],M[0],T\"is_active_c1_het_coeff_model\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c1_het_coeff_model_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (_het_coeff_modelMachineNumber_,
           1,
           1,
           1,
           4,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance.chartNumber),
           &(chartInstance.instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_het_coeff_modelMachineNumber_,
            chartInstance.chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (_het_coeff_modelMachineNumber_,chartInstance.chartNumber,1);
          sf_debug_set_chart_event_thresholds(_het_coeff_modelMachineNumber_,
            chartInstance.chartNumber,
            0,
            0,
            0);

          {
            unsigned int dimVector[1];
            dimVector[0]= 6;
            _SFD_SET_DATA_PROPS(0,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"V_tire",0,c1_sf_marshall);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 6;
            _SFD_SET_DATA_PROPS(1,2,0,1,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"friction",0,NULL);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 6;
            _SFD_SET_DATA_PROPS(2,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"Vlong",0,NULL);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 6;
            _SFD_SET_DATA_PROPS(3,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"alfa",0,NULL);
          }

          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of EML Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,0,1,0,2,1);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,254);
        _SFD_CV_INIT_EML_IF(0,0,108,144,170,250);
        _SFD_CV_INIT_EML_FOR(0,0,92,104,254);

        {
          static int condStart[] = { 112, 129 };

          static int condEnd[] = { 125, 143 };

          static int pfixExpr[] = { 0, 1, -3 };

          _SFD_CV_INIT_EML_MCDC(0,0,111,144,2,0,&(condStart[0]),&(condEnd[0]),3,
                                &(pfixExpr[0]));
        }

        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          real_T (*c1_V_tire)[6];
          real_T (*c1_friction)[6];
          real_T (*c1_Vlong)[6];
          real_T (*c1_alfa)[6];
          c1_V_tire = (real_T (*)[6])ssGetInputPortSignal(chartInstance.S, 0);
          c1_alfa = (real_T (*)[6])ssGetInputPortSignal(chartInstance.S, 2);
          c1_Vlong = (real_T (*)[6])ssGetInputPortSignal(chartInstance.S, 1);
          c1_friction = (real_T (*)[6])ssGetOutputPortSignal(chartInstance.S, 1);
          _SFD_SET_DATA_VALUE_PTR(0U, c1_V_tire);
          _SFD_SET_DATA_VALUE_PTR(1U, c1_friction);
          _SFD_SET_DATA_VALUE_PTR(2U, c1_Vlong);
          _SFD_SET_DATA_VALUE_PTR(3U, c1_alfa);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_het_coeff_modelMachineNumber_,
        chartInstance.chartNumber,chartInstance.instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c1_het_coeff_model(void *chartInstanceVar)
{
  chart_debug_initialization(chartInstance.S,0);
  initialize_params_c1_het_coeff_model();
  initialize_c1_het_coeff_model();
}

static void sf_opaque_enable_c1_het_coeff_model(void *chartInstanceVar)
{
  enable_c1_het_coeff_model();
}

static void sf_opaque_disable_c1_het_coeff_model(void *chartInstanceVar)
{
  disable_c1_het_coeff_model();
}

static void sf_opaque_gateway_c1_het_coeff_model(void *chartInstanceVar)
{
  sf_c1_het_coeff_model();
}

static mxArray* sf_opaque_get_sim_state_c1_het_coeff_model(void
  *chartInstanceVar)
{
  mxArray *st = (mxArray *) get_sim_state_c1_het_coeff_model();
  return st;
}

static void sf_opaque_set_sim_state_c1_het_coeff_model(void *chartInstanceVar,
  const mxArray *st)
{
  set_sim_state_c1_het_coeff_model(sf_mex_dup(st));
}

static void sf_opaque_terminate_c1_het_coeff_model(void *chartInstanceVar)
{
  if (sim_mode_is_rtw_gen(chartInstance.S) || sim_mode_is_external
      (chartInstance.S)) {
    sf_clear_rtw_identifier(chartInstance.S);
  }

  finalize_c1_het_coeff_model();
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c1_het_coeff_model(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c1_het_coeff_model();
  }
}

static void mdlSetWorkWidths_c1_het_coeff_model(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("het_coeff_model","het_coeff_model",1);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop("het_coeff_model","het_coeff_model",1,
                "RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("het_coeff_model",
      "het_coeff_model",1,"gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"het_coeff_model","het_coeff_model",
        1,3);
      sf_mark_chart_reusable_outputs(S,"het_coeff_model","het_coeff_model",1,1);
    }

    sf_set_rtw_dwork_info(S,"het_coeff_model","het_coeff_model",1);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(965195864U));
  ssSetChecksum1(S,(573909671U));
  ssSetChecksum2(S,(3021692359U));
  ssSetChecksum3(S,(2800725811U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c1_het_coeff_model(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "het_coeff_model", "het_coeff_model",1);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c1_het_coeff_model(SimStruct *S)
{
  chartInstance.chartInfo.chartInstance = NULL;
  chartInstance.chartInfo.isEMLChart = 1;
  chartInstance.chartInfo.chartInitialized = 0;
  chartInstance.chartInfo.sFunctionGateway =
    sf_opaque_gateway_c1_het_coeff_model;
  chartInstance.chartInfo.initializeChart =
    sf_opaque_initialize_c1_het_coeff_model;
  chartInstance.chartInfo.terminateChart =
    sf_opaque_terminate_c1_het_coeff_model;
  chartInstance.chartInfo.enableChart = sf_opaque_enable_c1_het_coeff_model;
  chartInstance.chartInfo.disableChart = sf_opaque_disable_c1_het_coeff_model;
  chartInstance.chartInfo.getSimState =
    sf_opaque_get_sim_state_c1_het_coeff_model;
  chartInstance.chartInfo.setSimState =
    sf_opaque_set_sim_state_c1_het_coeff_model;
  chartInstance.chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c1_het_coeff_model;
  chartInstance.chartInfo.zeroCrossings = NULL;
  chartInstance.chartInfo.outputs = NULL;
  chartInstance.chartInfo.derivatives = NULL;
  chartInstance.chartInfo.mdlRTW = mdlRTW_c1_het_coeff_model;
  chartInstance.chartInfo.mdlStart = mdlStart_c1_het_coeff_model;
  chartInstance.chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c1_het_coeff_model;
  chartInstance.chartInfo.extModeExec = NULL;
  chartInstance.chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.storeCurrentConfiguration = NULL;
  chartInstance.S = S;
  ssSetUserData(S,(void *)(&(chartInstance.chartInfo)));/* register the chart instance with simstruct */
  if (!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info();
  }

  chart_debug_initialization(S,1);
}

void c1_het_coeff_model_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c1_het_coeff_model(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c1_het_coeff_model(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c1_het_coeff_model(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c1_het_coeff_model_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
