/* Include files */

#include "blascompat32.h"
#include "het_coeff_model_sfun.h"
#include "c7_het_coeff_model.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance.chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance.instanceNumber)
#include "het_coeff_model_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define c7_IN_NO_ACTIVE_CHILD          (0)

/* Variable Declarations */

/* Variable Definitions */
static SFc7_het_coeff_modelInstanceStruct chartInstance;

/* Function Declarations */
static void initialize_c7_het_coeff_model(void);
static void initialize_params_c7_het_coeff_model(void);
static void enable_c7_het_coeff_model(void);
static void disable_c7_het_coeff_model(void);
static void c7_update_debugger_state_c7_het_coeff_model(void);
static const mxArray *get_sim_state_c7_het_coeff_model(void);
static void set_sim_state_c7_het_coeff_model(const mxArray *c7_st);
static void finalize_c7_het_coeff_model(void);
static void sf_c7_het_coeff_model(void);
static void init_script_number_translation(uint32_T c7_machineNumber, uint32_T
  c7_chartNumber);
static const mxArray *c7_sf_marshall(void *c7_chartInstance, void *c7_u);
static const mxArray *c7_b_sf_marshall(void *c7_chartInstance, void *c7_u);
static const mxArray *c7_c_sf_marshall(void *c7_chartInstance, void *c7_u);
static void c7_info_helper(c7_ResolvedFunctionInfo c7_info[23]);
static const mxArray *c7_emlrt_marshallOut(uint8_T c7_u);
static void c7_emlrt_marshallIn(const mxArray *c7_y, char *c7_name, real_T
  c7_b_y[36]);
static uint8_T c7_b_emlrt_marshallIn(const mxArray
  *c7_b_is_active_c7_het_coeff_model, char *c7_name);
static void init_io_bus_offset(void);
static void init_dsm_address_info(void);

/* Function Definitions */
static void initialize_c7_het_coeff_model(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  chartInstance.c7_is_active_c7_het_coeff_model = 0U;
}

static void initialize_params_c7_het_coeff_model(void)
{
}

static void enable_c7_het_coeff_model(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void disable_c7_het_coeff_model(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void c7_update_debugger_state_c7_het_coeff_model(void)
{
}

static const mxArray *get_sim_state_c7_het_coeff_model(void)
{
  const mxArray *c7_st = NULL;
  const mxArray *c7_y = NULL;
  int32_T c7_i0;
  real_T c7_u[36];
  const mxArray *c7_b_y = NULL;
  real_T (*c7_c_y)[36];
  c7_c_y = (real_T (*)[36])ssGetOutputPortSignal(chartInstance.S, 1);
  c7_st = NULL;
  c7_y = NULL;
  sf_mex_assign(&c7_y, sf_mex_createcellarray(2));
  for (c7_i0 = 0; c7_i0 < 36; c7_i0 = c7_i0 + 1) {
    c7_u[c7_i0] = (*c7_c_y)[c7_i0];
  }

  c7_b_y = NULL;
  sf_mex_assign(&c7_b_y, sf_mex_create("y", &c7_u, 0, 0U, 1U, 0U, 2, 6, 6));
  sf_mex_setcell(c7_y, 0, c7_b_y);
  sf_mex_setcell(c7_y, 1, c7_emlrt_marshallOut
                 (chartInstance.c7_is_active_c7_het_coeff_model));
  sf_mex_assign(&c7_st, c7_y);
  return c7_st;
}

static void set_sim_state_c7_het_coeff_model(const mxArray *c7_st)
{
  const mxArray *c7_u;
  real_T c7_dv0[36];
  int32_T c7_i1;
  real_T (*c7_y)[36];
  c7_y = (real_T (*)[36])ssGetOutputPortSignal(chartInstance.S, 1);
  chartInstance.c7_doneDoubleBufferReInit = true;
  c7_u = sf_mex_dup(c7_st);
  c7_emlrt_marshallIn(sf_mex_dup(sf_mex_getcell(c7_u, 0)), "y", c7_dv0);
  for (c7_i1 = 0; c7_i1 < 36; c7_i1 = c7_i1 + 1) {
    (*c7_y)[c7_i1] = c7_dv0[c7_i1];
  }

  chartInstance.c7_is_active_c7_het_coeff_model = c7_b_emlrt_marshallIn
    (sf_mex_dup(sf_mex_getcell(c7_u, 1)),
     "is_active_c7_het_coeff_model");
  sf_mex_destroy(&c7_u);
  c7_update_debugger_state_c7_het_coeff_model();
  sf_mex_destroy(&c7_st);
}

static void finalize_c7_het_coeff_model(void)
{
}

static void sf_c7_het_coeff_model(void)
{
  int32_T c7_i2;
  int32_T c7_i3;
  uint8_T c7_previousEvent;
  int32_T c7_i4;
  real_T c7_u[6];
  real_T c7_nargout = 1.0;
  real_T c7_nargin = 1.0;
  real_T c7_y[36];
  int32_T c7_i5;
  real_T c7_v[6];
  int32_T c7_i6;
  int32_T c7_j;
  int32_T c7_b_j;
  int32_T c7_a;
  int32_T c7_c;
  int32_T c7_i7;
  real_T (*c7_b_y)[36];
  real_T (*c7_b_u)[6];
  c7_b_y = (real_T (*)[36])ssGetOutputPortSignal(chartInstance.S, 1);
  c7_b_u = (real_T (*)[6])ssGetInputPortSignal(chartInstance.S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG,6);
  for (c7_i2 = 0; c7_i2 < 6; c7_i2 = c7_i2 + 1) {
    _SFD_DATA_RANGE_CHECK((*c7_b_u)[c7_i2], 0U);
  }

  for (c7_i3 = 0; c7_i3 < 36; c7_i3 = c7_i3 + 1) {
    _SFD_DATA_RANGE_CHECK((*c7_b_y)[c7_i3], 1U);
  }

  c7_previousEvent = _sfEvent_;
  _sfEvent_ = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG,6);
  for (c7_i4 = 0; c7_i4 < 6; c7_i4 = c7_i4 + 1) {
    c7_u[c7_i4] = (*c7_b_u)[c7_i4];
  }

  sf_debug_symbol_scope_push(4U, 0U);
  sf_debug_symbol_scope_add("nargout", &c7_nargout, c7_c_sf_marshall);
  sf_debug_symbol_scope_add("nargin", &c7_nargin, c7_c_sf_marshall);
  sf_debug_symbol_scope_add("y", &c7_y, c7_b_sf_marshall);
  sf_debug_symbol_scope_add("u", &c7_u, c7_sf_marshall);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0,4);
  for (c7_i5 = 0; c7_i5 < 6; c7_i5 = c7_i5 + 1) {
    c7_v[c7_i5] = c7_u[c7_i5];
  }

  for (c7_i6 = 0; c7_i6 < 36; c7_i6 = c7_i6 + 1) {
    c7_y[c7_i6] = 0.0;
  }

  for (c7_j = 1; c7_j < 7; c7_j = c7_j + 1) {
    c7_b_j = c7_j;
    c7_a = c7_b_j;
    c7_c = c7_a;
    c7_y[(_SFD_EML_ARRAY_BOUNDS_CHECK("d", _SFD_INTEGER_CHECK("j", (real_T)
            c7_b_j), 1, 6, 1, 0) - 1) + 6 * (_SFD_EML_ARRAY_BOUNDS_CHECK(
      "d", _SFD_INTEGER_CHECK("", (real_T)c7_c), 1, 6, 2, 0) - 1)] =
      c7_v[_SFD_EML_ARRAY_BOUNDS_CHECK("v", _SFD_INTEGER_CHECK("j", (real_T
      )c7_b_j), 1, 6, 1, 0) - 1];
  }

  _SFD_EML_CALL(0,-4);
  sf_debug_symbol_scope_pop();
  for (c7_i7 = 0; c7_i7 < 36; c7_i7 = c7_i7 + 1) {
    (*c7_b_y)[c7_i7] = c7_y[c7_i7];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG,6);
  _sfEvent_ = c7_previousEvent;
  sf_debug_check_for_state_inconsistency(_het_coeff_modelMachineNumber_,
    chartInstance.chartNumber, chartInstance.instanceNumber);
}

static void init_script_number_translation(uint32_T c7_machineNumber, uint32_T
  c7_chartNumber)
{
}

static const mxArray *c7_sf_marshall(void *c7_chartInstance, void *c7_u)
{
  const mxArray *c7_y = NULL;
  int32_T c7_i8;
  real_T c7_b_u[6];
  const mxArray *c7_b_y = NULL;
  c7_y = NULL;
  for (c7_i8 = 0; c7_i8 < 6; c7_i8 = c7_i8 + 1) {
    c7_b_u[c7_i8] = (*((real_T (*)[6])c7_u))[c7_i8];
  }

  c7_b_y = NULL;
  sf_mex_assign(&c7_b_y, sf_mex_create("y", &c7_b_u, 0, 0U, 1U, 0U, 1, 6));
  sf_mex_assign(&c7_y, c7_b_y);
  return c7_y;
}

static const mxArray *c7_b_sf_marshall(void *c7_chartInstance, void *c7_u)
{
  const mxArray *c7_y = NULL;
  int32_T c7_i9;
  int32_T c7_i10;
  int32_T c7_i11;
  real_T c7_b_u[36];
  const mxArray *c7_b_y = NULL;
  c7_y = NULL;
  c7_i9 = 0;
  for (c7_i10 = 0; c7_i10 < 6; c7_i10 = c7_i10 + 1) {
    for (c7_i11 = 0; c7_i11 < 6; c7_i11 = c7_i11 + 1) {
      c7_b_u[c7_i11 + c7_i9] = (*((real_T (*)[36])c7_u))[c7_i11 + c7_i9];
    }

    c7_i9 = c7_i9 + 6;
  }

  c7_b_y = NULL;
  sf_mex_assign(&c7_b_y, sf_mex_create("y", &c7_b_u, 0, 0U, 1U, 0U, 2, 6, 6));
  sf_mex_assign(&c7_y, c7_b_y);
  return c7_y;
}

static const mxArray *c7_c_sf_marshall(void *c7_chartInstance, void *c7_u)
{
  const mxArray *c7_y = NULL;
  real_T c7_b_u;
  const mxArray *c7_b_y = NULL;
  c7_y = NULL;
  c7_b_u = *((real_T *)c7_u);
  c7_b_y = NULL;
  sf_mex_assign(&c7_b_y, sf_mex_create("y", &c7_b_u, 0, 0U, 0U, 0U, 0));
  sf_mex_assign(&c7_y, c7_b_y);
  return c7_y;
}

const mxArray *sf_c7_het_coeff_model_get_eml_resolved_functions_info(void)
{
  const mxArray *c7_nameCaptureInfo = NULL;
  c7_ResolvedFunctionInfo c7_info[23];
  const mxArray *c7_m0 = NULL;
  int32_T c7_i12;
  c7_ResolvedFunctionInfo *c7_r0;
  c7_nameCaptureInfo = NULL;
  c7_info_helper(c7_info);
  sf_mex_assign(&c7_m0, sf_mex_createstruct("nameCaptureInfo", 1, 23));
  for (c7_i12 = 0; c7_i12 < 23; c7_i12 = c7_i12 + 1) {
    c7_r0 = &c7_info[c7_i12];
    sf_mex_addfield(c7_m0, sf_mex_create("nameCaptureInfo", c7_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c7_r0->context)), "context",
                    "nameCaptureInfo", c7_i12);
    sf_mex_addfield(c7_m0, sf_mex_create("nameCaptureInfo", c7_r0->name, 15, 0U,
      0U, 0U, 2, 1, strlen(c7_r0->name)), "name",
                    "nameCaptureInfo", c7_i12);
    sf_mex_addfield(c7_m0, sf_mex_create("nameCaptureInfo", c7_r0->dominantType,
      15, 0U, 0U, 0U, 2, 1, strlen(c7_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c7_i12);
    sf_mex_addfield(c7_m0, sf_mex_create("nameCaptureInfo", c7_r0->resolved, 15,
      0U, 0U, 0U, 2, 1, strlen(c7_r0->resolved)), "resolved"
                    , "nameCaptureInfo", c7_i12);
    sf_mex_addfield(c7_m0, sf_mex_create("nameCaptureInfo", &c7_r0->fileLength,
      7, 0U, 0U, 0U, 0), "fileLength", "nameCaptureInfo",
                    c7_i12);
    sf_mex_addfield(c7_m0, sf_mex_create("nameCaptureInfo", &c7_r0->fileTime1, 7,
      0U, 0U, 0U, 0), "fileTime1", "nameCaptureInfo", c7_i12
                    );
    sf_mex_addfield(c7_m0, sf_mex_create("nameCaptureInfo", &c7_r0->fileTime2, 7,
      0U, 0U, 0U, 0), "fileTime2", "nameCaptureInfo", c7_i12
                    );
  }

  sf_mex_assign(&c7_nameCaptureInfo, c7_m0);
  return c7_nameCaptureInfo;
}

static void c7_info_helper(c7_ResolvedFunctionInfo c7_info[23])
{
  c7_info[0].context = "";
  c7_info[0].name = "diag";
  c7_info[0].dominantType = "double";
  c7_info[0].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c7_info[0].fileLength = 2581U;
  c7_info[0].fileTime1 = 1227613384U;
  c7_info[0].fileTime2 = 0U;
  c7_info[1].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c7_info[1].name = "nargin";
  c7_info[1].dominantType = "";
  c7_info[1].resolved = "[B]nargin";
  c7_info[1].fileLength = 0U;
  c7_info[1].fileTime1 = 0U;
  c7_info[1].fileTime2 = 0U;
  c7_info[2].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c7_info[2].name = "ge";
  c7_info[2].dominantType = "double";
  c7_info[2].resolved = "[B]ge";
  c7_info[2].fileLength = 0U;
  c7_info[2].fileTime1 = 0U;
  c7_info[2].fileTime2 = 0U;
  c7_info[3].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c7_info[3].name = "ndims";
  c7_info[3].dominantType = "double";
  c7_info[3].resolved = "[B]ndims";
  c7_info[3].fileLength = 0U;
  c7_info[3].fileTime1 = 0U;
  c7_info[3].fileTime2 = 0U;
  c7_info[4].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c7_info[4].name = "eq";
  c7_info[4].dominantType = "double";
  c7_info[4].resolved = "[B]eq";
  c7_info[4].fileLength = 0U;
  c7_info[4].fileTime1 = 0U;
  c7_info[4].fileTime2 = 0U;
  c7_info[5].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c7_info[5].name = "isnumeric";
  c7_info[5].dominantType = "double";
  c7_info[5].resolved = "[B]isnumeric";
  c7_info[5].fileLength = 0U;
  c7_info[5].fileTime1 = 0U;
  c7_info[5].fileTime2 = 0U;
  c7_info[6].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c7_info[6].name = "eml_index_class";
  c7_info[6].dominantType = "";
  c7_info[6].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c7_info[6].fileLength = 909U;
  c7_info[6].fileTime1 = 1192466782U;
  c7_info[6].fileTime2 = 0U;
  c7_info[7].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c7_info[7].name = "zeros";
  c7_info[7].dominantType = "char";
  c7_info[7].resolved = "[B]zeros";
  c7_info[7].fileLength = 0U;
  c7_info[7].fileTime1 = 0U;
  c7_info[7].fileTime2 = 0U;
  c7_info[8].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c7_info[8].name = "isvector";
  c7_info[8].dominantType = "double";
  c7_info[8].resolved = "[B]isvector";
  c7_info[8].fileLength = 0U;
  c7_info[8].fileTime1 = 0U;
  c7_info[8].fileTime2 = 0U;
  c7_info[9].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c7_info[9].name = "cast";
  c7_info[9].dominantType = "double";
  c7_info[9].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/cast.m";
  c7_info[9].fileLength = 889U;
  c7_info[9].fileTime1 = 1225989442U;
  c7_info[9].fileTime2 = 0U;
  c7_info[10].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/cast.m";
  c7_info[10].name = "ischar";
  c7_info[10].dominantType = "char";
  c7_info[10].resolved = "[B]ischar";
  c7_info[10].fileLength = 0U;
  c7_info[10].fileTime1 = 0U;
  c7_info[10].fileTime2 = 0U;
  c7_info[11].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/cast.m";
  c7_info[11].name = "int32";
  c7_info[11].dominantType = "double";
  c7_info[11].resolved = "[B]int32";
  c7_info[11].fileLength = 0U;
  c7_info[11].fileTime1 = 0U;
  c7_info[11].fileTime2 = 0U;
  c7_info[12].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c7_info[12].name = "lt";
  c7_info[12].dominantType = "int32";
  c7_info[12].resolved = "[B]lt";
  c7_info[12].fileLength = 0U;
  c7_info[12].fileTime1 = 0U;
  c7_info[12].fileTime2 = 0U;
  c7_info[13].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c7_info[13].name = "eml_index_plus";
  c7_info[13].dominantType = "int32";
  c7_info[13].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_plus.m";
  c7_info[13].fileLength = 272U;
  c7_info[13].fileTime1 = 1192466786U;
  c7_info[13].fileTime2 = 0U;
  c7_info[14].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c7_info[14].name = "eml_scalar_eg";
  c7_info[14].dominantType = "double";
  c7_info[14].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c7_info[14].fileLength = 3524U;
  c7_info[14].fileTime1 = 1227613394U;
  c7_info[14].fileTime2 = 0U;
  c7_info[15].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c7_info[15].name = "gt";
  c7_info[15].dominantType = "double";
  c7_info[15].resolved = "[B]gt";
  c7_info[15].fileLength = 0U;
  c7_info[15].fileTime1 = 0U;
  c7_info[15].fileTime2 = 0U;
  c7_info[16].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m/any_enums";
  c7_info[16].name = "false";
  c7_info[16].dominantType = "";
  c7_info[16].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/false.m";
  c7_info[16].fileLength = 238U;
  c7_info[16].fileTime1 = 1192466720U;
  c7_info[16].fileTime2 = 0U;
  c7_info[17].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/false.m";
  c7_info[17].name = "logical";
  c7_info[17].dominantType = "double";
  c7_info[17].resolved = "[B]logical";
  c7_info[17].fileLength = 0U;
  c7_info[17].fileTime1 = 0U;
  c7_info[17].fileTime2 = 0U;
  c7_info[18].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c7_info[18].name = "isstruct";
  c7_info[18].dominantType = "double";
  c7_info[18].resolved = "[B]isstruct";
  c7_info[18].fileLength = 0U;
  c7_info[18].fileTime1 = 0U;
  c7_info[18].fileTime2 = 0U;
  c7_info[19].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c7_info[19].name = "isa";
  c7_info[19].dominantType = "double";
  c7_info[19].resolved = "[B]isa";
  c7_info[19].fileLength = 0U;
  c7_info[19].fileTime1 = 0U;
  c7_info[19].fileTime2 = 0U;
  c7_info[20].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m/zerosum";
  c7_info[20].name = "class";
  c7_info[20].dominantType = "double";
  c7_info[20].resolved = "[B]class";
  c7_info[20].fileLength = 0U;
  c7_info[20].fileTime1 = 0U;
  c7_info[20].fileTime2 = 0U;
  c7_info[21].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/cast.m";
  c7_info[21].name = "double";
  c7_info[21].dominantType = "double";
  c7_info[21].resolved = "[B]double";
  c7_info[21].fileLength = 0U;
  c7_info[21].fileTime1 = 0U;
  c7_info[21].fileTime2 = 0U;
  c7_info[22].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m/allreal";
  c7_info[22].name = "isreal";
  c7_info[22].dominantType = "double";
  c7_info[22].resolved = "[B]isreal";
  c7_info[22].fileLength = 0U;
  c7_info[22].fileTime1 = 0U;
  c7_info[22].fileTime2 = 0U;
}

static const mxArray *c7_emlrt_marshallOut(uint8_T c7_u)
{
  const mxArray *c7_y = NULL;
  c7_y = NULL;
  sf_mex_assign(&c7_y, sf_mex_create("y", &c7_u, 3, 0U, 0U, 0U, 0));
  return c7_y;
}

static void c7_emlrt_marshallIn(const mxArray *c7_y, char *c7_name, real_T
  c7_b_y[36])
{
  real_T c7_dv1[36];
  int32_T c7_i13;
  sf_mex_import(c7_name, sf_mex_dup(c7_y), &c7_dv1, 1, 0, 0U, 1, 0U, 2, 6, 6);
  for (c7_i13 = 0; c7_i13 < 36; c7_i13 = c7_i13 + 1) {
    c7_b_y[c7_i13] = c7_dv1[c7_i13];
  }

  sf_mex_destroy(&c7_y);
}

static uint8_T c7_b_emlrt_marshallIn(const mxArray
  *c7_b_is_active_c7_het_coeff_model, char *c7_name)
{
  uint8_T c7_y;
  uint8_T c7_u0;
  sf_mex_import(c7_name, sf_mex_dup(c7_b_is_active_c7_het_coeff_model), &c7_u0,
                1, 3, 0U, 0, 0U, 0);
  c7_y = c7_u0;
  sf_mex_destroy(&c7_b_is_active_c7_het_coeff_model);
  return c7_y;
}

static void init_io_bus_offset(void)
{
}

static void init_dsm_address_info(void)
{
}

/* SFunction Glue Code */
void sf_c7_het_coeff_model_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(796784553U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(2916865954U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(4059431120U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(1280182206U);
}

mxArray *sf_c7_het_coeff_model_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,4,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(2762996615U);
    pr[1] = (double)(1593114142U);
    pr[2] = (double)(1050482106U);
    pr[3] = (double)(1779091181U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(6);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  return(mxAutoinheritanceInfo);
}

static mxArray *sf_get_sim_state_info_c7_het_coeff_model(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[5],T\"y\",},{M[8],M[0],T\"is_active_c7_het_coeff_model\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c7_het_coeff_model_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (_het_coeff_modelMachineNumber_,
           7,
           1,
           1,
           2,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance.chartNumber),
           &(chartInstance.instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_het_coeff_modelMachineNumber_,
            chartInstance.chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (_het_coeff_modelMachineNumber_,chartInstance.chartNumber,1);
          sf_debug_set_chart_event_thresholds(_het_coeff_modelMachineNumber_,
            chartInstance.chartNumber,
            0,
            0,
            0);

          {
            unsigned int dimVector[1];
            dimVector[0]= 6;
            _SFD_SET_DATA_PROPS(0,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"u",0,c7_sf_marshall);
          }

          {
            unsigned int dimVector[2];
            dimVector[0]= 6;
            dimVector[1]= 6;
            _SFD_SET_DATA_PROPS(1,2,0,1,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"y",0,c7_b_sf_marshall);
          }

          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of EML Model Coverage */
        _SFD_CV_INIT_EML(0,1,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,34);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          real_T (*c7_u)[6];
          real_T (*c7_y)[36];
          c7_y = (real_T (*)[36])ssGetOutputPortSignal(chartInstance.S, 1);
          c7_u = (real_T (*)[6])ssGetInputPortSignal(chartInstance.S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, c7_u);
          _SFD_SET_DATA_VALUE_PTR(1U, c7_y);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_het_coeff_modelMachineNumber_,
        chartInstance.chartNumber,chartInstance.instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c7_het_coeff_model(void *chartInstanceVar)
{
  chart_debug_initialization(chartInstance.S,0);
  initialize_params_c7_het_coeff_model();
  initialize_c7_het_coeff_model();
}

static void sf_opaque_enable_c7_het_coeff_model(void *chartInstanceVar)
{
  enable_c7_het_coeff_model();
}

static void sf_opaque_disable_c7_het_coeff_model(void *chartInstanceVar)
{
  disable_c7_het_coeff_model();
}

static void sf_opaque_gateway_c7_het_coeff_model(void *chartInstanceVar)
{
  sf_c7_het_coeff_model();
}

static mxArray* sf_opaque_get_sim_state_c7_het_coeff_model(void
  *chartInstanceVar)
{
  mxArray *st = (mxArray *) get_sim_state_c7_het_coeff_model();
  return st;
}

static void sf_opaque_set_sim_state_c7_het_coeff_model(void *chartInstanceVar,
  const mxArray *st)
{
  set_sim_state_c7_het_coeff_model(sf_mex_dup(st));
}

static void sf_opaque_terminate_c7_het_coeff_model(void *chartInstanceVar)
{
  if (sim_mode_is_rtw_gen(chartInstance.S) || sim_mode_is_external
      (chartInstance.S)) {
    sf_clear_rtw_identifier(chartInstance.S);
  }

  finalize_c7_het_coeff_model();
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c7_het_coeff_model(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c7_het_coeff_model();
  }
}

static void mdlSetWorkWidths_c7_het_coeff_model(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("het_coeff_model","het_coeff_model",7);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop("het_coeff_model","het_coeff_model",7,
                "RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("het_coeff_model",
      "het_coeff_model",7,"gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"het_coeff_model","het_coeff_model",
        7,1);
      sf_mark_chart_reusable_outputs(S,"het_coeff_model","het_coeff_model",7,1);
    }

    sf_set_rtw_dwork_info(S,"het_coeff_model","het_coeff_model",7);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(1852016419U));
  ssSetChecksum1(S,(3255032146U));
  ssSetChecksum2(S,(1597690353U));
  ssSetChecksum3(S,(197105788U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c7_het_coeff_model(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "het_coeff_model", "het_coeff_model",7);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c7_het_coeff_model(SimStruct *S)
{
  chartInstance.chartInfo.chartInstance = NULL;
  chartInstance.chartInfo.isEMLChart = 1;
  chartInstance.chartInfo.chartInitialized = 0;
  chartInstance.chartInfo.sFunctionGateway =
    sf_opaque_gateway_c7_het_coeff_model;
  chartInstance.chartInfo.initializeChart =
    sf_opaque_initialize_c7_het_coeff_model;
  chartInstance.chartInfo.terminateChart =
    sf_opaque_terminate_c7_het_coeff_model;
  chartInstance.chartInfo.enableChart = sf_opaque_enable_c7_het_coeff_model;
  chartInstance.chartInfo.disableChart = sf_opaque_disable_c7_het_coeff_model;
  chartInstance.chartInfo.getSimState =
    sf_opaque_get_sim_state_c7_het_coeff_model;
  chartInstance.chartInfo.setSimState =
    sf_opaque_set_sim_state_c7_het_coeff_model;
  chartInstance.chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c7_het_coeff_model;
  chartInstance.chartInfo.zeroCrossings = NULL;
  chartInstance.chartInfo.outputs = NULL;
  chartInstance.chartInfo.derivatives = NULL;
  chartInstance.chartInfo.mdlRTW = mdlRTW_c7_het_coeff_model;
  chartInstance.chartInfo.mdlStart = mdlStart_c7_het_coeff_model;
  chartInstance.chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c7_het_coeff_model;
  chartInstance.chartInfo.extModeExec = NULL;
  chartInstance.chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.storeCurrentConfiguration = NULL;
  chartInstance.S = S;
  ssSetUserData(S,(void *)(&(chartInstance.chartInfo)));/* register the chart instance with simstruct */
  if (!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info();
  }

  chart_debug_initialization(S,1);
}

void c7_het_coeff_model_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c7_het_coeff_model(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c7_het_coeff_model(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c7_het_coeff_model(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c7_het_coeff_model_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
