/* Include files */

#include "blascompat32.h"
#include "modelodefinitivo_sfun.h"
#include "c14_modelodefinitivo.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance.chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance.instanceNumber)
#include "modelodefinitivo_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define c14_IN_NO_ACTIVE_CHILD         (0)

/* Variable Declarations */

/* Variable Definitions */
static SFc14_modelodefinitivoInstanceStruct chartInstance;

/* Function Declarations */
static void initialize_c14_modelodefinitivo(void);
static void initialize_params_c14_modelodefinitivo(void);
static void enable_c14_modelodefinitivo(void);
static void disable_c14_modelodefinitivo(void);
static void c14_update_debugger_state_c14_modelodefinitivo(void);
static const mxArray *get_sim_state_c14_modelodefinitivo(void);
static void set_sim_state_c14_modelodefinitivo(const mxArray *c14_st);
static void finalize_c14_modelodefinitivo(void);
static void sf_c14_modelodefinitivo(void);
static void init_script_number_translation(uint32_T c14_machineNumber, uint32_T
  c14_chartNumber);
static const mxArray *c14_sf_marshall(void *c14_chartInstance, void *c14_u);
static const mxArray *c14_emlrt_marshallOut(uint8_T c14_u);
static real_T c14_emlrt_marshallIn(const mxArray *c14_correc, char *c14_name);
static uint8_T c14_b_emlrt_marshallIn(const mxArray
  *c14_b_is_active_c14_modelodefinitivo, char *c14_name);
static void init_io_bus_offset(void);
static void init_dsm_address_info(void);

/* Function Definitions */
static void initialize_c14_modelodefinitivo(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  chartInstance.c14_is_active_c14_modelodefinitivo = 0U;
}

static void initialize_params_c14_modelodefinitivo(void)
{
}

static void enable_c14_modelodefinitivo(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void disable_c14_modelodefinitivo(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void c14_update_debugger_state_c14_modelodefinitivo(void)
{
}

static const mxArray *get_sim_state_c14_modelodefinitivo(void)
{
  const mxArray *c14_st = NULL;
  const mxArray *c14_y = NULL;
  real_T c14_u;
  const mxArray *c14_b_y = NULL;
  real_T *c14_correc;
  c14_correc = (real_T *)ssGetOutputPortSignal(chartInstance.S, 1);
  c14_st = NULL;
  c14_y = NULL;
  sf_mex_assign(&c14_y, sf_mex_createcellarray(2));
  c14_u = *c14_correc;
  c14_b_y = NULL;
  sf_mex_assign(&c14_b_y, sf_mex_create("y", &c14_u, 0, 0U, 0U, 0U, 0));
  sf_mex_setcell(c14_y, 0, c14_b_y);
  sf_mex_setcell(c14_y, 1, c14_emlrt_marshallOut
                 (chartInstance.c14_is_active_c14_modelodefinitivo));
  sf_mex_assign(&c14_st, c14_y);
  return c14_st;
}

static void set_sim_state_c14_modelodefinitivo(const mxArray *c14_st)
{
  const mxArray *c14_u;
  real_T *c14_correc;
  c14_correc = (real_T *)ssGetOutputPortSignal(chartInstance.S, 1);
  chartInstance.c14_doneDoubleBufferReInit = true;
  c14_u = sf_mex_dup(c14_st);
  *c14_correc = c14_emlrt_marshallIn(sf_mex_dup(sf_mex_getcell(c14_u, 0)),
    "correc");
  chartInstance.c14_is_active_c14_modelodefinitivo = c14_b_emlrt_marshallIn
    (sf_mex_dup(sf_mex_getcell(c14_u, 1)),
     "is_active_c14_modelodefinitivo");
  sf_mex_destroy(&c14_u);
  c14_update_debugger_state_c14_modelodefinitivo();
  sf_mex_destroy(&c14_st);
}

static void finalize_c14_modelodefinitivo(void)
{
}

static void sf_c14_modelodefinitivo(void)
{
  uint8_T c14_previousEvent;
  real_T c14_diff;
  real_T c14_nargout = 1.0;
  real_T c14_nargin = 1.0;
  real_T c14_correc;
  real_T c14_x;
  real_T c14_b_x;
  real_T c14_y;
  real_T *c14_b_diff;
  real_T *c14_b_correc;
  c14_b_correc = (real_T *)ssGetOutputPortSignal(chartInstance.S, 1);
  c14_b_diff = (real_T *)ssGetInputPortSignal(chartInstance.S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG,13);
  _SFD_DATA_RANGE_CHECK(*c14_b_diff, 0U);
  _SFD_DATA_RANGE_CHECK(*c14_b_correc, 1U);
  c14_previousEvent = _sfEvent_;
  _sfEvent_ = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG,13);
  c14_diff = *c14_b_diff;
  sf_debug_symbol_scope_push(4U, 0U);
  sf_debug_symbol_scope_add("nargout", &c14_nargout, c14_sf_marshall);
  sf_debug_symbol_scope_add("nargin", &c14_nargin, c14_sf_marshall);
  sf_debug_symbol_scope_add("correc", &c14_correc, c14_sf_marshall);
  sf_debug_symbol_scope_add("diff", &c14_diff, c14_sf_marshall);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0,4);
  c14_x = c14_diff;
  c14_b_x = c14_x;
  c14_y = muDoubleScalarAbs(c14_b_x);
  if (CV_EML_IF(0, 0, c14_y >= 35.0)) {
    _SFD_EML_CALL(0,5);
    c14_correc = 0.0;
  } else {
    _SFD_EML_CALL(0,7);
    c14_correc = 1.0;
  }

  _SFD_EML_CALL(0,-7);
  sf_debug_symbol_scope_pop();
  *c14_b_correc = c14_correc;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG,13);
  _sfEvent_ = c14_previousEvent;
  sf_debug_check_for_state_inconsistency(_modelodefinitivoMachineNumber_,
    chartInstance.chartNumber, chartInstance.instanceNumber);
}

static void init_script_number_translation(uint32_T c14_machineNumber, uint32_T
  c14_chartNumber)
{
}

static const mxArray *c14_sf_marshall(void *c14_chartInstance, void *c14_u)
{
  const mxArray *c14_y = NULL;
  real_T c14_b_u;
  const mxArray *c14_b_y = NULL;
  c14_y = NULL;
  c14_b_u = *((real_T *)c14_u);
  c14_b_y = NULL;
  sf_mex_assign(&c14_b_y, sf_mex_create("y", &c14_b_u, 0, 0U, 0U, 0U, 0));
  sf_mex_assign(&c14_y, c14_b_y);
  return c14_y;
}

const mxArray *sf_c14_modelodefinitivo_get_eml_resolved_functions_info(void)
{
  const mxArray *c14_nameCaptureInfo = NULL;
  c14_ResolvedFunctionInfo c14_info[13];
  c14_ResolvedFunctionInfo (*c14_b_info)[13];
  const mxArray *c14_m0 = NULL;
  int32_T c14_i0;
  c14_ResolvedFunctionInfo *c14_r0;
  c14_nameCaptureInfo = NULL;
  c14_b_info = (c14_ResolvedFunctionInfo (*)[13])c14_info;
  (*c14_b_info)[0].context = "";
  (*c14_b_info)[0].name = "abs";
  (*c14_b_info)[0].dominantType = "double";
  (*c14_b_info)[0].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  (*c14_b_info)[0].fileLength = 566U;
  (*c14_b_info)[0].fileTime1 = 1221267134U;
  (*c14_b_info)[0].fileTime2 = 0U;
  (*c14_b_info)[1].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  (*c14_b_info)[1].name = "nargin";
  (*c14_b_info)[1].dominantType = "";
  (*c14_b_info)[1].resolved = "[B]nargin";
  (*c14_b_info)[1].fileLength = 0U;
  (*c14_b_info)[1].fileTime1 = 0U;
  (*c14_b_info)[1].fileTime2 = 0U;
  (*c14_b_info)[2].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  (*c14_b_info)[2].name = "gt";
  (*c14_b_info)[2].dominantType = "double";
  (*c14_b_info)[2].resolved = "[B]gt";
  (*c14_b_info)[2].fileLength = 0U;
  (*c14_b_info)[2].fileTime1 = 0U;
  (*c14_b_info)[2].fileTime2 = 0U;
  (*c14_b_info)[3].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  (*c14_b_info)[3].name = "isa";
  (*c14_b_info)[3].dominantType = "double";
  (*c14_b_info)[3].resolved = "[B]isa";
  (*c14_b_info)[3].fileLength = 0U;
  (*c14_b_info)[3].fileTime1 = 0U;
  (*c14_b_info)[3].fileTime2 = 0U;
  (*c14_b_info)[4].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  (*c14_b_info)[4].name = "ischar";
  (*c14_b_info)[4].dominantType = "double";
  (*c14_b_info)[4].resolved = "[B]ischar";
  (*c14_b_info)[4].fileLength = 0U;
  (*c14_b_info)[4].fileTime1 = 0U;
  (*c14_b_info)[4].fileTime2 = 0U;
  (*c14_b_info)[5].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  (*c14_b_info)[5].name = "islogical";
  (*c14_b_info)[5].dominantType = "double";
  (*c14_b_info)[5].resolved = "[B]islogical";
  (*c14_b_info)[5].fileLength = 0U;
  (*c14_b_info)[5].fileTime1 = 0U;
  (*c14_b_info)[5].fileTime2 = 0U;
  (*c14_b_info)[6].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  (*c14_b_info)[6].name = "size";
  (*c14_b_info)[6].dominantType = "double";
  (*c14_b_info)[6].resolved = "[B]size";
  (*c14_b_info)[6].fileLength = 0U;
  (*c14_b_info)[6].fileTime1 = 0U;
  (*c14_b_info)[6].fileTime2 = 0U;
  (*c14_b_info)[7].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  (*c14_b_info)[7].name = "class";
  (*c14_b_info)[7].dominantType = "double";
  (*c14_b_info)[7].resolved = "[B]class";
  (*c14_b_info)[7].fileLength = 0U;
  (*c14_b_info)[7].fileTime1 = 0U;
  (*c14_b_info)[7].fileTime2 = 0U;
  (*c14_b_info)[8].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  (*c14_b_info)[8].name = "zeros";
  (*c14_b_info)[8].dominantType = "double";
  (*c14_b_info)[8].resolved = "[B]zeros";
  (*c14_b_info)[8].fileLength = 0U;
  (*c14_b_info)[8].fileTime1 = 0U;
  (*c14_b_info)[8].fileTime2 = 0U;
  (*c14_b_info)[9].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  (*c14_b_info)[9].name = "eml_scalar_abs";
  (*c14_b_info)[9].dominantType = "double";
  (*c14_b_info)[9].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  (*c14_b_info)[9].fileLength = 461U;
  (*c14_b_info)[9].fileTime1 = 1203447960U;
  (*c14_b_info)[9].fileTime2 = 0U;
  (*c14_b_info)[10].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  (*c14_b_info)[10].name = "isinteger";
  (*c14_b_info)[10].dominantType = "double";
  (*c14_b_info)[10].resolved = "[B]isinteger";
  (*c14_b_info)[10].fileLength = 0U;
  (*c14_b_info)[10].fileTime1 = 0U;
  (*c14_b_info)[10].fileTime2 = 0U;
  (*c14_b_info)[11].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  (*c14_b_info)[11].name = "isreal";
  (*c14_b_info)[11].dominantType = "double";
  (*c14_b_info)[11].resolved = "[B]isreal";
  (*c14_b_info)[11].fileLength = 0U;
  (*c14_b_info)[11].fileTime1 = 0U;
  (*c14_b_info)[11].fileTime2 = 0U;
  (*c14_b_info)[12].context = "";
  (*c14_b_info)[12].name = "ge";
  (*c14_b_info)[12].dominantType = "double";
  (*c14_b_info)[12].resolved = "[B]ge";
  (*c14_b_info)[12].fileLength = 0U;
  (*c14_b_info)[12].fileTime1 = 0U;
  (*c14_b_info)[12].fileTime2 = 0U;
  sf_mex_assign(&c14_m0, sf_mex_createstruct("nameCaptureInfo", 1, 13));
  for (c14_i0 = 0; c14_i0 < 13; c14_i0 = c14_i0 + 1) {
    c14_r0 = &c14_info[c14_i0];
    sf_mex_addfield(c14_m0, sf_mex_create("nameCaptureInfo", c14_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c14_r0->context)), "context"
                    , "nameCaptureInfo", c14_i0);
    sf_mex_addfield(c14_m0, sf_mex_create("nameCaptureInfo", c14_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c14_r0->name)), "name",
                    "nameCaptureInfo", c14_i0);
    sf_mex_addfield(c14_m0, sf_mex_create("nameCaptureInfo",
      c14_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c14_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c14_i0);
    sf_mex_addfield(c14_m0, sf_mex_create("nameCaptureInfo", c14_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c14_r0->resolved)),
                    "resolved", "nameCaptureInfo", c14_i0);
    sf_mex_addfield(c14_m0, sf_mex_create("nameCaptureInfo", &c14_r0->fileLength,
      7, 0U, 0U, 0U, 0), "fileLength", "nameCaptureInfo",
                    c14_i0);
    sf_mex_addfield(c14_m0, sf_mex_create("nameCaptureInfo", &c14_r0->fileTime1,
      7, 0U, 0U, 0U, 0), "fileTime1", "nameCaptureInfo",
                    c14_i0);
    sf_mex_addfield(c14_m0, sf_mex_create("nameCaptureInfo", &c14_r0->fileTime2,
      7, 0U, 0U, 0U, 0), "fileTime2", "nameCaptureInfo",
                    c14_i0);
  }

  sf_mex_assign(&c14_nameCaptureInfo, c14_m0);
  return c14_nameCaptureInfo;
}

static const mxArray *c14_emlrt_marshallOut(uint8_T c14_u)
{
  const mxArray *c14_y = NULL;
  c14_y = NULL;
  sf_mex_assign(&c14_y, sf_mex_create("y", &c14_u, 3, 0U, 0U, 0U, 0));
  return c14_y;
}

static real_T c14_emlrt_marshallIn(const mxArray *c14_correc, char *c14_name)
{
  real_T c14_y;
  real_T c14_d0;
  sf_mex_import(c14_name, sf_mex_dup(c14_correc), &c14_d0, 1, 0, 0U, 0, 0U, 0);
  c14_y = c14_d0;
  sf_mex_destroy(&c14_correc);
  return c14_y;
}

static uint8_T c14_b_emlrt_marshallIn(const mxArray
  *c14_b_is_active_c14_modelodefinitivo, char *c14_name)
{
  uint8_T c14_y;
  uint8_T c14_u0;
  sf_mex_import(c14_name, sf_mex_dup(c14_b_is_active_c14_modelodefinitivo),
                &c14_u0, 1, 3, 0U, 0, 0U, 0);
  c14_y = c14_u0;
  sf_mex_destroy(&c14_b_is_active_c14_modelodefinitivo);
  return c14_y;
}

static void init_io_bus_offset(void)
{
}

static void init_dsm_address_info(void)
{
}

/* SFunction Glue Code */
void sf_c14_modelodefinitivo_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(2601908011U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(101100025U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(3716062629U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(3612945829U);
}

mxArray *sf_c14_modelodefinitivo_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,4,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(1299787464U);
    pr[1] = (double)(3686465853U);
    pr[2] = (double)(2690114234U);
    pr[3] = (double)(3173701506U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  return(mxAutoinheritanceInfo);
}

static mxArray *sf_get_sim_state_info_c14_modelodefinitivo(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[5],T\"correc\",},{M[8],M[0],T\"is_active_c14_modelodefinitivo\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c14_modelodefinitivo_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (_modelodefinitivoMachineNumber_,
           14,
           1,
           1,
           2,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance.chartNumber),
           &(chartInstance.instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_modelodefinitivoMachineNumber_,
            chartInstance.chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (_modelodefinitivoMachineNumber_,chartInstance.chartNumber,1);
          sf_debug_set_chart_event_thresholds(_modelodefinitivoMachineNumber_,
            chartInstance.chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"diff",0,
                              c14_sf_marshall);
          _SFD_SET_DATA_PROPS(1,2,0,1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"correc",
                              0,NULL);
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of EML Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,88);
        _SFD_CV_INIT_EML_IF(0,0,35,51,66,88);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          real_T *c14_diff;
          real_T *c14_correc;
          c14_correc = (real_T *)ssGetOutputPortSignal(chartInstance.S, 1);
          c14_diff = (real_T *)ssGetInputPortSignal(chartInstance.S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, c14_diff);
          _SFD_SET_DATA_VALUE_PTR(1U, c14_correc);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_modelodefinitivoMachineNumber_,
        chartInstance.chartNumber,chartInstance.instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c14_modelodefinitivo(void *chartInstanceVar)
{
  chart_debug_initialization(chartInstance.S,0);
  initialize_params_c14_modelodefinitivo();
  initialize_c14_modelodefinitivo();
}

static void sf_opaque_enable_c14_modelodefinitivo(void *chartInstanceVar)
{
  enable_c14_modelodefinitivo();
}

static void sf_opaque_disable_c14_modelodefinitivo(void *chartInstanceVar)
{
  disable_c14_modelodefinitivo();
}

static void sf_opaque_gateway_c14_modelodefinitivo(void *chartInstanceVar)
{
  sf_c14_modelodefinitivo();
}

static mxArray* sf_opaque_get_sim_state_c14_modelodefinitivo(void
  *chartInstanceVar)
{
  mxArray *st = (mxArray *) get_sim_state_c14_modelodefinitivo();
  return st;
}

static void sf_opaque_set_sim_state_c14_modelodefinitivo(void *chartInstanceVar,
  const mxArray *st)
{
  set_sim_state_c14_modelodefinitivo(sf_mex_dup(st));
}

static void sf_opaque_terminate_c14_modelodefinitivo(void *chartInstanceVar)
{
  if (sim_mode_is_rtw_gen(chartInstance.S) || sim_mode_is_external
      (chartInstance.S)) {
    sf_clear_rtw_identifier(chartInstance.S);
  }

  finalize_c14_modelodefinitivo();
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c14_modelodefinitivo(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c14_modelodefinitivo();
  }
}

static void mdlSetWorkWidths_c14_modelodefinitivo(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("modelodefinitivo","modelodefinitivo",14);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop("modelodefinitivo","modelodefinitivo",14,
                "RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("modelodefinitivo",
      "modelodefinitivo",14,"gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"modelodefinitivo",
        "modelodefinitivo",14,1);
      sf_mark_chart_reusable_outputs(S,"modelodefinitivo","modelodefinitivo",14,
        1);
    }

    sf_set_rtw_dwork_info(S,"modelodefinitivo","modelodefinitivo",14);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(815550030U));
  ssSetChecksum1(S,(3550302054U));
  ssSetChecksum2(S,(3499472617U));
  ssSetChecksum3(S,(2305650072U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c14_modelodefinitivo(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "modelodefinitivo", "modelodefinitivo",14);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c14_modelodefinitivo(SimStruct *S)
{
  chartInstance.chartInfo.chartInstance = NULL;
  chartInstance.chartInfo.isEMLChart = 1;
  chartInstance.chartInfo.chartInitialized = 0;
  chartInstance.chartInfo.sFunctionGateway =
    sf_opaque_gateway_c14_modelodefinitivo;
  chartInstance.chartInfo.initializeChart =
    sf_opaque_initialize_c14_modelodefinitivo;
  chartInstance.chartInfo.terminateChart =
    sf_opaque_terminate_c14_modelodefinitivo;
  chartInstance.chartInfo.enableChart = sf_opaque_enable_c14_modelodefinitivo;
  chartInstance.chartInfo.disableChart = sf_opaque_disable_c14_modelodefinitivo;
  chartInstance.chartInfo.getSimState =
    sf_opaque_get_sim_state_c14_modelodefinitivo;
  chartInstance.chartInfo.setSimState =
    sf_opaque_set_sim_state_c14_modelodefinitivo;
  chartInstance.chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c14_modelodefinitivo;
  chartInstance.chartInfo.zeroCrossings = NULL;
  chartInstance.chartInfo.outputs = NULL;
  chartInstance.chartInfo.derivatives = NULL;
  chartInstance.chartInfo.mdlRTW = mdlRTW_c14_modelodefinitivo;
  chartInstance.chartInfo.mdlStart = mdlStart_c14_modelodefinitivo;
  chartInstance.chartInfo.mdlSetWorkWidths =
    mdlSetWorkWidths_c14_modelodefinitivo;
  chartInstance.chartInfo.extModeExec = NULL;
  chartInstance.chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.storeCurrentConfiguration = NULL;
  chartInstance.S = S;
  ssSetUserData(S,(void *)(&(chartInstance.chartInfo)));/* register the chart instance with simstruct */
  if (!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info();
  }

  chart_debug_initialization(S,1);
}

void c14_modelodefinitivo_method_dispatcher(SimStruct *S, int_T method, void
  *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c14_modelodefinitivo(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c14_modelodefinitivo(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c14_modelodefinitivo(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c14_modelodefinitivo_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
