/* Include files */

#include "blascompat32.h"
#include "pruebacontrolador_sfun.h"
#include "c11_pruebacontrolador.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance.chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance.instanceNumber)
#include "pruebacontrolador_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define c11_IN_NO_ACTIVE_CHILD         (0)

/* Variable Declarations */

/* Variable Definitions */
static SFc11_pruebacontroladorInstanceStruct chartInstance;

/* Function Declarations */
static void initialize_c11_pruebacontrolador(void);
static void initialize_params_c11_pruebacontrolador(void);
static void enable_c11_pruebacontrolador(void);
static void disable_c11_pruebacontrolador(void);
static void c11_update_debugger_state_c11_pruebacontrolador(void);
static const mxArray *get_sim_state_c11_pruebacontrolador(void);
static void set_sim_state_c11_pruebacontrolador(const mxArray *c11_st);
static void finalize_c11_pruebacontrolador(void);
static void sf_c11_pruebacontrolador(void);
static void init_script_number_translation(uint32_T c11_machineNumber, uint32_T
  c11_chartNumber);
static void c11_eml_warning(void);
static const mxArray *c11_sf_marshall(void *c11_chartInstance, void *c11_u);
static const mxArray *c11_b_sf_marshall(void *c11_chartInstance, void *c11_u);
static void c11_info_helper(c11_ResolvedFunctionInfo c11_info[24]);
static const mxArray *c11_emlrt_marshallOut(uint8_T c11_u);
static void c11_emlrt_marshallIn(const mxArray *c11_friction, char *c11_name,
  real_T c11_y[6]);
static uint8_T c11_b_emlrt_marshallIn(const mxArray
  *c11_b_is_active_c11_pruebacontrolador, char *c11_name);
static void init_io_bus_offset(void);
static void init_dsm_address_info(void);

/* Function Definitions */
static void initialize_c11_pruebacontrolador(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  chartInstance.c11_is_active_c11_pruebacontrolador = 0U;
}

static void initialize_params_c11_pruebacontrolador(void)
{
}

static void enable_c11_pruebacontrolador(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void disable_c11_pruebacontrolador(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void c11_update_debugger_state_c11_pruebacontrolador(void)
{
}

static const mxArray *get_sim_state_c11_pruebacontrolador(void)
{
  const mxArray *c11_st = NULL;
  const mxArray *c11_y = NULL;
  int32_T c11_i0;
  real_T c11_u[6];
  const mxArray *c11_b_y = NULL;
  real_T (*c11_friction)[6];
  c11_friction = (real_T (*)[6])ssGetOutputPortSignal(chartInstance.S, 1);
  c11_st = NULL;
  c11_y = NULL;
  sf_mex_assign(&c11_y, sf_mex_createcellarray(2));
  for (c11_i0 = 0; c11_i0 < 6; c11_i0 = c11_i0 + 1) {
    c11_u[c11_i0] = (*c11_friction)[c11_i0];
  }

  c11_b_y = NULL;
  sf_mex_assign(&c11_b_y, sf_mex_create("y", &c11_u, 0, 0U, 1U, 0U, 1, 6));
  sf_mex_setcell(c11_y, 0, c11_b_y);
  sf_mex_setcell(c11_y, 1, c11_emlrt_marshallOut
                 (chartInstance.c11_is_active_c11_pruebacontrolador));
  sf_mex_assign(&c11_st, c11_y);
  return c11_st;
}

static void set_sim_state_c11_pruebacontrolador(const mxArray *c11_st)
{
  const mxArray *c11_u;
  real_T c11_dv0[6];
  int32_T c11_i1;
  real_T (*c11_friction)[6];
  c11_friction = (real_T (*)[6])ssGetOutputPortSignal(chartInstance.S, 1);
  chartInstance.c11_doneDoubleBufferReInit = true;
  c11_u = sf_mex_dup(c11_st);
  c11_emlrt_marshallIn(sf_mex_dup(sf_mex_getcell(c11_u, 0)), "friction", c11_dv0);
  for (c11_i1 = 0; c11_i1 < 6; c11_i1 = c11_i1 + 1) {
    (*c11_friction)[c11_i1] = c11_dv0[c11_i1];
  }

  chartInstance.c11_is_active_c11_pruebacontrolador = c11_b_emlrt_marshallIn
    (sf_mex_dup(sf_mex_getcell(c11_u, 1)),
     "is_active_c11_pruebacontrolador");
  sf_mex_destroy(&c11_u);
  c11_update_debugger_state_c11_pruebacontrolador();
  sf_mex_destroy(&c11_st);
}

static void finalize_c11_pruebacontrolador(void)
{
}

static void sf_c11_pruebacontrolador(void)
{
  int32_T c11_i2;
  int32_T c11_i3;
  int32_T c11_i4;
  int32_T c11_i5;
  uint8_T c11_previousEvent;
  int32_T c11_i6;
  real_T c11_V_tire[6];
  int32_T c11_i7;
  real_T c11_Vlong[6];
  int32_T c11_i8;
  real_T c11_alfa[6];
  real_T c11_nargout = 1.0;
  real_T c11_nargin = 3.0;
  real_T c11_i;
  real_T c11_m;
  real_T c11_n;
  real_T c11_friction[6];
  int32_T c11_i9;
  real_T c11_b_i;
  real_T c11_a;
  real_T c11_b;
  real_T c11_A;
  real_T c11_x;
  real_T c11_b_x;
  real_T c11_B;
  real_T c11_c_x;
  real_T c11_y;
  real_T c11_d_x;
  real_T c11_b_y;
  real_T c11_e_x;
  real_T c11_c_y;
  real_T c11_d_y;
  int32_T c11_i10;
  real_T (*c11_b_friction)[6];
  real_T (*c11_b_alfa)[6];
  real_T (*c11_b_Vlong)[6];
  real_T (*c11_b_V_tire)[6];
  c11_b_Vlong = (real_T (*)[6])ssGetInputPortSignal(chartInstance.S, 1);
  c11_b_friction = (real_T (*)[6])ssGetOutputPortSignal(chartInstance.S, 1);
  c11_b_V_tire = (real_T (*)[6])ssGetInputPortSignal(chartInstance.S, 0);
  c11_b_alfa = (real_T (*)[6])ssGetInputPortSignal(chartInstance.S, 2);
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG,10);
  for (c11_i2 = 0; c11_i2 < 6; c11_i2 = c11_i2 + 1) {
    _SFD_DATA_RANGE_CHECK((*c11_b_V_tire)[c11_i2], 0U);
  }

  for (c11_i3 = 0; c11_i3 < 6; c11_i3 = c11_i3 + 1) {
    _SFD_DATA_RANGE_CHECK((*c11_b_friction)[c11_i3], 1U);
  }

  for (c11_i4 = 0; c11_i4 < 6; c11_i4 = c11_i4 + 1) {
    _SFD_DATA_RANGE_CHECK((*c11_b_Vlong)[c11_i4], 2U);
  }

  for (c11_i5 = 0; c11_i5 < 6; c11_i5 = c11_i5 + 1) {
    _SFD_DATA_RANGE_CHECK((*c11_b_alfa)[c11_i5], 3U);
  }

  c11_previousEvent = _sfEvent_;
  _sfEvent_ = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG,10);
  for (c11_i6 = 0; c11_i6 < 6; c11_i6 = c11_i6 + 1) {
    c11_V_tire[c11_i6] = (*c11_b_V_tire)[c11_i6];
  }

  for (c11_i7 = 0; c11_i7 < 6; c11_i7 = c11_i7 + 1) {
    c11_Vlong[c11_i7] = (*c11_b_Vlong)[c11_i7];
  }

  for (c11_i8 = 0; c11_i8 < 6; c11_i8 = c11_i8 + 1) {
    c11_alfa[c11_i8] = (*c11_b_alfa)[c11_i8];
  }

  sf_debug_symbol_scope_push(9U, 0U);
  sf_debug_symbol_scope_add("nargout", &c11_nargout, c11_b_sf_marshall);
  sf_debug_symbol_scope_add("nargin", &c11_nargin, c11_b_sf_marshall);
  sf_debug_symbol_scope_add("i", &c11_i, c11_b_sf_marshall);
  sf_debug_symbol_scope_add("m", &c11_m, c11_b_sf_marshall);
  sf_debug_symbol_scope_add("n", &c11_n, c11_b_sf_marshall);
  sf_debug_symbol_scope_add("friction", &c11_friction, c11_sf_marshall);
  sf_debug_symbol_scope_add("alfa", &c11_alfa, c11_sf_marshall);
  sf_debug_symbol_scope_add("Vlong", &c11_Vlong, c11_sf_marshall);
  sf_debug_symbol_scope_add("V_tire", &c11_V_tire, c11_sf_marshall);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0,2);
  c11_n = 6.0;
  c11_m = 1.0;
  _SFD_EML_CALL(0,3);
  for (c11_i9 = 0; c11_i9 < 6; c11_i9 = c11_i9 + 1) {
    c11_friction[c11_i9] = 0.0;
  }

  c11_i = 1.0;
  c11_b_i = 1.0;
  while (c11_b_i <= 6.0) {
    c11_i = c11_b_i;
    CV_EML_FOR(0, 0, 1);
    _SFD_EML_CALL(0,5);
    if (CV_EML_COND(0, 0, c11_Vlong[_SFD_EML_ARRAY_BOUNDS_CHECK("Vlong",
          (int32_T)_SFD_INTEGER_CHECK("i", c11_i), 1, 6, 1, 0) - 1] == 0.0
                    )) {
      if (CV_EML_COND(0, 1, c11_V_tire[_SFD_EML_ARRAY_BOUNDS_CHECK("V_tire",
            (int32_T)_SFD_INTEGER_CHECK("i", c11_i), 1, 6, 1, 0) - 1] ==
                      0.0)) {
        CV_EML_MCDC(0, 0, true);
        CV_EML_IF(0, 0, true);
        _SFD_EML_CALL(0,6);
        c11_friction[_SFD_EML_ARRAY_BOUNDS_CHECK("friction", (int32_T)
          _SFD_INTEGER_CHECK("i", c11_i), 1, 6, 1, 0) - 1] = 0.0;
        goto label_1;
      }
    }

    CV_EML_MCDC(0, 0, false);
    CV_EML_IF(0, 0, false);
    _SFD_EML_CALL(0,8);
    c11_a = c11_alfa[_SFD_EML_ARRAY_BOUNDS_CHECK("alfa", (int32_T)
      _SFD_INTEGER_CHECK("i", c11_i), 1, 6, 1, 0) - 1];
    c11_b = c11_V_tire[_SFD_EML_ARRAY_BOUNDS_CHECK("V_tire", (int32_T)
      _SFD_INTEGER_CHECK("i", c11_i), 1, 6, 1, 0) - 1] - c11_Vlong[
      _SFD_EML_ARRAY_BOUNDS_CHECK("Vlong", (int32_T)_SFD_INTEGER_CHECK("i",
      c11_i), 1, 6, 1, 0) - 1];
    c11_A = c11_a * c11_b;
    c11_x = c11_Vlong[_SFD_EML_ARRAY_BOUNDS_CHECK("Vlong", (int32_T)
      _SFD_INTEGER_CHECK("i", c11_i), 1, 6, 1, 0) - 1];
    c11_b_x = c11_x;
    c11_B = muDoubleScalarAbs(c11_b_x);
    c11_c_x = c11_A;
    c11_y = c11_B;
    if (c11_y == 0.0) {
      c11_eml_warning();
    }

    c11_d_x = c11_c_x;
    c11_b_y = c11_y;
    c11_e_x = c11_d_x;
    c11_c_y = c11_b_y;
    c11_d_y = c11_e_x / c11_c_y;
    c11_friction[_SFD_EML_ARRAY_BOUNDS_CHECK("friction", (int32_T)
      _SFD_INTEGER_CHECK("i", c11_i), 1, 6, 1, 0) - 1] = c11_d_y;
   label_1:
    ;
    c11_b_i = c11_b_i + 1.0;
    sf_mex_listen_for_ctrl_c(chartInstance.S);
  }

  CV_EML_FOR(0, 0, 0);
  _SFD_EML_CALL(0,-8);
  sf_debug_symbol_scope_pop();
  for (c11_i10 = 0; c11_i10 < 6; c11_i10 = c11_i10 + 1) {
    (*c11_b_friction)[c11_i10] = c11_friction[c11_i10];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG,10);
  _sfEvent_ = c11_previousEvent;
  sf_debug_check_for_state_inconsistency(_pruebacontroladorMachineNumber_,
    chartInstance.chartNumber, chartInstance.instanceNumber);
}

static void init_script_number_translation(uint32_T c11_machineNumber, uint32_T
  c11_chartNumber)
{
}

static void c11_eml_warning(void)
{
  int32_T c11_i11;
  static char_T c11_cv0[15] = { 'D', 'i', 'v', 'i', 'd', 'e', ' ', 'b', 'y', ' ',
    'z', 'e', 'r', 'o', '.' };

  char_T c11_u[15];
  const mxArray *c11_y = NULL;
  int32_T c11_i12;
  static char_T c11_cv1[19] = { 'M', 'A', 'T', 'L', 'A', 'B', ':', 'd', 'i', 'v',
    'i', 'd', 'e', 'B', 'y', 'Z', 'e', 'r', 'o' };

  char_T c11_b_u[19];
  const mxArray *c11_b_y = NULL;
  for (c11_i11 = 0; c11_i11 < 15; c11_i11 = c11_i11 + 1) {
    c11_u[c11_i11] = c11_cv0[c11_i11];
  }

  c11_y = NULL;
  sf_mex_assign(&c11_y, sf_mex_create("y", &c11_u, 10, 0U, 1U, 0U, 2, 1, 15));
  for (c11_i12 = 0; c11_i12 < 19; c11_i12 = c11_i12 + 1) {
    c11_b_u[c11_i12] = c11_cv1[c11_i12];
  }

  c11_b_y = NULL;
  sf_mex_assign(&c11_b_y, sf_mex_create("y", &c11_b_u, 10, 0U, 1U, 0U, 2, 1, 19));
  sf_mex_call_debug("warning", 0U, 2U, 14, c11_b_y, 14, c11_y);
}

static const mxArray *c11_sf_marshall(void *c11_chartInstance, void *c11_u)
{
  const mxArray *c11_y = NULL;
  int32_T c11_i13;
  real_T c11_b_u[6];
  const mxArray *c11_b_y = NULL;
  c11_y = NULL;
  for (c11_i13 = 0; c11_i13 < 6; c11_i13 = c11_i13 + 1) {
    c11_b_u[c11_i13] = (*((real_T (*)[6])c11_u))[c11_i13];
  }

  c11_b_y = NULL;
  sf_mex_assign(&c11_b_y, sf_mex_create("y", &c11_b_u, 0, 0U, 1U, 0U, 1, 6));
  sf_mex_assign(&c11_y, c11_b_y);
  return c11_y;
}

static const mxArray *c11_b_sf_marshall(void *c11_chartInstance, void *c11_u)
{
  const mxArray *c11_y = NULL;
  real_T c11_b_u;
  const mxArray *c11_b_y = NULL;
  c11_y = NULL;
  c11_b_u = *((real_T *)c11_u);
  c11_b_y = NULL;
  sf_mex_assign(&c11_b_y, sf_mex_create("y", &c11_b_u, 0, 0U, 0U, 0U, 0));
  sf_mex_assign(&c11_y, c11_b_y);
  return c11_y;
}

const mxArray *sf_c11_pruebacontrolador_get_eml_resolved_functions_info(void)
{
  const mxArray *c11_nameCaptureInfo = NULL;
  c11_ResolvedFunctionInfo c11_info[24];
  const mxArray *c11_m0 = NULL;
  int32_T c11_i14;
  c11_ResolvedFunctionInfo *c11_r0;
  c11_nameCaptureInfo = NULL;
  c11_info_helper(c11_info);
  sf_mex_assign(&c11_m0, sf_mex_createstruct("nameCaptureInfo", 1, 24));
  for (c11_i14 = 0; c11_i14 < 24; c11_i14 = c11_i14 + 1) {
    c11_r0 = &c11_info[c11_i14];
    sf_mex_addfield(c11_m0, sf_mex_create("nameCaptureInfo", c11_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c11_r0->context)), "context"
                    , "nameCaptureInfo", c11_i14);
    sf_mex_addfield(c11_m0, sf_mex_create("nameCaptureInfo", c11_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c11_r0->name)), "name",
                    "nameCaptureInfo", c11_i14);
    sf_mex_addfield(c11_m0, sf_mex_create("nameCaptureInfo",
      c11_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c11_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c11_i14);
    sf_mex_addfield(c11_m0, sf_mex_create("nameCaptureInfo", c11_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c11_r0->resolved)),
                    "resolved", "nameCaptureInfo", c11_i14);
    sf_mex_addfield(c11_m0, sf_mex_create("nameCaptureInfo", &c11_r0->fileLength,
      7, 0U, 0U, 0U, 0), "fileLength", "nameCaptureInfo",
                    c11_i14);
    sf_mex_addfield(c11_m0, sf_mex_create("nameCaptureInfo", &c11_r0->fileTime1,
      7, 0U, 0U, 0U, 0), "fileTime1", "nameCaptureInfo",
                    c11_i14);
    sf_mex_addfield(c11_m0, sf_mex_create("nameCaptureInfo", &c11_r0->fileTime2,
      7, 0U, 0U, 0U, 0), "fileTime2", "nameCaptureInfo",
                    c11_i14);
  }

  sf_mex_assign(&c11_nameCaptureInfo, c11_m0);
  return c11_nameCaptureInfo;
}

static void c11_info_helper(c11_ResolvedFunctionInfo c11_info[24])
{
  c11_info[0].context = "";
  c11_info[0].name = "size";
  c11_info[0].dominantType = "double";
  c11_info[0].resolved = "[B]size";
  c11_info[0].fileLength = 0U;
  c11_info[0].fileTime1 = 0U;
  c11_info[0].fileTime2 = 0U;
  c11_info[1].context = "";
  c11_info[1].name = "zeros";
  c11_info[1].dominantType = "double";
  c11_info[1].resolved = "[B]zeros";
  c11_info[1].fileLength = 0U;
  c11_info[1].fileTime1 = 0U;
  c11_info[1].fileTime2 = 0U;
  c11_info[2].context = "";
  c11_info[2].name = "eq";
  c11_info[2].dominantType = "double";
  c11_info[2].resolved = "[B]eq";
  c11_info[2].fileLength = 0U;
  c11_info[2].fileTime1 = 0U;
  c11_info[2].fileTime2 = 0U;
  c11_info[3].context = "";
  c11_info[3].name = "minus";
  c11_info[3].dominantType = "double";
  c11_info[3].resolved = "[B]minus";
  c11_info[3].fileLength = 0U;
  c11_info[3].fileTime1 = 0U;
  c11_info[3].fileTime2 = 0U;
  c11_info[4].context = "";
  c11_info[4].name = "mtimes";
  c11_info[4].dominantType = "double";
  c11_info[4].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c11_info[4].fileLength = 2408U;
  c11_info[4].fileTime1 = 1227613402U;
  c11_info[4].fileTime2 = 0U;
  c11_info[5].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c11_info[5].name = "nargin";
  c11_info[5].dominantType = "";
  c11_info[5].resolved = "[B]nargin";
  c11_info[5].fileLength = 0U;
  c11_info[5].fileTime1 = 0U;
  c11_info[5].fileTime2 = 0U;
  c11_info[6].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c11_info[6].name = "gt";
  c11_info[6].dominantType = "double";
  c11_info[6].resolved = "[B]gt";
  c11_info[6].fileLength = 0U;
  c11_info[6].fileTime1 = 0U;
  c11_info[6].fileTime2 = 0U;
  c11_info[7].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c11_info[7].name = "isa";
  c11_info[7].dominantType = "double";
  c11_info[7].resolved = "[B]isa";
  c11_info[7].fileLength = 0U;
  c11_info[7].fileTime1 = 0U;
  c11_info[7].fileTime2 = 0U;
  c11_info[8].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c11_info[8].name = "isinteger";
  c11_info[8].dominantType = "double";
  c11_info[8].resolved = "[B]isinteger";
  c11_info[8].fileLength = 0U;
  c11_info[8].fileTime1 = 0U;
  c11_info[8].fileTime2 = 0U;
  c11_info[9].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c11_info[9].name = "isscalar";
  c11_info[9].dominantType = "double";
  c11_info[9].resolved = "[B]isscalar";
  c11_info[9].fileLength = 0U;
  c11_info[9].fileTime1 = 0U;
  c11_info[9].fileTime2 = 0U;
  c11_info[10].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c11_info[10].name = "strcmp";
  c11_info[10].dominantType = "char";
  c11_info[10].resolved = "[B]strcmp";
  c11_info[10].fileLength = 0U;
  c11_info[10].fileTime1 = 0U;
  c11_info[10].fileTime2 = 0U;
  c11_info[11].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c11_info[11].name = "class";
  c11_info[11].dominantType = "double";
  c11_info[11].resolved = "[B]class";
  c11_info[11].fileLength = 0U;
  c11_info[11].fileTime1 = 0U;
  c11_info[11].fileTime2 = 0U;
  c11_info[12].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c11_info[12].name = "not";
  c11_info[12].dominantType = "logical";
  c11_info[12].resolved = "[B]not";
  c11_info[12].fileLength = 0U;
  c11_info[12].fileTime1 = 0U;
  c11_info[12].fileTime2 = 0U;
  c11_info[13].context = "";
  c11_info[13].name = "abs";
  c11_info[13].dominantType = "double";
  c11_info[13].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c11_info[13].fileLength = 566U;
  c11_info[13].fileTime1 = 1221267134U;
  c11_info[13].fileTime2 = 0U;
  c11_info[14].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c11_info[14].name = "ischar";
  c11_info[14].dominantType = "double";
  c11_info[14].resolved = "[B]ischar";
  c11_info[14].fileLength = 0U;
  c11_info[14].fileTime1 = 0U;
  c11_info[14].fileTime2 = 0U;
  c11_info[15].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c11_info[15].name = "islogical";
  c11_info[15].dominantType = "double";
  c11_info[15].resolved = "[B]islogical";
  c11_info[15].fileLength = 0U;
  c11_info[15].fileTime1 = 0U;
  c11_info[15].fileTime2 = 0U;
  c11_info[16].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c11_info[16].name = "eml_scalar_abs";
  c11_info[16].dominantType = "double";
  c11_info[16].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  c11_info[16].fileLength = 461U;
  c11_info[16].fileTime1 = 1203447960U;
  c11_info[16].fileTime2 = 0U;
  c11_info[17].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  c11_info[17].name = "isreal";
  c11_info[17].dominantType = "double";
  c11_info[17].resolved = "[B]isreal";
  c11_info[17].fileLength = 0U;
  c11_info[17].fileTime1 = 0U;
  c11_info[17].fileTime2 = 0U;
  c11_info[18].context = "";
  c11_info[18].name = "mrdivide";
  c11_info[18].dominantType = "double";
  c11_info[18].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.m";
  c11_info[18].fileLength = 771U;
  c11_info[18].fileTime1 = 1219752936U;
  c11_info[18].fileTime2 = 0U;
  c11_info[19].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.m";
  c11_info[19].name = "ge";
  c11_info[19].dominantType = "double";
  c11_info[19].resolved = "[B]ge";
  c11_info[19].fileLength = 0U;
  c11_info[19].fileTime1 = 0U;
  c11_info[19].fileTime2 = 0U;
  c11_info[20].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.m";
  c11_info[20].name = "rdivide";
  c11_info[20].dominantType = "double";
  c11_info[20].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c11_info[20].fileLength = 620U;
  c11_info[20].fileTime1 = 1213926766U;
  c11_info[20].fileTime2 = 0U;
  c11_info[21].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c11_info[21].name = "isempty";
  c11_info[21].dominantType = "double";
  c11_info[21].resolved = "[B]isempty";
  c11_info[21].fileLength = 0U;
  c11_info[21].fileTime1 = 0U;
  c11_info[21].fileTime2 = 0U;
  c11_info[22].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c11_info[22].name = "eml_warning";
  c11_info[22].dominantType = "char";
  c11_info[22].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_warning.m";
  c11_info[22].fileLength = 274U;
  c11_info[22].fileTime1 = 1227613396U;
  c11_info[22].fileTime2 = 0U;
  c11_info[23].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c11_info[23].name = "eml_div";
  c11_info[23].dominantType = "double";
  c11_info[23].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  c11_info[23].fileLength = 4269U;
  c11_info[23].fileTime1 = 1227613386U;
  c11_info[23].fileTime2 = 0U;
}

static const mxArray *c11_emlrt_marshallOut(uint8_T c11_u)
{
  const mxArray *c11_y = NULL;
  c11_y = NULL;
  sf_mex_assign(&c11_y, sf_mex_create("y", &c11_u, 3, 0U, 0U, 0U, 0));
  return c11_y;
}

static void c11_emlrt_marshallIn(const mxArray *c11_friction, char *c11_name,
  real_T c11_y[6])
{
  real_T c11_dv1[6];
  int32_T c11_i15;
  sf_mex_import(c11_name, sf_mex_dup(c11_friction), &c11_dv1, 1, 0, 0U, 1, 0U, 1,
                6);
  for (c11_i15 = 0; c11_i15 < 6; c11_i15 = c11_i15 + 1) {
    c11_y[c11_i15] = c11_dv1[c11_i15];
  }

  sf_mex_destroy(&c11_friction);
}

static uint8_T c11_b_emlrt_marshallIn(const mxArray
  *c11_b_is_active_c11_pruebacontrolador, char *c11_name)
{
  uint8_T c11_y;
  uint8_T c11_u0;
  sf_mex_import(c11_name, sf_mex_dup(c11_b_is_active_c11_pruebacontrolador),
                &c11_u0, 1, 3, 0U, 0, 0U, 0);
  c11_y = c11_u0;
  sf_mex_destroy(&c11_b_is_active_c11_pruebacontrolador);
  return c11_y;
}

static void init_io_bus_offset(void)
{
}

static void init_dsm_address_info(void)
{
}

/* SFunction Glue Code */
void sf_c11_pruebacontrolador_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(313154001U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(2243631492U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(2805492977U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(3450942416U);
}

mxArray *sf_c11_pruebacontrolador_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,4,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(3356053377U);
    pr[1] = (double)(559709466U);
    pr[2] = (double)(634552602U);
    pr[3] = (double)(2624604767U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,3,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  return(mxAutoinheritanceInfo);
}

static mxArray *sf_get_sim_state_info_c11_pruebacontrolador(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[5],T\"friction\",},{M[8],M[0],T\"is_active_c11_pruebacontrolador\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c11_pruebacontrolador_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (_pruebacontroladorMachineNumber_,
           11,
           1,
           1,
           4,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance.chartNumber),
           &(chartInstance.instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_pruebacontroladorMachineNumber_,
            chartInstance.chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (_pruebacontroladorMachineNumber_,chartInstance.chartNumber,1);
          sf_debug_set_chart_event_thresholds(_pruebacontroladorMachineNumber_,
            chartInstance.chartNumber,
            0,
            0,
            0);

          {
            unsigned int dimVector[1];
            dimVector[0]= 6;
            _SFD_SET_DATA_PROPS(0,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"V_tire",0,c11_sf_marshall);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 6;
            _SFD_SET_DATA_PROPS(1,2,0,1,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"friction",0,NULL);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 6;
            _SFD_SET_DATA_PROPS(2,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"Vlong",0,NULL);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 6;
            _SFD_SET_DATA_PROPS(3,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"alfa",0,NULL);
          }

          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of EML Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,0,1,0,2,1);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,254);
        _SFD_CV_INIT_EML_IF(0,0,108,144,170,250);
        _SFD_CV_INIT_EML_FOR(0,0,92,104,254);

        {
          static int condStart[] = { 112, 129 };

          static int condEnd[] = { 125, 143 };

          static int pfixExpr[] = { 0, 1, -3 };

          _SFD_CV_INIT_EML_MCDC(0,0,111,144,2,0,&(condStart[0]),&(condEnd[0]),3,
                                &(pfixExpr[0]));
        }

        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          real_T (*c11_V_tire)[6];
          real_T (*c11_friction)[6];
          real_T (*c11_Vlong)[6];
          real_T (*c11_alfa)[6];
          c11_Vlong = (real_T (*)[6])ssGetInputPortSignal(chartInstance.S, 1);
          c11_friction = (real_T (*)[6])ssGetOutputPortSignal(chartInstance.S, 1);
          c11_V_tire = (real_T (*)[6])ssGetInputPortSignal(chartInstance.S, 0);
          c11_alfa = (real_T (*)[6])ssGetInputPortSignal(chartInstance.S, 2);
          _SFD_SET_DATA_VALUE_PTR(0U, c11_V_tire);
          _SFD_SET_DATA_VALUE_PTR(1U, c11_friction);
          _SFD_SET_DATA_VALUE_PTR(2U, c11_Vlong);
          _SFD_SET_DATA_VALUE_PTR(3U, c11_alfa);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration
        (_pruebacontroladorMachineNumber_,chartInstance.chartNumber,
         chartInstance.instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c11_pruebacontrolador(void *chartInstanceVar)
{
  chart_debug_initialization(chartInstance.S,0);
  initialize_params_c11_pruebacontrolador();
  initialize_c11_pruebacontrolador();
}

static void sf_opaque_enable_c11_pruebacontrolador(void *chartInstanceVar)
{
  enable_c11_pruebacontrolador();
}

static void sf_opaque_disable_c11_pruebacontrolador(void *chartInstanceVar)
{
  disable_c11_pruebacontrolador();
}

static void sf_opaque_gateway_c11_pruebacontrolador(void *chartInstanceVar)
{
  sf_c11_pruebacontrolador();
}

static mxArray* sf_opaque_get_sim_state_c11_pruebacontrolador(void
  *chartInstanceVar)
{
  mxArray *st = (mxArray *) get_sim_state_c11_pruebacontrolador();
  return st;
}

static void sf_opaque_set_sim_state_c11_pruebacontrolador(void *chartInstanceVar,
  const mxArray *st)
{
  set_sim_state_c11_pruebacontrolador(sf_mex_dup(st));
}

static void sf_opaque_terminate_c11_pruebacontrolador(void *chartInstanceVar)
{
  if (sim_mode_is_rtw_gen(chartInstance.S) || sim_mode_is_external
      (chartInstance.S)) {
    sf_clear_rtw_identifier(chartInstance.S);
  }

  finalize_c11_pruebacontrolador();
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c11_pruebacontrolador(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c11_pruebacontrolador();
  }
}

static void mdlSetWorkWidths_c11_pruebacontrolador(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("pruebacontrolador","pruebacontrolador",11);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop("pruebacontrolador","pruebacontrolador",
                11,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("pruebacontrolador",
      "pruebacontrolador",11,"gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"pruebacontrolador",
        "pruebacontrolador",11,3);
      sf_mark_chart_reusable_outputs(S,"pruebacontrolador","pruebacontrolador",
        11,1);
    }

    sf_set_rtw_dwork_info(S,"pruebacontrolador","pruebacontrolador",11);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(965195864U));
  ssSetChecksum1(S,(573909671U));
  ssSetChecksum2(S,(3021692359U));
  ssSetChecksum3(S,(2800725811U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c11_pruebacontrolador(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "pruebacontrolador", "pruebacontrolador",11);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c11_pruebacontrolador(SimStruct *S)
{
  chartInstance.chartInfo.chartInstance = NULL;
  chartInstance.chartInfo.isEMLChart = 1;
  chartInstance.chartInfo.chartInitialized = 0;
  chartInstance.chartInfo.sFunctionGateway =
    sf_opaque_gateway_c11_pruebacontrolador;
  chartInstance.chartInfo.initializeChart =
    sf_opaque_initialize_c11_pruebacontrolador;
  chartInstance.chartInfo.terminateChart =
    sf_opaque_terminate_c11_pruebacontrolador;
  chartInstance.chartInfo.enableChart = sf_opaque_enable_c11_pruebacontrolador;
  chartInstance.chartInfo.disableChart = sf_opaque_disable_c11_pruebacontrolador;
  chartInstance.chartInfo.getSimState =
    sf_opaque_get_sim_state_c11_pruebacontrolador;
  chartInstance.chartInfo.setSimState =
    sf_opaque_set_sim_state_c11_pruebacontrolador;
  chartInstance.chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c11_pruebacontrolador;
  chartInstance.chartInfo.zeroCrossings = NULL;
  chartInstance.chartInfo.outputs = NULL;
  chartInstance.chartInfo.derivatives = NULL;
  chartInstance.chartInfo.mdlRTW = mdlRTW_c11_pruebacontrolador;
  chartInstance.chartInfo.mdlStart = mdlStart_c11_pruebacontrolador;
  chartInstance.chartInfo.mdlSetWorkWidths =
    mdlSetWorkWidths_c11_pruebacontrolador;
  chartInstance.chartInfo.extModeExec = NULL;
  chartInstance.chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.storeCurrentConfiguration = NULL;
  chartInstance.S = S;
  ssSetUserData(S,(void *)(&(chartInstance.chartInfo)));/* register the chart instance with simstruct */
  if (!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info();
  }

  chart_debug_initialization(S,1);
}

void c11_pruebacontrolador_method_dispatcher(SimStruct *S, int_T method, void
  *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c11_pruebacontrolador(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c11_pruebacontrolador(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c11_pruebacontrolador(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c11_pruebacontrolador_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
