%  Observability verification and system discretization

%%%Jess Garca Estbanez%%%
%%% GPS/IMU integration for a snake robot with active wheels%%%


% GPS/IMU ideal case
clc
clear all

A=[0 0 1 0 0 0;
   0 0 0 1 0 0;
   0 0 0 0 1 0;
   0 0 0 0 0 1;
   0 0 0 0 0 0;
   0 0 0 0 0 0];
B=[0;
   0;
   0;
   0;
   0;
   0];
C=[1 0 0 0 0 0;
   0 1 0 0 0 0;
   0 0 0 0 1 0;
   0 0 0 0 0 1];
D=[0;
   0;
   0;
   0];
sys=ss(A,B,C,D);
sysd=c2d(sys,1/120);
ob_rank=rank(obsv(sysd));
display('the system is observable')


