clc
clear all
format long

%Initial position
Xini=[-1.75 -1.4 -1.05 -0.7 -0.35 0]';
Yini=[0 0 0 0 0 0]';
%Initial velocity
Xini_doc=[0 0 0 0 0 0]';
Yini_doc=[0 0 0 0 0 0]';
%Initial aceleration
Xini_doc_doc=[0 0 0 0 0 0]';
Yini_doc_doc=[0 0 0 0 0 0]';

%Teta initial
Teta_ini=[0 0 0 0 0 0]';
Xcom=-1.75/2;
Ycom=0;

%Mass matrix     [Kg]
mass=1.2*ones(1,6);
M=diag(mass);
m_link=1.2;
m=1.2*6;
%From head to axle lenght matrix   [m]
n=0.15*ones(1,6);   
N=diag(n);
          
%From axle to the back side lenght matrix   [m]
l=0.2*ones(1,6);
L=diag(l);
%Wheel radioum  [m]
Lwide=0.10;
Rwheel=0.05;


%Moment of inertia matrix   [Kg.m^2]
jx=2.18e-3*ones(1,6);
J=diag(jx);

%Matrix A

A=[1  0  0  0  0  0;
   0  1  0  0  0  0;
   0  0  1  0  0  0
   0  0  0  1  0  0
   0  0  0  0  1  0];

%Matrix B


B=[0  1  0  0  0  0;
   0  0  1  0  0  0;
   0  0  0  1  0  0;
   0  0  0  0  1  0;
   0  0  0  0  0  1];



%Matrix D


D=[1  -1   0   0   0   0;
   0   1  -1   0   0   0;
   0   0   1  -1   0   0;
   0   0   0   1  -1   0;
   0   0   0   0   1  -1];


%Matrix C fiction coefficient


Mu=0.5;    %coeficient of firction
cx=Mu*ones(1,6);
C=diag(cx);
g=9.8;      %gravity acceleration
alfa=g*Mu*m_link/2;
%Distance matrix from the body to the wheel

l_axle=0.08*ones(1,6);
Laxle=diag(l_axle);

%Matrix N

Na=inv(M)*D'*(inv(D*inv(M)*D'))*(A*L+B*N);

%Matrix H

H=(A*L+B*N)'*inv(D*inv(M)*D')*(A*L+B*N);


K=(A*L+B*N)'*inv(D*inv(M)*D')*D*inv(M);
%Matrix E

E=[1 1 1 1 1 1 0 0 0 0 0 0;
   0 0 0 0 0 0 1 1 1 1 1 1]'; 
%Controller
Kp_=0.05;
Kd_=0.05;

   