/* Include files */

#include "blascompat32.h"
#include "het_coeff_model_sfun.h"
#include "c15_het_coeff_model.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance.chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance.instanceNumber)
#include "het_coeff_model_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define c15_IN_NO_ACTIVE_CHILD         (0)

/* Variable Declarations */

/* Variable Definitions */
static SFc15_het_coeff_modelInstanceStruct chartInstance;

/* Function Declarations */
static void initialize_c15_het_coeff_model(void);
static void initialize_params_c15_het_coeff_model(void);
static void enable_c15_het_coeff_model(void);
static void disable_c15_het_coeff_model(void);
static void c15_update_debugger_state_c15_het_coeff_model(void);
static const mxArray *get_sim_state_c15_het_coeff_model(void);
static void set_sim_state_c15_het_coeff_model(const mxArray *c15_st);
static void finalize_c15_het_coeff_model(void);
static void sf_c15_het_coeff_model(void);
static void init_script_number_translation(uint32_T c15_machineNumber, uint32_T
  c15_chartNumber);
static const mxArray *c15_sf_marshall(void *c15_chartInstance, void *c15_u);
static const mxArray *c15_b_sf_marshall(void *c15_chartInstance, void *c15_u);
static void c15_info_helper(c15_ResolvedFunctionInfo c15_info[29]);
static const mxArray *c15_emlrt_marshallOut(uint8_T c15_u);
static void c15_emlrt_marshallIn(const mxArray *c15_fn, char *c15_name, real_T
  c15_y[6]);
static uint8_T c15_b_emlrt_marshallIn(const mxArray
  *c15_b_is_active_c15_het_coeff_model, char *c15_name);
static void init_io_bus_offset(void);
static void init_dsm_address_info(void);

/* Function Definitions */
static void initialize_c15_het_coeff_model(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  chartInstance.c15_is_active_c15_het_coeff_model = 0U;
}

static void initialize_params_c15_het_coeff_model(void)
{
}

static void enable_c15_het_coeff_model(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void disable_c15_het_coeff_model(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void c15_update_debugger_state_c15_het_coeff_model(void)
{
}

static const mxArray *get_sim_state_c15_het_coeff_model(void)
{
  const mxArray *c15_st = NULL;
  const mxArray *c15_y = NULL;
  int32_T c15_i0;
  real_T c15_u[6];
  const mxArray *c15_b_y = NULL;
  real_T (*c15_fn)[6];
  c15_fn = (real_T (*)[6])ssGetOutputPortSignal(chartInstance.S, 1);
  c15_st = NULL;
  c15_y = NULL;
  sf_mex_assign(&c15_y, sf_mex_createcellarray(2));
  for (c15_i0 = 0; c15_i0 < 6; c15_i0 = c15_i0 + 1) {
    c15_u[c15_i0] = (*c15_fn)[c15_i0];
  }

  c15_b_y = NULL;
  sf_mex_assign(&c15_b_y, sf_mex_create("y", &c15_u, 0, 0U, 1U, 0U, 1, 6));
  sf_mex_setcell(c15_y, 0, c15_b_y);
  sf_mex_setcell(c15_y, 1, c15_emlrt_marshallOut
                 (chartInstance.c15_is_active_c15_het_coeff_model));
  sf_mex_assign(&c15_st, c15_y);
  return c15_st;
}

static void set_sim_state_c15_het_coeff_model(const mxArray *c15_st)
{
  const mxArray *c15_u;
  real_T c15_dv0[6];
  int32_T c15_i1;
  real_T (*c15_fn)[6];
  c15_fn = (real_T (*)[6])ssGetOutputPortSignal(chartInstance.S, 1);
  chartInstance.c15_doneDoubleBufferReInit = true;
  c15_u = sf_mex_dup(c15_st);
  c15_emlrt_marshallIn(sf_mex_dup(sf_mex_getcell(c15_u, 0)), "fn", c15_dv0);
  for (c15_i1 = 0; c15_i1 < 6; c15_i1 = c15_i1 + 1) {
    (*c15_fn)[c15_i1] = c15_dv0[c15_i1];
  }

  chartInstance.c15_is_active_c15_het_coeff_model = c15_b_emlrt_marshallIn
    (sf_mex_dup(sf_mex_getcell(c15_u, 1)),
     "is_active_c15_het_coeff_model");
  sf_mex_destroy(&c15_u);
  c15_update_debugger_state_c15_het_coeff_model();
  sf_mex_destroy(&c15_st);
}

static void finalize_c15_het_coeff_model(void)
{
}

static void sf_c15_het_coeff_model(void)
{
  int32_T c15_i2;
  int32_T c15_i3;
  uint8_T c15_previousEvent;
  int32_T c15_i4;
  real_T c15_Vn[6];
  real_T c15_alfa;
  real_T c15_nargout = 1.0;
  real_T c15_nargin = 2.0;
  real_T c15_fn[6];
  real_T c15_a;
  int32_T c15_i5;
  real_T c15_x[6];
  int32_T c15_i6;
  real_T c15_b[6];
  real_T c15_k;
  real_T c15_b_k;
  real_T c15_b_x;
  real_T c15_c_x;
  real_T c15_d_x;
  boolean_T c15_b_b;
  int32_T c15_i7;
  int32_T c15_i8;
  real_T *c15_b_alfa;
  real_T (*c15_b_fn)[6];
  real_T (*c15_b_Vn)[6];
  c15_b_alfa = (real_T *)ssGetInputPortSignal(chartInstance.S, 1);
  c15_b_fn = (real_T (*)[6])ssGetOutputPortSignal(chartInstance.S, 1);
  c15_b_Vn = (real_T (*)[6])ssGetInputPortSignal(chartInstance.S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG,11);
  for (c15_i2 = 0; c15_i2 < 6; c15_i2 = c15_i2 + 1) {
    _SFD_DATA_RANGE_CHECK((*c15_b_Vn)[c15_i2], 0U);
  }

  for (c15_i3 = 0; c15_i3 < 6; c15_i3 = c15_i3 + 1) {
    _SFD_DATA_RANGE_CHECK((*c15_b_fn)[c15_i3], 1U);
  }

  _SFD_DATA_RANGE_CHECK(*c15_b_alfa, 2U);
  c15_previousEvent = _sfEvent_;
  _sfEvent_ = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG,11);
  for (c15_i4 = 0; c15_i4 < 6; c15_i4 = c15_i4 + 1) {
    c15_Vn[c15_i4] = (*c15_b_Vn)[c15_i4];
  }

  c15_alfa = *c15_b_alfa;
  sf_debug_symbol_scope_push(5U, 0U);
  sf_debug_symbol_scope_add("nargout", &c15_nargout, c15_b_sf_marshall);
  sf_debug_symbol_scope_add("nargin", &c15_nargin, c15_b_sf_marshall);
  sf_debug_symbol_scope_add("fn", &c15_fn, c15_sf_marshall);
  sf_debug_symbol_scope_add("alfa", &c15_alfa, c15_b_sf_marshall);
  sf_debug_symbol_scope_add("Vn", &c15_Vn, c15_sf_marshall);
  CV_EML_FCN(0, 0);

  /*  This block supports an embeddable subset of the MATLAB language. */
  /*  See the help menu for details.  */
  _SFD_EML_CALL(0,5);
  c15_a = -c15_alfa;
  for (c15_i5 = 0; c15_i5 < 6; c15_i5 = c15_i5 + 1) {
    c15_x[c15_i5] = c15_Vn[c15_i5];
  }

  for (c15_i6 = 0; c15_i6 < 6; c15_i6 = c15_i6 + 1) {
    c15_b[c15_i6] = c15_x[c15_i6];
  }

  for (c15_k = 1.0; c15_k <= 6.0; c15_k = c15_k + 1.0) {
    c15_b_k = c15_k;
    c15_b_x = c15_b[_SFD_EML_ARRAY_BOUNDS_CHECK("x", (int32_T)_SFD_INTEGER_CHECK
      ("k", c15_b_k), 1, 6, 1, 0) - 1];
    c15_c_x = c15_b_x;
    c15_d_x = c15_c_x;
    c15_b_b = rtIsNaN(c15_d_x);
    if (c15_b_b) {
      c15_c_x = rtNaN;
    } else if (c15_c_x > 0.0) {
      c15_c_x = 1.0;
    } else if (c15_c_x < 0.0) {
      c15_c_x = -1.0;
    } else {
      c15_c_x = 0.0;
    }

    c15_b[_SFD_EML_ARRAY_BOUNDS_CHECK("x", (int32_T)_SFD_INTEGER_CHECK("k",
      c15_b_k), 1, 6, 1, 0) - 1] = c15_c_x;
  }

  for (c15_i7 = 0; c15_i7 < 6; c15_i7 = c15_i7 + 1) {
    c15_fn[c15_i7] = c15_a * c15_b[c15_i7];
  }

  _SFD_EML_CALL(0,-5);
  sf_debug_symbol_scope_pop();
  for (c15_i8 = 0; c15_i8 < 6; c15_i8 = c15_i8 + 1) {
    (*c15_b_fn)[c15_i8] = c15_fn[c15_i8];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG,11);
  _sfEvent_ = c15_previousEvent;
  sf_debug_check_for_state_inconsistency(_het_coeff_modelMachineNumber_,
    chartInstance.chartNumber, chartInstance.instanceNumber);
}

static void init_script_number_translation(uint32_T c15_machineNumber, uint32_T
  c15_chartNumber)
{
}

static const mxArray *c15_sf_marshall(void *c15_chartInstance, void *c15_u)
{
  const mxArray *c15_y = NULL;
  int32_T c15_i9;
  real_T c15_b_u[6];
  const mxArray *c15_b_y = NULL;
  c15_y = NULL;
  for (c15_i9 = 0; c15_i9 < 6; c15_i9 = c15_i9 + 1) {
    c15_b_u[c15_i9] = (*((real_T (*)[6])c15_u))[c15_i9];
  }

  c15_b_y = NULL;
  sf_mex_assign(&c15_b_y, sf_mex_create("y", &c15_b_u, 0, 0U, 1U, 0U, 1, 6));
  sf_mex_assign(&c15_y, c15_b_y);
  return c15_y;
}

static const mxArray *c15_b_sf_marshall(void *c15_chartInstance, void *c15_u)
{
  const mxArray *c15_y = NULL;
  real_T c15_b_u;
  const mxArray *c15_b_y = NULL;
  c15_y = NULL;
  c15_b_u = *((real_T *)c15_u);
  c15_b_y = NULL;
  sf_mex_assign(&c15_b_y, sf_mex_create("y", &c15_b_u, 0, 0U, 0U, 0U, 0));
  sf_mex_assign(&c15_y, c15_b_y);
  return c15_y;
}

const mxArray *sf_c15_het_coeff_model_get_eml_resolved_functions_info(void)
{
  const mxArray *c15_nameCaptureInfo = NULL;
  c15_ResolvedFunctionInfo c15_info[29];
  const mxArray *c15_m0 = NULL;
  int32_T c15_i10;
  c15_ResolvedFunctionInfo *c15_r0;
  c15_nameCaptureInfo = NULL;
  c15_info_helper(c15_info);
  sf_mex_assign(&c15_m0, sf_mex_createstruct("nameCaptureInfo", 1, 29));
  for (c15_i10 = 0; c15_i10 < 29; c15_i10 = c15_i10 + 1) {
    c15_r0 = &c15_info[c15_i10];
    sf_mex_addfield(c15_m0, sf_mex_create("nameCaptureInfo", c15_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c15_r0->context)), "context"
                    , "nameCaptureInfo", c15_i10);
    sf_mex_addfield(c15_m0, sf_mex_create("nameCaptureInfo", c15_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c15_r0->name)), "name",
                    "nameCaptureInfo", c15_i10);
    sf_mex_addfield(c15_m0, sf_mex_create("nameCaptureInfo",
      c15_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c15_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c15_i10);
    sf_mex_addfield(c15_m0, sf_mex_create("nameCaptureInfo", c15_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c15_r0->resolved)),
                    "resolved", "nameCaptureInfo", c15_i10);
    sf_mex_addfield(c15_m0, sf_mex_create("nameCaptureInfo", &c15_r0->fileLength,
      7, 0U, 0U, 0U, 0), "fileLength", "nameCaptureInfo",
                    c15_i10);
    sf_mex_addfield(c15_m0, sf_mex_create("nameCaptureInfo", &c15_r0->fileTime1,
      7, 0U, 0U, 0U, 0), "fileTime1", "nameCaptureInfo",
                    c15_i10);
    sf_mex_addfield(c15_m0, sf_mex_create("nameCaptureInfo", &c15_r0->fileTime2,
      7, 0U, 0U, 0U, 0), "fileTime2", "nameCaptureInfo",
                    c15_i10);
  }

  sf_mex_assign(&c15_nameCaptureInfo, c15_m0);
  return c15_nameCaptureInfo;
}

static void c15_info_helper(c15_ResolvedFunctionInfo c15_info[29])
{
  c15_info[0].context = "";
  c15_info[0].name = "uminus";
  c15_info[0].dominantType = "double";
  c15_info[0].resolved = "[B]uminus";
  c15_info[0].fileLength = 0U;
  c15_info[0].fileTime1 = 0U;
  c15_info[0].fileTime2 = 0U;
  c15_info[1].context = "";
  c15_info[1].name = "sign";
  c15_info[1].dominantType = "double";
  c15_info[1].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/sign.m";
  c15_info[1].fileLength = 408U;
  c15_info[1].fileTime1 = 1203448042U;
  c15_info[1].fileTime2 = 0U;
  c15_info[2].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/sign.m";
  c15_info[2].name = "nargin";
  c15_info[2].dominantType = "";
  c15_info[2].resolved = "[B]nargin";
  c15_info[2].fileLength = 0U;
  c15_info[2].fileTime1 = 0U;
  c15_info[2].fileTime2 = 0U;
  c15_info[3].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/sign.m";
  c15_info[3].name = "eq";
  c15_info[3].dominantType = "double";
  c15_info[3].resolved = "[B]eq";
  c15_info[3].fileLength = 0U;
  c15_info[3].fileTime1 = 0U;
  c15_info[3].fileTime2 = 0U;
  c15_info[4].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/sign.m";
  c15_info[4].name = "isa";
  c15_info[4].dominantType = "double";
  c15_info[4].resolved = "[B]isa";
  c15_info[4].fileLength = 0U;
  c15_info[4].fileTime1 = 0U;
  c15_info[4].fileTime2 = 0U;
  c15_info[5].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/sign.m";
  c15_info[5].name = "isreal";
  c15_info[5].dominantType = "double";
  c15_info[5].resolved = "[B]isreal";
  c15_info[5].fileLength = 0U;
  c15_info[5].fileTime1 = 0U;
  c15_info[5].fileTime2 = 0U;
  c15_info[6].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/sign.m";
  c15_info[6].name = "eml_scalar_sign";
  c15_info[6].dominantType = "double";
  c15_info[6].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sign.m";
  c15_info[6].fileLength = 543U;
  c15_info[6].fileTime1 = 1203448012U;
  c15_info[6].fileTime2 = 0U;
  c15_info[7].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sign.m";
  c15_info[7].name = "isnan";
  c15_info[7].dominantType = "double";
  c15_info[7].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/isnan.m";
  c15_info[7].fileLength = 506U;
  c15_info[7].fileTime1 = 1227613388U;
  c15_info[7].fileTime2 = 0U;
  c15_info[8].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/isnan.m";
  c15_info[8].name = "gt";
  c15_info[8].dominantType = "double";
  c15_info[8].resolved = "[B]gt";
  c15_info[8].fileLength = 0U;
  c15_info[8].fileTime1 = 0U;
  c15_info[8].fileTime2 = 0U;
  c15_info[9].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sign.m";
  c15_info[9].name = "class";
  c15_info[9].dominantType = "double";
  c15_info[9].resolved = "[B]class";
  c15_info[9].fileLength = 0U;
  c15_info[9].fileTime1 = 0U;
  c15_info[9].fileTime2 = 0U;
  c15_info[10].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sign.m";
  c15_info[10].name = "eml_guarded_nan";
  c15_info[10].dominantType = "char";
  c15_info[10].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_guarded_nan.m";
  c15_info[10].fileLength = 485U;
  c15_info[10].fileTime1 = 1192466780U;
  c15_info[10].fileTime2 = 0U;
  c15_info[11].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_guarded_nan.m";
  c15_info[11].name = "eml_is_float_class";
  c15_info[11].dominantType = "char";
  c15_info[11].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_is_float_class.m";
  c15_info[11].fileLength = 226U;
  c15_info[11].fileTime1 = 1197850442U;
  c15_info[11].fileTime2 = 0U;
  c15_info[12].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_is_float_class.m";
  c15_info[12].name = "ischar";
  c15_info[12].dominantType = "char";
  c15_info[12].resolved = "[B]ischar";
  c15_info[12].fileLength = 0U;
  c15_info[12].fileTime1 = 0U;
  c15_info[12].fileTime2 = 0U;
  c15_info[13].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_is_float_class.m";
  c15_info[13].name = "strcmp";
  c15_info[13].dominantType = "char";
  c15_info[13].resolved = "[B]strcmp";
  c15_info[13].fileLength = 0U;
  c15_info[13].fileTime1 = 0U;
  c15_info[13].fileTime2 = 0U;
  c15_info[14].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_guarded_nan.m";
  c15_info[14].name = "nan";
  c15_info[14].dominantType = "char";
  c15_info[14].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/nan.m";
  c15_info[14].fileLength = 474U;
  c15_info[14].fileTime1 = 1192466744U;
  c15_info[14].fileTime2 = 0U;
  c15_info[15].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/nan.m";
  c15_info[15].name = "minus";
  c15_info[15].dominantType = "double";
  c15_info[15].resolved = "[B]minus";
  c15_info[15].fileLength = 0U;
  c15_info[15].fileTime1 = 0U;
  c15_info[15].fileTime2 = 0U;
  c15_info[16].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/nan.m";
  c15_info[16].name = "eml_varargin_to_size";
  c15_info[16].dominantType = "";
  c15_info[16].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_varargin_to_size.m";
  c15_info[16].fileLength = 630U;
  c15_info[16].fileTime1 = 1209330844U;
  c15_info[16].fileTime2 = 0U;
  c15_info[17].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_varargin_to_size.m";
  c15_info[17].name = "eml_assert_valid_size_arg";
  c15_info[17].dominantType = "";
  c15_info[17].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m";
  c15_info[17].fileLength = 3237U;
  c15_info[17].fileTime1 = 1227613384U;
  c15_info[17].fileTime2 = 0U;
  c15_info[18].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/nan.m";
  c15_info[18].name = "cast";
  c15_info[18].dominantType = "double";
  c15_info[18].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/cast.m";
  c15_info[18].fileLength = 889U;
  c15_info[18].fileTime1 = 1225989442U;
  c15_info[18].fileTime2 = 0U;
  c15_info[19].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/cast.m";
  c15_info[19].name = "ge";
  c15_info[19].dominantType = "double";
  c15_info[19].resolved = "[B]ge";
  c15_info[19].fileLength = 0U;
  c15_info[19].fileTime1 = 0U;
  c15_info[19].fileTime2 = 0U;
  c15_info[20].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/cast.m";
  c15_info[20].name = "double";
  c15_info[20].dominantType = "double";
  c15_info[20].resolved = "[B]double";
  c15_info[20].fileLength = 0U;
  c15_info[20].fileTime1 = 0U;
  c15_info[20].fileTime2 = 0U;
  c15_info[21].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sign.m";
  c15_info[21].name = "ones";
  c15_info[21].dominantType = "char";
  c15_info[21].resolved = "[B]ones";
  c15_info[21].fileLength = 0U;
  c15_info[21].fileTime1 = 0U;
  c15_info[21].fileTime2 = 0U;
  c15_info[22].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sign.m";
  c15_info[22].name = "lt";
  c15_info[22].dominantType = "double";
  c15_info[22].resolved = "[B]lt";
  c15_info[22].fileLength = 0U;
  c15_info[22].fileTime1 = 0U;
  c15_info[22].fileTime2 = 0U;
  c15_info[23].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sign.m";
  c15_info[23].name = "zeros";
  c15_info[23].dominantType = "char";
  c15_info[23].resolved = "[B]zeros";
  c15_info[23].fileLength = 0U;
  c15_info[23].fileTime1 = 0U;
  c15_info[23].fileTime2 = 0U;
  c15_info[24].context = "";
  c15_info[24].name = "mtimes";
  c15_info[24].dominantType = "double";
  c15_info[24].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c15_info[24].fileLength = 2408U;
  c15_info[24].fileTime1 = 1227613402U;
  c15_info[24].fileTime2 = 0U;
  c15_info[25].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c15_info[25].name = "isinteger";
  c15_info[25].dominantType = "double";
  c15_info[25].resolved = "[B]isinteger";
  c15_info[25].fileLength = 0U;
  c15_info[25].fileTime1 = 0U;
  c15_info[25].fileTime2 = 0U;
  c15_info[26].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c15_info[26].name = "isscalar";
  c15_info[26].dominantType = "double";
  c15_info[26].resolved = "[B]isscalar";
  c15_info[26].fileLength = 0U;
  c15_info[26].fileTime1 = 0U;
  c15_info[26].fileTime2 = 0U;
  c15_info[27].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c15_info[27].name = "size";
  c15_info[27].dominantType = "double";
  c15_info[27].resolved = "[B]size";
  c15_info[27].fileLength = 0U;
  c15_info[27].fileTime1 = 0U;
  c15_info[27].fileTime2 = 0U;
  c15_info[28].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c15_info[28].name = "not";
  c15_info[28].dominantType = "logical";
  c15_info[28].resolved = "[B]not";
  c15_info[28].fileLength = 0U;
  c15_info[28].fileTime1 = 0U;
  c15_info[28].fileTime2 = 0U;
}

static const mxArray *c15_emlrt_marshallOut(uint8_T c15_u)
{
  const mxArray *c15_y = NULL;
  c15_y = NULL;
  sf_mex_assign(&c15_y, sf_mex_create("y", &c15_u, 3, 0U, 0U, 0U, 0));
  return c15_y;
}

static void c15_emlrt_marshallIn(const mxArray *c15_fn, char *c15_name, real_T
  c15_y[6])
{
  real_T c15_dv1[6];
  int32_T c15_i11;
  sf_mex_import(c15_name, sf_mex_dup(c15_fn), &c15_dv1, 1, 0, 0U, 1, 0U, 1, 6);
  for (c15_i11 = 0; c15_i11 < 6; c15_i11 = c15_i11 + 1) {
    c15_y[c15_i11] = c15_dv1[c15_i11];
  }

  sf_mex_destroy(&c15_fn);
}

static uint8_T c15_b_emlrt_marshallIn(const mxArray
  *c15_b_is_active_c15_het_coeff_model, char *c15_name)
{
  uint8_T c15_y;
  uint8_T c15_u0;
  sf_mex_import(c15_name, sf_mex_dup(c15_b_is_active_c15_het_coeff_model),
                &c15_u0, 1, 3, 0U, 0, 0U, 0);
  c15_y = c15_u0;
  sf_mex_destroy(&c15_b_is_active_c15_het_coeff_model);
  return c15_y;
}

static void init_io_bus_offset(void)
{
}

static void init_dsm_address_info(void)
{
}

/* SFunction Glue Code */
void sf_c15_het_coeff_model_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(3903798346U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(4164825298U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(624234365U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(1610731145U);
}

mxArray *sf_c15_het_coeff_model_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,4,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(3122705149U);
    pr[1] = (double)(3842477059U);
    pr[2] = (double)(3094595083U);
    pr[3] = (double)(1793892608U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,2,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  return(mxAutoinheritanceInfo);
}

static mxArray *sf_get_sim_state_info_c15_het_coeff_model(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[5],T\"fn\",},{M[8],M[0],T\"is_active_c15_het_coeff_model\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c15_het_coeff_model_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (_het_coeff_modelMachineNumber_,
           15,
           1,
           1,
           3,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance.chartNumber),
           &(chartInstance.instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_het_coeff_modelMachineNumber_,
            chartInstance.chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (_het_coeff_modelMachineNumber_,chartInstance.chartNumber,1);
          sf_debug_set_chart_event_thresholds(_het_coeff_modelMachineNumber_,
            chartInstance.chartNumber,
            0,
            0,
            0);

          {
            unsigned int dimVector[1];
            dimVector[0]= 6;
            _SFD_SET_DATA_PROPS(0,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"Vn",0,c15_sf_marshall);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 6;
            _SFD_SET_DATA_PROPS(1,2,0,1,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"fn",0,NULL);
          }

          _SFD_SET_DATA_PROPS(2,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"alfa",0,
                              c15_b_sf_marshall);
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of EML Model Coverage */
        _SFD_CV_INIT_EML(0,1,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,155);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          real_T (*c15_Vn)[6];
          real_T (*c15_fn)[6];
          real_T *c15_alfa;
          c15_alfa = (real_T *)ssGetInputPortSignal(chartInstance.S, 1);
          c15_fn = (real_T (*)[6])ssGetOutputPortSignal(chartInstance.S, 1);
          c15_Vn = (real_T (*)[6])ssGetInputPortSignal(chartInstance.S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, c15_Vn);
          _SFD_SET_DATA_VALUE_PTR(1U, c15_fn);
          _SFD_SET_DATA_VALUE_PTR(2U, c15_alfa);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_het_coeff_modelMachineNumber_,
        chartInstance.chartNumber,chartInstance.instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c15_het_coeff_model(void *chartInstanceVar)
{
  chart_debug_initialization(chartInstance.S,0);
  initialize_params_c15_het_coeff_model();
  initialize_c15_het_coeff_model();
}

static void sf_opaque_enable_c15_het_coeff_model(void *chartInstanceVar)
{
  enable_c15_het_coeff_model();
}

static void sf_opaque_disable_c15_het_coeff_model(void *chartInstanceVar)
{
  disable_c15_het_coeff_model();
}

static void sf_opaque_gateway_c15_het_coeff_model(void *chartInstanceVar)
{
  sf_c15_het_coeff_model();
}

static mxArray* sf_opaque_get_sim_state_c15_het_coeff_model(void
  *chartInstanceVar)
{
  mxArray *st = (mxArray *) get_sim_state_c15_het_coeff_model();
  return st;
}

static void sf_opaque_set_sim_state_c15_het_coeff_model(void *chartInstanceVar,
  const mxArray *st)
{
  set_sim_state_c15_het_coeff_model(sf_mex_dup(st));
}

static void sf_opaque_terminate_c15_het_coeff_model(void *chartInstanceVar)
{
  if (sim_mode_is_rtw_gen(chartInstance.S) || sim_mode_is_external
      (chartInstance.S)) {
    sf_clear_rtw_identifier(chartInstance.S);
  }

  finalize_c15_het_coeff_model();
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c15_het_coeff_model(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c15_het_coeff_model();
  }
}

static void mdlSetWorkWidths_c15_het_coeff_model(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("het_coeff_model","het_coeff_model",15);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop("het_coeff_model","het_coeff_model",15,
                "RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("het_coeff_model",
      "het_coeff_model",15,"gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"het_coeff_model","het_coeff_model",
        15,2);
      sf_mark_chart_reusable_outputs(S,"het_coeff_model","het_coeff_model",15,1);
    }

    sf_set_rtw_dwork_info(S,"het_coeff_model","het_coeff_model",15);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(3530462004U));
  ssSetChecksum1(S,(1405543696U));
  ssSetChecksum2(S,(2285697036U));
  ssSetChecksum3(S,(3682293857U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c15_het_coeff_model(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "het_coeff_model", "het_coeff_model",15);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c15_het_coeff_model(SimStruct *S)
{
  chartInstance.chartInfo.chartInstance = NULL;
  chartInstance.chartInfo.isEMLChart = 1;
  chartInstance.chartInfo.chartInitialized = 0;
  chartInstance.chartInfo.sFunctionGateway =
    sf_opaque_gateway_c15_het_coeff_model;
  chartInstance.chartInfo.initializeChart =
    sf_opaque_initialize_c15_het_coeff_model;
  chartInstance.chartInfo.terminateChart =
    sf_opaque_terminate_c15_het_coeff_model;
  chartInstance.chartInfo.enableChart = sf_opaque_enable_c15_het_coeff_model;
  chartInstance.chartInfo.disableChart = sf_opaque_disable_c15_het_coeff_model;
  chartInstance.chartInfo.getSimState =
    sf_opaque_get_sim_state_c15_het_coeff_model;
  chartInstance.chartInfo.setSimState =
    sf_opaque_set_sim_state_c15_het_coeff_model;
  chartInstance.chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c15_het_coeff_model;
  chartInstance.chartInfo.zeroCrossings = NULL;
  chartInstance.chartInfo.outputs = NULL;
  chartInstance.chartInfo.derivatives = NULL;
  chartInstance.chartInfo.mdlRTW = mdlRTW_c15_het_coeff_model;
  chartInstance.chartInfo.mdlStart = mdlStart_c15_het_coeff_model;
  chartInstance.chartInfo.mdlSetWorkWidths =
    mdlSetWorkWidths_c15_het_coeff_model;
  chartInstance.chartInfo.extModeExec = NULL;
  chartInstance.chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.storeCurrentConfiguration = NULL;
  chartInstance.S = S;
  ssSetUserData(S,(void *)(&(chartInstance.chartInfo)));/* register the chart instance with simstruct */
  if (!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info();
  }

  chart_debug_initialization(S,1);
}

void c15_het_coeff_model_method_dispatcher(SimStruct *S, int_T method, void
  *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c15_het_coeff_model(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c15_het_coeff_model(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c15_het_coeff_model(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c15_het_coeff_model_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
