/* Include files */

#include "blascompat32.h"
#include "model_with_controller_sfun.h"
#include "c16_model_with_controller.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance.chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance.instanceNumber)
#include "model_with_controller_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define c16_IN_NO_ACTIVE_CHILD         (0)

/* Variable Declarations */

/* Variable Definitions */
static SFc16_model_with_controllerInstanceStruct chartInstance;

/* Function Declarations */
static void initialize_c16_model_with_controller(void);
static void initialize_params_c16_model_with_controller(void);
static void enable_c16_model_with_controller(void);
static void disable_c16_model_with_controller(void);
static void c16_update_debugger_state_c16_model_with_controller(void);
static const mxArray *get_sim_state_c16_model_with_controller(void);
static void set_sim_state_c16_model_with_controller(const mxArray *c16_st);
static void finalize_c16_model_with_controller(void);
static void sf_c16_model_with_controller(void);
static void init_script_number_translation(uint32_T c16_machineNumber, uint32_T
  c16_chartNumber);
static const mxArray *c16_sf_marshall(void *c16_chartInstance, void *c16_u);
static const mxArray *c16_b_sf_marshall(void *c16_chartInstance, void *c16_u);
static const mxArray *c16_c_sf_marshall(void *c16_chartInstance, void *c16_u);
static void c16_info_helper(c16_ResolvedFunctionInfo c16_info[23]);
static const mxArray *c16_emlrt_marshallOut(uint8_T c16_u);
static void c16_emlrt_marshallIn(const mxArray *c16_y, char *c16_name, real_T
  c16_b_y[36]);
static uint8_T c16_b_emlrt_marshallIn(const mxArray
  *c16_b_is_active_c16_model_with_controller, char *c16_name);
static void init_io_bus_offset(void);
static void init_dsm_address_info(void);

/* Function Definitions */
static void initialize_c16_model_with_controller(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  chartInstance.c16_is_active_c16_model_with_controller = 0U;
}

static void initialize_params_c16_model_with_controller(void)
{
}

static void enable_c16_model_with_controller(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void disable_c16_model_with_controller(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void c16_update_debugger_state_c16_model_with_controller(void)
{
}

static const mxArray *get_sim_state_c16_model_with_controller(void)
{
  const mxArray *c16_st = NULL;
  const mxArray *c16_y = NULL;
  int32_T c16_i0;
  real_T c16_u[36];
  const mxArray *c16_b_y = NULL;
  real_T (*c16_c_y)[36];
  c16_c_y = (real_T (*)[36])ssGetOutputPortSignal(chartInstance.S, 1);
  c16_st = NULL;
  c16_y = NULL;
  sf_mex_assign(&c16_y, sf_mex_createcellarray(2));
  for (c16_i0 = 0; c16_i0 < 36; c16_i0 = c16_i0 + 1) {
    c16_u[c16_i0] = (*c16_c_y)[c16_i0];
  }

  c16_b_y = NULL;
  sf_mex_assign(&c16_b_y, sf_mex_create("y", &c16_u, 0, 0U, 1U, 0U, 2, 6, 6));
  sf_mex_setcell(c16_y, 0, c16_b_y);
  sf_mex_setcell(c16_y, 1, c16_emlrt_marshallOut
                 (chartInstance.c16_is_active_c16_model_with_controller));
  sf_mex_assign(&c16_st, c16_y);
  return c16_st;
}

static void set_sim_state_c16_model_with_controller(const mxArray *c16_st)
{
  const mxArray *c16_u;
  real_T c16_dv0[36];
  int32_T c16_i1;
  real_T (*c16_y)[36];
  c16_y = (real_T (*)[36])ssGetOutputPortSignal(chartInstance.S, 1);
  chartInstance.c16_doneDoubleBufferReInit = true;
  c16_u = sf_mex_dup(c16_st);
  c16_emlrt_marshallIn(sf_mex_dup(sf_mex_getcell(c16_u, 0)), "y", c16_dv0);
  for (c16_i1 = 0; c16_i1 < 36; c16_i1 = c16_i1 + 1) {
    (*c16_y)[c16_i1] = c16_dv0[c16_i1];
  }

  chartInstance.c16_is_active_c16_model_with_controller = c16_b_emlrt_marshallIn
    (sf_mex_dup(sf_mex_getcell(c16_u, 1)),
     "is_active_c16_model_with_controller");
  sf_mex_destroy(&c16_u);
  c16_update_debugger_state_c16_model_with_controller();
  sf_mex_destroy(&c16_st);
}

static void finalize_c16_model_with_controller(void)
{
}

static void sf_c16_model_with_controller(void)
{
  int32_T c16_i2;
  int32_T c16_i3;
  uint8_T c16_previousEvent;
  int32_T c16_i4;
  real_T c16_u[6];
  real_T c16_nargout = 1.0;
  real_T c16_nargin = 1.0;
  real_T c16_y[36];
  int32_T c16_i5;
  real_T c16_v[6];
  int32_T c16_i6;
  int32_T c16_j;
  int32_T c16_b_j;
  int32_T c16_a;
  int32_T c16_c;
  int32_T c16_i7;
  real_T (*c16_b_y)[36];
  real_T (*c16_b_u)[6];
  c16_b_y = (real_T (*)[36])ssGetOutputPortSignal(chartInstance.S, 1);
  c16_b_u = (real_T (*)[6])ssGetInputPortSignal(chartInstance.S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG,3);
  for (c16_i2 = 0; c16_i2 < 6; c16_i2 = c16_i2 + 1) {
    _SFD_DATA_RANGE_CHECK((*c16_b_u)[c16_i2], 0U);
  }

  for (c16_i3 = 0; c16_i3 < 36; c16_i3 = c16_i3 + 1) {
    _SFD_DATA_RANGE_CHECK((*c16_b_y)[c16_i3], 1U);
  }

  c16_previousEvent = _sfEvent_;
  _sfEvent_ = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG,3);
  for (c16_i4 = 0; c16_i4 < 6; c16_i4 = c16_i4 + 1) {
    c16_u[c16_i4] = (*c16_b_u)[c16_i4];
  }

  sf_debug_symbol_scope_push(4U, 0U);
  sf_debug_symbol_scope_add("nargout", &c16_nargout, c16_c_sf_marshall);
  sf_debug_symbol_scope_add("nargin", &c16_nargin, c16_c_sf_marshall);
  sf_debug_symbol_scope_add("y", &c16_y, c16_b_sf_marshall);
  sf_debug_symbol_scope_add("u", &c16_u, c16_sf_marshall);
  CV_EML_FCN(0, 0);

  /*  This block supports an embeddable subset of the MATLAB language. */
  /*  See the help menu for details.  */
  _SFD_EML_CALL(0,5);
  for (c16_i5 = 0; c16_i5 < 6; c16_i5 = c16_i5 + 1) {
    c16_v[c16_i5] = c16_u[c16_i5];
  }

  for (c16_i6 = 0; c16_i6 < 36; c16_i6 = c16_i6 + 1) {
    c16_y[c16_i6] = 0.0;
  }

  for (c16_j = 1; c16_j < 7; c16_j = c16_j + 1) {
    c16_b_j = c16_j;
    c16_a = c16_b_j;
    c16_c = c16_a;
    c16_y[(_SFD_EML_ARRAY_BOUNDS_CHECK("d", _SFD_INTEGER_CHECK("j", (real_T)
             c16_b_j), 1, 6, 1, 0) - 1) + 6 * (
      _SFD_EML_ARRAY_BOUNDS_CHECK("d", _SFD_INTEGER_CHECK("", (real_T)c16_c), 1,
      6, 2, 0) - 1)] = c16_v[_SFD_EML_ARRAY_BOUNDS_CHECK("v",
      _SFD_INTEGER_CHECK("j", (real_T)c16_b_j), 1, 6, 1, 0) - 1];
  }

  _SFD_EML_CALL(0,-5);
  sf_debug_symbol_scope_pop();
  for (c16_i7 = 0; c16_i7 < 36; c16_i7 = c16_i7 + 1) {
    (*c16_b_y)[c16_i7] = c16_y[c16_i7];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG,3);
  _sfEvent_ = c16_previousEvent;
  sf_debug_check_for_state_inconsistency(_model_with_controllerMachineNumber_,
    chartInstance.chartNumber, chartInstance.instanceNumber
    );
}

static void init_script_number_translation(uint32_T c16_machineNumber, uint32_T
  c16_chartNumber)
{
}

static const mxArray *c16_sf_marshall(void *c16_chartInstance, void *c16_u)
{
  const mxArray *c16_y = NULL;
  int32_T c16_i8;
  real_T c16_b_u[6];
  const mxArray *c16_b_y = NULL;
  c16_y = NULL;
  for (c16_i8 = 0; c16_i8 < 6; c16_i8 = c16_i8 + 1) {
    c16_b_u[c16_i8] = (*((real_T (*)[6])c16_u))[c16_i8];
  }

  c16_b_y = NULL;
  sf_mex_assign(&c16_b_y, sf_mex_create("y", &c16_b_u, 0, 0U, 1U, 0U, 1, 6));
  sf_mex_assign(&c16_y, c16_b_y);
  return c16_y;
}

static const mxArray *c16_b_sf_marshall(void *c16_chartInstance, void *c16_u)
{
  const mxArray *c16_y = NULL;
  int32_T c16_i9;
  int32_T c16_i10;
  int32_T c16_i11;
  real_T c16_b_u[36];
  const mxArray *c16_b_y = NULL;
  c16_y = NULL;
  c16_i9 = 0;
  for (c16_i10 = 0; c16_i10 < 6; c16_i10 = c16_i10 + 1) {
    for (c16_i11 = 0; c16_i11 < 6; c16_i11 = c16_i11 + 1) {
      c16_b_u[c16_i11 + c16_i9] = (*((real_T (*)[36])c16_u))[c16_i11 + c16_i9];
    }

    c16_i9 = c16_i9 + 6;
  }

  c16_b_y = NULL;
  sf_mex_assign(&c16_b_y, sf_mex_create("y", &c16_b_u, 0, 0U, 1U, 0U, 2, 6, 6));
  sf_mex_assign(&c16_y, c16_b_y);
  return c16_y;
}

static const mxArray *c16_c_sf_marshall(void *c16_chartInstance, void *c16_u)
{
  const mxArray *c16_y = NULL;
  real_T c16_b_u;
  const mxArray *c16_b_y = NULL;
  c16_y = NULL;
  c16_b_u = *((real_T *)c16_u);
  c16_b_y = NULL;
  sf_mex_assign(&c16_b_y, sf_mex_create("y", &c16_b_u, 0, 0U, 0U, 0U, 0));
  sf_mex_assign(&c16_y, c16_b_y);
  return c16_y;
}

const mxArray *sf_c16_model_with_controller_get_eml_resolved_functions_info(void)
{
  const mxArray *c16_nameCaptureInfo = NULL;
  c16_ResolvedFunctionInfo c16_info[23];
  const mxArray *c16_m0 = NULL;
  int32_T c16_i12;
  c16_ResolvedFunctionInfo *c16_r0;
  c16_nameCaptureInfo = NULL;
  c16_info_helper(c16_info);
  sf_mex_assign(&c16_m0, sf_mex_createstruct("nameCaptureInfo", 1, 23));
  for (c16_i12 = 0; c16_i12 < 23; c16_i12 = c16_i12 + 1) {
    c16_r0 = &c16_info[c16_i12];
    sf_mex_addfield(c16_m0, sf_mex_create("nameCaptureInfo", c16_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c16_r0->context)), "context"
                    , "nameCaptureInfo", c16_i12);
    sf_mex_addfield(c16_m0, sf_mex_create("nameCaptureInfo", c16_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c16_r0->name)), "name",
                    "nameCaptureInfo", c16_i12);
    sf_mex_addfield(c16_m0, sf_mex_create("nameCaptureInfo",
      c16_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c16_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c16_i12);
    sf_mex_addfield(c16_m0, sf_mex_create("nameCaptureInfo", c16_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c16_r0->resolved)),
                    "resolved", "nameCaptureInfo", c16_i12);
    sf_mex_addfield(c16_m0, sf_mex_create("nameCaptureInfo", &c16_r0->fileLength,
      7, 0U, 0U, 0U, 0), "fileLength", "nameCaptureInfo",
                    c16_i12);
    sf_mex_addfield(c16_m0, sf_mex_create("nameCaptureInfo", &c16_r0->fileTime1,
      7, 0U, 0U, 0U, 0), "fileTime1", "nameCaptureInfo",
                    c16_i12);
    sf_mex_addfield(c16_m0, sf_mex_create("nameCaptureInfo", &c16_r0->fileTime2,
      7, 0U, 0U, 0U, 0), "fileTime2", "nameCaptureInfo",
                    c16_i12);
  }

  sf_mex_assign(&c16_nameCaptureInfo, c16_m0);
  return c16_nameCaptureInfo;
}

static void c16_info_helper(c16_ResolvedFunctionInfo c16_info[23])
{
  c16_info[0].context = "";
  c16_info[0].name = "diag";
  c16_info[0].dominantType = "double";
  c16_info[0].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c16_info[0].fileLength = 2581U;
  c16_info[0].fileTime1 = 1227613384U;
  c16_info[0].fileTime2 = 0U;
  c16_info[1].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c16_info[1].name = "nargin";
  c16_info[1].dominantType = "";
  c16_info[1].resolved = "[B]nargin";
  c16_info[1].fileLength = 0U;
  c16_info[1].fileTime1 = 0U;
  c16_info[1].fileTime2 = 0U;
  c16_info[2].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c16_info[2].name = "ge";
  c16_info[2].dominantType = "double";
  c16_info[2].resolved = "[B]ge";
  c16_info[2].fileLength = 0U;
  c16_info[2].fileTime1 = 0U;
  c16_info[2].fileTime2 = 0U;
  c16_info[3].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c16_info[3].name = "ndims";
  c16_info[3].dominantType = "double";
  c16_info[3].resolved = "[B]ndims";
  c16_info[3].fileLength = 0U;
  c16_info[3].fileTime1 = 0U;
  c16_info[3].fileTime2 = 0U;
  c16_info[4].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c16_info[4].name = "eq";
  c16_info[4].dominantType = "double";
  c16_info[4].resolved = "[B]eq";
  c16_info[4].fileLength = 0U;
  c16_info[4].fileTime1 = 0U;
  c16_info[4].fileTime2 = 0U;
  c16_info[5].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c16_info[5].name = "isnumeric";
  c16_info[5].dominantType = "double";
  c16_info[5].resolved = "[B]isnumeric";
  c16_info[5].fileLength = 0U;
  c16_info[5].fileTime1 = 0U;
  c16_info[5].fileTime2 = 0U;
  c16_info[6].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c16_info[6].name = "eml_index_class";
  c16_info[6].dominantType = "";
  c16_info[6].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c16_info[6].fileLength = 909U;
  c16_info[6].fileTime1 = 1192466782U;
  c16_info[6].fileTime2 = 0U;
  c16_info[7].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c16_info[7].name = "zeros";
  c16_info[7].dominantType = "char";
  c16_info[7].resolved = "[B]zeros";
  c16_info[7].fileLength = 0U;
  c16_info[7].fileTime1 = 0U;
  c16_info[7].fileTime2 = 0U;
  c16_info[8].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c16_info[8].name = "isvector";
  c16_info[8].dominantType = "double";
  c16_info[8].resolved = "[B]isvector";
  c16_info[8].fileLength = 0U;
  c16_info[8].fileTime1 = 0U;
  c16_info[8].fileTime2 = 0U;
  c16_info[9].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c16_info[9].name = "cast";
  c16_info[9].dominantType = "double";
  c16_info[9].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/cast.m";
  c16_info[9].fileLength = 889U;
  c16_info[9].fileTime1 = 1225989442U;
  c16_info[9].fileTime2 = 0U;
  c16_info[10].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/cast.m";
  c16_info[10].name = "ischar";
  c16_info[10].dominantType = "char";
  c16_info[10].resolved = "[B]ischar";
  c16_info[10].fileLength = 0U;
  c16_info[10].fileTime1 = 0U;
  c16_info[10].fileTime2 = 0U;
  c16_info[11].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/cast.m";
  c16_info[11].name = "int32";
  c16_info[11].dominantType = "double";
  c16_info[11].resolved = "[B]int32";
  c16_info[11].fileLength = 0U;
  c16_info[11].fileTime1 = 0U;
  c16_info[11].fileTime2 = 0U;
  c16_info[12].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c16_info[12].name = "lt";
  c16_info[12].dominantType = "int32";
  c16_info[12].resolved = "[B]lt";
  c16_info[12].fileLength = 0U;
  c16_info[12].fileTime1 = 0U;
  c16_info[12].fileTime2 = 0U;
  c16_info[13].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c16_info[13].name = "eml_index_plus";
  c16_info[13].dominantType = "int32";
  c16_info[13].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_plus.m";
  c16_info[13].fileLength = 272U;
  c16_info[13].fileTime1 = 1192466786U;
  c16_info[13].fileTime2 = 0U;
  c16_info[14].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c16_info[14].name = "eml_scalar_eg";
  c16_info[14].dominantType = "double";
  c16_info[14].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c16_info[14].fileLength = 3524U;
  c16_info[14].fileTime1 = 1227613394U;
  c16_info[14].fileTime2 = 0U;
  c16_info[15].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c16_info[15].name = "gt";
  c16_info[15].dominantType = "double";
  c16_info[15].resolved = "[B]gt";
  c16_info[15].fileLength = 0U;
  c16_info[15].fileTime1 = 0U;
  c16_info[15].fileTime2 = 0U;
  c16_info[16].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m/any_enums";
  c16_info[16].name = "false";
  c16_info[16].dominantType = "";
  c16_info[16].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/false.m";
  c16_info[16].fileLength = 238U;
  c16_info[16].fileTime1 = 1192466720U;
  c16_info[16].fileTime2 = 0U;
  c16_info[17].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elmat/false.m";
  c16_info[17].name = "logical";
  c16_info[17].dominantType = "double";
  c16_info[17].resolved = "[B]logical";
  c16_info[17].fileLength = 0U;
  c16_info[17].fileTime1 = 0U;
  c16_info[17].fileTime2 = 0U;
  c16_info[18].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c16_info[18].name = "isstruct";
  c16_info[18].dominantType = "double";
  c16_info[18].resolved = "[B]isstruct";
  c16_info[18].fileLength = 0U;
  c16_info[18].fileTime1 = 0U;
  c16_info[18].fileTime2 = 0U;
  c16_info[19].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c16_info[19].name = "isa";
  c16_info[19].dominantType = "double";
  c16_info[19].resolved = "[B]isa";
  c16_info[19].fileLength = 0U;
  c16_info[19].fileTime1 = 0U;
  c16_info[19].fileTime2 = 0U;
  c16_info[20].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m/zerosum";
  c16_info[20].name = "class";
  c16_info[20].dominantType = "double";
  c16_info[20].resolved = "[B]class";
  c16_info[20].fileLength = 0U;
  c16_info[20].fileTime1 = 0U;
  c16_info[20].fileTime2 = 0U;
  c16_info[21].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/datatypes/cast.m";
  c16_info[21].name = "double";
  c16_info[21].dominantType = "double";
  c16_info[21].resolved = "[B]double";
  c16_info[21].fileLength = 0U;
  c16_info[21].fileTime1 = 0U;
  c16_info[21].fileTime2 = 0U;
  c16_info[22].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m/allreal";
  c16_info[22].name = "isreal";
  c16_info[22].dominantType = "double";
  c16_info[22].resolved = "[B]isreal";
  c16_info[22].fileLength = 0U;
  c16_info[22].fileTime1 = 0U;
  c16_info[22].fileTime2 = 0U;
}

static const mxArray *c16_emlrt_marshallOut(uint8_T c16_u)
{
  const mxArray *c16_y = NULL;
  c16_y = NULL;
  sf_mex_assign(&c16_y, sf_mex_create("y", &c16_u, 3, 0U, 0U, 0U, 0));
  return c16_y;
}

static void c16_emlrt_marshallIn(const mxArray *c16_y, char *c16_name, real_T
  c16_b_y[36])
{
  real_T c16_dv1[36];
  int32_T c16_i13;
  sf_mex_import(c16_name, sf_mex_dup(c16_y), &c16_dv1, 1, 0, 0U, 1, 0U, 2, 6, 6);
  for (c16_i13 = 0; c16_i13 < 36; c16_i13 = c16_i13 + 1) {
    c16_b_y[c16_i13] = c16_dv1[c16_i13];
  }

  sf_mex_destroy(&c16_y);
}

static uint8_T c16_b_emlrt_marshallIn(const mxArray
  *c16_b_is_active_c16_model_with_controller, char *c16_name)
{
  uint8_T c16_y;
  uint8_T c16_u0;
  sf_mex_import(c16_name, sf_mex_dup(c16_b_is_active_c16_model_with_controller),
                &c16_u0, 1, 3, 0U, 0, 0U, 0);
  c16_y = c16_u0;
  sf_mex_destroy(&c16_b_is_active_c16_model_with_controller);
  return c16_y;
}

static void init_io_bus_offset(void)
{
}

static void init_dsm_address_info(void)
{
}

/* SFunction Glue Code */
void sf_c16_model_with_controller_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(90487743U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(1749732141U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(3362520516U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(3648368297U);
}

mxArray *sf_c16_model_with_controller_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,4,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(1577788608U);
    pr[1] = (double)(2800698242U);
    pr[2] = (double)(1223022990U);
    pr[3] = (double)(649966725U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(6);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  return(mxAutoinheritanceInfo);
}

static mxArray *sf_get_sim_state_info_c16_model_with_controller(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[5],T\"y\",},{M[8],M[0],T\"is_active_c16_model_with_controller\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c16_model_with_controller_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (_model_with_controllerMachineNumber_,
           16,
           1,
           1,
           2,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance.chartNumber),
           &(chartInstance.instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_model_with_controllerMachineNumber_,
            chartInstance.chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (_model_with_controllerMachineNumber_,chartInstance.chartNumber,1);
          sf_debug_set_chart_event_thresholds
            (_model_with_controllerMachineNumber_,
             chartInstance.chartNumber,
             0,
             0,
             0);

          {
            unsigned int dimVector[1];
            dimVector[0]= 6;
            _SFD_SET_DATA_PROPS(0,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"u",0,c16_sf_marshall);
          }

          {
            unsigned int dimVector[2];
            dimVector[0]= 6;
            dimVector[1]= 6;
            _SFD_SET_DATA_PROPS(1,2,0,1,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"y",0,c16_b_sf_marshall);
          }

          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of EML Model Coverage */
        _SFD_CV_INIT_EML(0,1,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,145);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          real_T (*c16_u)[6];
          real_T (*c16_y)[36];
          c16_y = (real_T (*)[36])ssGetOutputPortSignal(chartInstance.S, 1);
          c16_u = (real_T (*)[6])ssGetInputPortSignal(chartInstance.S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, c16_u);
          _SFD_SET_DATA_VALUE_PTR(1U, c16_y);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration
        (_model_with_controllerMachineNumber_,chartInstance.chartNumber,
         chartInstance.instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c16_model_with_controller(void
  *chartInstanceVar)
{
  chart_debug_initialization(chartInstance.S,0);
  initialize_params_c16_model_with_controller();
  initialize_c16_model_with_controller();
}

static void sf_opaque_enable_c16_model_with_controller(void *chartInstanceVar)
{
  enable_c16_model_with_controller();
}

static void sf_opaque_disable_c16_model_with_controller(void *chartInstanceVar)
{
  disable_c16_model_with_controller();
}

static void sf_opaque_gateway_c16_model_with_controller(void *chartInstanceVar)
{
  sf_c16_model_with_controller();
}

static mxArray* sf_opaque_get_sim_state_c16_model_with_controller(void
  *chartInstanceVar)
{
  mxArray *st = (mxArray *) get_sim_state_c16_model_with_controller();
  return st;
}

static void sf_opaque_set_sim_state_c16_model_with_controller(void
  *chartInstanceVar, const mxArray *st)
{
  set_sim_state_c16_model_with_controller(sf_mex_dup(st));
}

static void sf_opaque_terminate_c16_model_with_controller(void *chartInstanceVar)
{
  if (sim_mode_is_rtw_gen(chartInstance.S) || sim_mode_is_external
      (chartInstance.S)) {
    sf_clear_rtw_identifier(chartInstance.S);
  }

  finalize_c16_model_with_controller();
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c16_model_with_controller(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c16_model_with_controller();
  }
}

static void mdlSetWorkWidths_c16_model_with_controller(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("model_with_controller",
      "model_with_controller",16);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop("model_with_controller",
                "model_with_controller",16,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("model_with_controller",
      "model_with_controller",16,"gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"model_with_controller",
        "model_with_controller",16,1);
      sf_mark_chart_reusable_outputs(S,"model_with_controller",
        "model_with_controller",16,1);
    }

    sf_set_rtw_dwork_info(S,"model_with_controller","model_with_controller",16);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(2523054165U));
  ssSetChecksum1(S,(1807202128U));
  ssSetChecksum2(S,(3952079217U));
  ssSetChecksum3(S,(1315351939U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c16_model_with_controller(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "model_with_controller", "model_with_controller",
      16);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c16_model_with_controller(SimStruct *S)
{
  chartInstance.chartInfo.chartInstance = NULL;
  chartInstance.chartInfo.isEMLChart = 1;
  chartInstance.chartInfo.chartInitialized = 0;
  chartInstance.chartInfo.sFunctionGateway =
    sf_opaque_gateway_c16_model_with_controller;
  chartInstance.chartInfo.initializeChart =
    sf_opaque_initialize_c16_model_with_controller;
  chartInstance.chartInfo.terminateChart =
    sf_opaque_terminate_c16_model_with_controller;
  chartInstance.chartInfo.enableChart =
    sf_opaque_enable_c16_model_with_controller;
  chartInstance.chartInfo.disableChart =
    sf_opaque_disable_c16_model_with_controller;
  chartInstance.chartInfo.getSimState =
    sf_opaque_get_sim_state_c16_model_with_controller;
  chartInstance.chartInfo.setSimState =
    sf_opaque_set_sim_state_c16_model_with_controller;
  chartInstance.chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c16_model_with_controller;
  chartInstance.chartInfo.zeroCrossings = NULL;
  chartInstance.chartInfo.outputs = NULL;
  chartInstance.chartInfo.derivatives = NULL;
  chartInstance.chartInfo.mdlRTW = mdlRTW_c16_model_with_controller;
  chartInstance.chartInfo.mdlStart = mdlStart_c16_model_with_controller;
  chartInstance.chartInfo.mdlSetWorkWidths =
    mdlSetWorkWidths_c16_model_with_controller;
  chartInstance.chartInfo.extModeExec = NULL;
  chartInstance.chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.storeCurrentConfiguration = NULL;
  chartInstance.S = S;
  ssSetUserData(S,(void *)(&(chartInstance.chartInfo)));/* register the chart instance with simstruct */
  if (!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info();
  }

  chart_debug_initialization(S,1);
}

void c16_model_with_controller_method_dispatcher(SimStruct *S, int_T method,
  void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c16_model_with_controller(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c16_model_with_controller(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c16_model_with_controller(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c16_model_with_controller_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
