/* Include files */

#include "model_with_controller_sfun.h"
#include "c2_model_with_controller.h"
#include "c9_model_with_controller.h"
#include "c15_model_with_controller.h"
#include "c16_model_with_controller.h"
#include "c17_model_with_controller.h"

/* Type Definitions */

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */
uint8_T _sfEvent_;
uint32_T _model_with_controllerMachineNumber_;
real_T _sfTime_;

/* Function Declarations */

/* Function Definitions */
void model_with_controller_initializer(void)
{
  _sfEvent_ = CALL_EVENT;
}

void model_with_controller_terminator(void)
{
}

/* SFunction Glue Code */
unsigned int sf_model_with_controller_method_dispatcher(SimStruct *simstructPtr,
  unsigned int chartFileNumber, int_T method, void *data)
{
  if (chartFileNumber==2) {
    c2_model_with_controller_method_dispatcher(simstructPtr, method, data);
    return 1;
  }

  if (chartFileNumber==9) {
    c9_model_with_controller_method_dispatcher(simstructPtr, method, data);
    return 1;
  }

  if (chartFileNumber==15) {
    c15_model_with_controller_method_dispatcher(simstructPtr, method, data);
    return 1;
  }

  if (chartFileNumber==16) {
    c16_model_with_controller_method_dispatcher(simstructPtr, method, data);
    return 1;
  }

  if (chartFileNumber==17) {
    c17_model_with_controller_method_dispatcher(simstructPtr, method, data);
    return 1;
  }

  return 0;
}

unsigned int sf_model_with_controller_process_check_sum_call( int nlhs, mxArray *
  plhs[], int nrhs, const mxArray * prhs[] )
{

#ifdef MATLAB_MEX_FILE

  char commandName[20];
  if (nrhs<1 || !mxIsChar(prhs[0]) )
    return 0;

  /* Possible call to get the checksum */
  mxGetString(prhs[0], commandName,sizeof(commandName)/sizeof(char));
  commandName[(sizeof(commandName)/sizeof(char)-1)] = '\0';
  if (strcmp(commandName,"sf_get_check_sum"))
    return 0;
  plhs[0] = mxCreateDoubleMatrix( 1,4,mxREAL);
  if (nrhs>1 && mxIsChar(prhs[1])) {
    mxGetString(prhs[1], commandName,sizeof(commandName)/sizeof(char));
    commandName[(sizeof(commandName)/sizeof(char)-1)] = '\0';
    if (!strcmp(commandName,"machine")) {
      ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(1674478468U);
      ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(1768602913U);
      ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(1870764940U);
      ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(608236652U);
    } else if (!strcmp(commandName,"exportedFcn")) {
      ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(0U);
      ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(0U);
      ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(0U);
      ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(0U);
    } else if (!strcmp(commandName,"makefile")) {
      ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(1242854538U);
      ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(819237341U);
      ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(413076713U);
      ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(2197038828U);
    } else if (nrhs==3 && !strcmp(commandName,"chart")) {
      unsigned int chartFileNumber;
      chartFileNumber = (unsigned int)mxGetScalar(prhs[2]);
      switch (chartFileNumber) {
       case 2:
        {
          extern void sf_c2_model_with_controller_get_check_sum(mxArray *plhs[]);
          sf_c2_model_with_controller_get_check_sum(plhs);
          break;
        }

       case 9:
        {
          extern void sf_c9_model_with_controller_get_check_sum(mxArray *plhs[]);
          sf_c9_model_with_controller_get_check_sum(plhs);
          break;
        }

       case 15:
        {
          extern void sf_c15_model_with_controller_get_check_sum(mxArray *plhs[]);
          sf_c15_model_with_controller_get_check_sum(plhs);
          break;
        }

       case 16:
        {
          extern void sf_c16_model_with_controller_get_check_sum(mxArray *plhs[]);
          sf_c16_model_with_controller_get_check_sum(plhs);
          break;
        }

       case 17:
        {
          extern void sf_c17_model_with_controller_get_check_sum(mxArray *plhs[]);
          sf_c17_model_with_controller_get_check_sum(plhs);
          break;
        }

       default:
        ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(0.0);
        ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(0.0);
        ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(0.0);
        ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(0.0);
      }
    } else if (!strcmp(commandName,"target")) {
      ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(3901255494U);
      ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(3502312195U);
      ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(312011709U);
      ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(2399046860U);
    } else {
      return 0;
    }
  } else {
    ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(2666993979U);
    ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(2228333622U);
    ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(847846478U);
    ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(1129110599U);
  }

  return 1;

#else

  return 0;

#endif

}

unsigned int sf_model_with_controller_autoinheritance_info( int nlhs, mxArray *
  plhs[], int nrhs, const mxArray * prhs[] )
{

#ifdef MATLAB_MEX_FILE

  char commandName[32];
  if (nrhs<2 || !mxIsChar(prhs[0]) )
    return 0;

  /* Possible call to get the autoinheritance_info */
  mxGetString(prhs[0], commandName,sizeof(commandName)/sizeof(char));
  commandName[(sizeof(commandName)/sizeof(char)-1)] = '\0';
  if (strcmp(commandName,"get_autoinheritance_info"))
    return 0;

  {
    unsigned int chartFileNumber;
    chartFileNumber = (unsigned int)mxGetScalar(prhs[1]);
    switch (chartFileNumber) {
     case 2:
      {
        extern mxArray *sf_c2_model_with_controller_get_autoinheritance_info
          (void);
        plhs[0] = sf_c2_model_with_controller_get_autoinheritance_info();
        break;
      }

     case 9:
      {
        extern mxArray *sf_c9_model_with_controller_get_autoinheritance_info
          (void);
        plhs[0] = sf_c9_model_with_controller_get_autoinheritance_info();
        break;
      }

     case 15:
      {
        extern mxArray *sf_c15_model_with_controller_get_autoinheritance_info
          (void);
        plhs[0] = sf_c15_model_with_controller_get_autoinheritance_info();
        break;
      }

     case 16:
      {
        extern mxArray *sf_c16_model_with_controller_get_autoinheritance_info
          (void);
        plhs[0] = sf_c16_model_with_controller_get_autoinheritance_info();
        break;
      }

     case 17:
      {
        extern mxArray *sf_c17_model_with_controller_get_autoinheritance_info
          (void);
        plhs[0] = sf_c17_model_with_controller_get_autoinheritance_info();
        break;
      }

     default:
      plhs[0] = mxCreateDoubleMatrix(0,0,mxREAL);
    }
  }

  return 1;

#else

  return 0;

#endif

}

unsigned int sf_model_with_controller_get_eml_resolved_functions_info( int nlhs,
  mxArray * plhs[], int nrhs, const mxArray * prhs[] )
{

#ifdef MATLAB_MEX_FILE

  char commandName[64];
  if (nrhs<2 || !mxIsChar(prhs[0]))
    return 0;

  /* Possible call to get the get_eml_resolved_functions_info */
  mxGetString(prhs[0], commandName,sizeof(commandName)/sizeof(char));
  commandName[(sizeof(commandName)/sizeof(char)-1)] = '\0';
  if (strcmp(commandName,"get_eml_resolved_functions_info"))
    return 0;

  {
    unsigned int chartFileNumber;
    chartFileNumber = (unsigned int)mxGetScalar(prhs[1]);
    switch (chartFileNumber) {
     case 2:
      {
        extern const mxArray
          *sf_c2_model_with_controller_get_eml_resolved_functions_info(void);
        mxArray *persistentMxArray = (mxArray *)
          sf_c2_model_with_controller_get_eml_resolved_functions_info();
        plhs[0] = mxDuplicateArray(persistentMxArray);
        mxDestroyArray(persistentMxArray);
        break;
      }

     case 9:
      {
        extern const mxArray
          *sf_c9_model_with_controller_get_eml_resolved_functions_info(void);
        mxArray *persistentMxArray = (mxArray *)
          sf_c9_model_with_controller_get_eml_resolved_functions_info();
        plhs[0] = mxDuplicateArray(persistentMxArray);
        mxDestroyArray(persistentMxArray);
        break;
      }

     case 15:
      {
        extern const mxArray
          *sf_c15_model_with_controller_get_eml_resolved_functions_info(void);
        mxArray *persistentMxArray = (mxArray *)
          sf_c15_model_with_controller_get_eml_resolved_functions_info();
        plhs[0] = mxDuplicateArray(persistentMxArray);
        mxDestroyArray(persistentMxArray);
        break;
      }

     case 16:
      {
        extern const mxArray
          *sf_c16_model_with_controller_get_eml_resolved_functions_info(void);
        mxArray *persistentMxArray = (mxArray *)
          sf_c16_model_with_controller_get_eml_resolved_functions_info();
        plhs[0] = mxDuplicateArray(persistentMxArray);
        mxDestroyArray(persistentMxArray);
        break;
      }

     case 17:
      {
        extern const mxArray
          *sf_c17_model_with_controller_get_eml_resolved_functions_info(void);
        mxArray *persistentMxArray = (mxArray *)
          sf_c17_model_with_controller_get_eml_resolved_functions_info();
        plhs[0] = mxDuplicateArray(persistentMxArray);
        mxDestroyArray(persistentMxArray);
        break;
      }

     default:
      plhs[0] = mxCreateDoubleMatrix(0,0,mxREAL);
    }
  }

  return 1;

#else

  return 0;

#endif

}

void model_with_controller_debug_initialize(void)
{
  _model_with_controllerMachineNumber_ = sf_debug_initialize_machine(
    "model_with_controller","sfun",0,5,0,0,0);
  sf_debug_set_machine_event_thresholds(_model_with_controllerMachineNumber_,0,0);
  sf_debug_set_machine_data_thresholds(_model_with_controllerMachineNumber_,0);
}

void model_with_controller_register_exported_symbols(SimStruct* S)
{
}
