/* Include files */

#include "blascompat32.h"
#include "pruebacontrolador_sfun.h"
#include "c9_pruebacontrolador.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance.chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance.instanceNumber)
#include "pruebacontrolador_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define c9_IN_NO_ACTIVE_CHILD          (0)

/* Variable Declarations */

/* Variable Definitions */
static SFc9_pruebacontroladorInstanceStruct chartInstance;

/* Function Declarations */
static void initialize_c9_pruebacontrolador(void);
static void initialize_params_c9_pruebacontrolador(void);
static void enable_c9_pruebacontrolador(void);
static void disable_c9_pruebacontrolador(void);
static void c9_update_debugger_state_c9_pruebacontrolador(void);
static const mxArray *get_sim_state_c9_pruebacontrolador(void);
static void set_sim_state_c9_pruebacontrolador(const mxArray *c9_st);
static void finalize_c9_pruebacontrolador(void);
static void sf_c9_pruebacontrolador(void);
static void init_script_number_translation(uint32_T c9_machineNumber, uint32_T
  c9_chartNumber);
static void c9_eml_warning(void);
static const mxArray *c9_sf_marshall(void *c9_chartInstance, void *c9_u);
static const mxArray *c9_b_sf_marshall(void *c9_chartInstance, void *c9_u);
static const mxArray *c9_c_sf_marshall(void *c9_chartInstance, void *c9_u);
static void c9_info_helper(c9_ResolvedFunctionInfo c9_info[24]);
static const mxArray *c9_emlrt_marshallOut(uint8_T c9_u);
static void c9_emlrt_marshallIn(const mxArray *c9_friction, char *c9_name,
  real_T c9_y[6]);
static uint8_T c9_b_emlrt_marshallIn(const mxArray
  *c9_b_is_active_c9_pruebacontrolador, char *c9_name);
static void init_io_bus_offset(void);
static void init_dsm_address_info(void);

/* Function Definitions */
static void initialize_c9_pruebacontrolador(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  chartInstance.c9_is_active_c9_pruebacontrolador = 0U;
}

static void initialize_params_c9_pruebacontrolador(void)
{
}

static void enable_c9_pruebacontrolador(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void disable_c9_pruebacontrolador(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void c9_update_debugger_state_c9_pruebacontrolador(void)
{
}

static const mxArray *get_sim_state_c9_pruebacontrolador(void)
{
  const mxArray *c9_st = NULL;
  const mxArray *c9_y = NULL;
  int32_T c9_i0;
  real_T c9_u[6];
  const mxArray *c9_b_y = NULL;
  real_T (*c9_friction)[6];
  c9_friction = (real_T (*)[6])ssGetOutputPortSignal(chartInstance.S, 1);
  c9_st = NULL;
  c9_y = NULL;
  sf_mex_assign(&c9_y, sf_mex_createcellarray(2));
  for (c9_i0 = 0; c9_i0 < 6; c9_i0 = c9_i0 + 1) {
    c9_u[c9_i0] = (*c9_friction)[c9_i0];
  }

  c9_b_y = NULL;
  sf_mex_assign(&c9_b_y, sf_mex_create("y", &c9_u, 0, 0U, 1U, 0U, 1, 6));
  sf_mex_setcell(c9_y, 0, c9_b_y);
  sf_mex_setcell(c9_y, 1, c9_emlrt_marshallOut
                 (chartInstance.c9_is_active_c9_pruebacontrolador));
  sf_mex_assign(&c9_st, c9_y);
  return c9_st;
}

static void set_sim_state_c9_pruebacontrolador(const mxArray *c9_st)
{
  const mxArray *c9_u;
  real_T c9_dv0[6];
  int32_T c9_i1;
  real_T (*c9_friction)[6];
  c9_friction = (real_T (*)[6])ssGetOutputPortSignal(chartInstance.S, 1);
  chartInstance.c9_doneDoubleBufferReInit = true;
  c9_u = sf_mex_dup(c9_st);
  c9_emlrt_marshallIn(sf_mex_dup(sf_mex_getcell(c9_u, 0)), "friction", c9_dv0);
  for (c9_i1 = 0; c9_i1 < 6; c9_i1 = c9_i1 + 1) {
    (*c9_friction)[c9_i1] = c9_dv0[c9_i1];
  }

  chartInstance.c9_is_active_c9_pruebacontrolador = c9_b_emlrt_marshallIn
    (sf_mex_dup(sf_mex_getcell(c9_u, 1)),
     "is_active_c9_pruebacontrolador");
  sf_mex_destroy(&c9_u);
  c9_update_debugger_state_c9_pruebacontrolador();
  sf_mex_destroy(&c9_st);
}

static void finalize_c9_pruebacontrolador(void)
{
}

static void sf_c9_pruebacontrolador(void)
{
  int32_T c9_i2;
  int32_T c9_i3;
  int32_T c9_i4;
  int32_T c9_i5;
  uint8_T c9_previousEvent;
  int32_T c9_i6;
  real_T c9_V_tire[6];
  int32_T c9_i7;
  real_T c9_Vlong[6];
  int32_T c9_i8;
  real_T c9_alfa[12];
  real_T c9_nargout = 1.0;
  real_T c9_nargin = 3.0;
  real_T c9_i;
  real_T c9_m;
  real_T c9_n;
  real_T c9_friction[6];
  int32_T c9_i9;
  real_T c9_b_i;
  real_T c9_a;
  real_T c9_b;
  real_T c9_A;
  real_T c9_x;
  real_T c9_b_x;
  real_T c9_B;
  real_T c9_c_x;
  real_T c9_y;
  real_T c9_d_x;
  real_T c9_b_y;
  real_T c9_e_x;
  real_T c9_c_y;
  real_T c9_d_y;
  int32_T c9_i10;
  real_T (*c9_b_friction)[6];
  real_T (*c9_b_alfa)[12];
  real_T (*c9_b_Vlong)[6];
  real_T (*c9_b_V_tire)[6];
  c9_b_V_tire = (real_T (*)[6])ssGetInputPortSignal(chartInstance.S, 0);
  c9_b_friction = (real_T (*)[6])ssGetOutputPortSignal(chartInstance.S, 1);
  c9_b_alfa = (real_T (*)[12])ssGetInputPortSignal(chartInstance.S, 2);
  c9_b_Vlong = (real_T (*)[6])ssGetInputPortSignal(chartInstance.S, 1);
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG,8);
  for (c9_i2 = 0; c9_i2 < 6; c9_i2 = c9_i2 + 1) {
    _SFD_DATA_RANGE_CHECK((*c9_b_V_tire)[c9_i2], 0U);
  }

  for (c9_i3 = 0; c9_i3 < 6; c9_i3 = c9_i3 + 1) {
    _SFD_DATA_RANGE_CHECK((*c9_b_friction)[c9_i3], 1U);
  }

  for (c9_i4 = 0; c9_i4 < 6; c9_i4 = c9_i4 + 1) {
    _SFD_DATA_RANGE_CHECK((*c9_b_Vlong)[c9_i4], 2U);
  }

  for (c9_i5 = 0; c9_i5 < 12; c9_i5 = c9_i5 + 1) {
    _SFD_DATA_RANGE_CHECK((*c9_b_alfa)[c9_i5], 3U);
  }

  c9_previousEvent = _sfEvent_;
  _sfEvent_ = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG,8);
  for (c9_i6 = 0; c9_i6 < 6; c9_i6 = c9_i6 + 1) {
    c9_V_tire[c9_i6] = (*c9_b_V_tire)[c9_i6];
  }

  for (c9_i7 = 0; c9_i7 < 6; c9_i7 = c9_i7 + 1) {
    c9_Vlong[c9_i7] = (*c9_b_Vlong)[c9_i7];
  }

  for (c9_i8 = 0; c9_i8 < 12; c9_i8 = c9_i8 + 1) {
    c9_alfa[c9_i8] = (*c9_b_alfa)[c9_i8];
  }

  sf_debug_symbol_scope_push(9U, 0U);
  sf_debug_symbol_scope_add("nargout", &c9_nargout, c9_c_sf_marshall);
  sf_debug_symbol_scope_add("nargin", &c9_nargin, c9_c_sf_marshall);
  sf_debug_symbol_scope_add("i", &c9_i, c9_c_sf_marshall);
  sf_debug_symbol_scope_add("m", &c9_m, c9_c_sf_marshall);
  sf_debug_symbol_scope_add("n", &c9_n, c9_c_sf_marshall);
  sf_debug_symbol_scope_add("friction", &c9_friction, c9_sf_marshall);
  sf_debug_symbol_scope_add("alfa", &c9_alfa, c9_b_sf_marshall);
  sf_debug_symbol_scope_add("Vlong", &c9_Vlong, c9_sf_marshall);
  sf_debug_symbol_scope_add("V_tire", &c9_V_tire, c9_sf_marshall);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0,2);
  c9_n = 6.0;
  c9_m = 1.0;
  _SFD_EML_CALL(0,3);
  for (c9_i9 = 0; c9_i9 < 6; c9_i9 = c9_i9 + 1) {
    c9_friction[c9_i9] = 0.0;
  }

  c9_i = 1.0;
  c9_b_i = 1.0;
  while (c9_b_i <= 6.0) {
    c9_i = c9_b_i;
    CV_EML_FOR(0, 0, 1);
    _SFD_EML_CALL(0,5);
    if (CV_EML_COND(0, 0, c9_Vlong[_SFD_EML_ARRAY_BOUNDS_CHECK("Vlong", (int32_T)
          _SFD_INTEGER_CHECK("i", c9_i), 1, 6, 1, 0) - 1] == 0.0)) {
      if (CV_EML_COND(0, 1, c9_V_tire[_SFD_EML_ARRAY_BOUNDS_CHECK("V_tire",
            (int32_T)_SFD_INTEGER_CHECK("i", c9_i), 1, 6, 1, 0) - 1] == 0.0
                      )) {
        CV_EML_MCDC(0, 0, true);
        CV_EML_IF(0, 0, true);
        _SFD_EML_CALL(0,6);
        c9_friction[_SFD_EML_ARRAY_BOUNDS_CHECK("friction", (int32_T)
          _SFD_INTEGER_CHECK("i", c9_i), 1, 6, 1, 0) - 1] = 0.0;
        goto label_1;
      }
    }

    CV_EML_MCDC(0, 0, false);
    CV_EML_IF(0, 0, false);
    _SFD_EML_CALL(0,8);
    c9_a = c9_alfa[_SFD_EML_ARRAY_BOUNDS_CHECK("alfa", (int32_T)
      _SFD_INTEGER_CHECK("i", c9_i), 1, 12, 1, 0) - 1];
    c9_b = c9_V_tire[_SFD_EML_ARRAY_BOUNDS_CHECK("V_tire", (int32_T)
      _SFD_INTEGER_CHECK("i", c9_i), 1, 6, 1, 0) - 1] - c9_Vlong[
      _SFD_EML_ARRAY_BOUNDS_CHECK("Vlong", (int32_T)_SFD_INTEGER_CHECK("i", c9_i),
      1, 6, 1, 0) - 1];
    c9_A = c9_a * c9_b;
    c9_x = c9_Vlong[_SFD_EML_ARRAY_BOUNDS_CHECK("Vlong", (int32_T)
      _SFD_INTEGER_CHECK("i", c9_i), 1, 6, 1, 0) - 1];
    c9_b_x = c9_x;
    c9_B = muDoubleScalarAbs(c9_b_x);
    c9_c_x = c9_A;
    c9_y = c9_B;
    if (c9_y == 0.0) {
      c9_eml_warning();
    }

    c9_d_x = c9_c_x;
    c9_b_y = c9_y;
    c9_e_x = c9_d_x;
    c9_c_y = c9_b_y;
    c9_d_y = c9_e_x / c9_c_y;
    c9_friction[_SFD_EML_ARRAY_BOUNDS_CHECK("friction", (int32_T)
      _SFD_INTEGER_CHECK("i", c9_i), 1, 6, 1, 0) - 1] = c9_d_y;
   label_1:
    ;
    c9_b_i = c9_b_i + 1.0;
    sf_mex_listen_for_ctrl_c(chartInstance.S);
  }

  CV_EML_FOR(0, 0, 0);
  _SFD_EML_CALL(0,-8);
  sf_debug_symbol_scope_pop();
  for (c9_i10 = 0; c9_i10 < 6; c9_i10 = c9_i10 + 1) {
    (*c9_b_friction)[c9_i10] = c9_friction[c9_i10];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG,8);
  _sfEvent_ = c9_previousEvent;
  sf_debug_check_for_state_inconsistency(_pruebacontroladorMachineNumber_,
    chartInstance.chartNumber, chartInstance.instanceNumber);
}

static void init_script_number_translation(uint32_T c9_machineNumber, uint32_T
  c9_chartNumber)
{
}

static void c9_eml_warning(void)
{
  int32_T c9_i11;
  static char_T c9_cv0[15] = { 'D', 'i', 'v', 'i', 'd', 'e', ' ', 'b', 'y', ' ',
    'z', 'e', 'r', 'o', '.' };

  char_T c9_u[15];
  const mxArray *c9_y = NULL;
  int32_T c9_i12;
  static char_T c9_cv1[19] = { 'M', 'A', 'T', 'L', 'A', 'B', ':', 'd', 'i', 'v',
    'i', 'd', 'e', 'B', 'y', 'Z', 'e', 'r', 'o' };

  char_T c9_b_u[19];
  const mxArray *c9_b_y = NULL;
  for (c9_i11 = 0; c9_i11 < 15; c9_i11 = c9_i11 + 1) {
    c9_u[c9_i11] = c9_cv0[c9_i11];
  }

  c9_y = NULL;
  sf_mex_assign(&c9_y, sf_mex_create("y", &c9_u, 10, 0U, 1U, 0U, 2, 1, 15));
  for (c9_i12 = 0; c9_i12 < 19; c9_i12 = c9_i12 + 1) {
    c9_b_u[c9_i12] = c9_cv1[c9_i12];
  }

  c9_b_y = NULL;
  sf_mex_assign(&c9_b_y, sf_mex_create("y", &c9_b_u, 10, 0U, 1U, 0U, 2, 1, 19));
  sf_mex_call_debug("warning", 0U, 2U, 14, c9_b_y, 14, c9_y);
}

static const mxArray *c9_sf_marshall(void *c9_chartInstance, void *c9_u)
{
  const mxArray *c9_y = NULL;
  int32_T c9_i13;
  real_T c9_b_u[6];
  const mxArray *c9_b_y = NULL;
  c9_y = NULL;
  for (c9_i13 = 0; c9_i13 < 6; c9_i13 = c9_i13 + 1) {
    c9_b_u[c9_i13] = (*((real_T (*)[6])c9_u))[c9_i13];
  }

  c9_b_y = NULL;
  sf_mex_assign(&c9_b_y, sf_mex_create("y", &c9_b_u, 0, 0U, 1U, 0U, 1, 6));
  sf_mex_assign(&c9_y, c9_b_y);
  return c9_y;
}

static const mxArray *c9_b_sf_marshall(void *c9_chartInstance, void *c9_u)
{
  const mxArray *c9_y = NULL;
  int32_T c9_i14;
  real_T c9_b_u[12];
  const mxArray *c9_b_y = NULL;
  c9_y = NULL;
  for (c9_i14 = 0; c9_i14 < 12; c9_i14 = c9_i14 + 1) {
    c9_b_u[c9_i14] = (*((real_T (*)[12])c9_u))[c9_i14];
  }

  c9_b_y = NULL;
  sf_mex_assign(&c9_b_y, sf_mex_create("y", &c9_b_u, 0, 0U, 1U, 0U, 1, 12));
  sf_mex_assign(&c9_y, c9_b_y);
  return c9_y;
}

static const mxArray *c9_c_sf_marshall(void *c9_chartInstance, void *c9_u)
{
  const mxArray *c9_y = NULL;
  real_T c9_b_u;
  const mxArray *c9_b_y = NULL;
  c9_y = NULL;
  c9_b_u = *((real_T *)c9_u);
  c9_b_y = NULL;
  sf_mex_assign(&c9_b_y, sf_mex_create("y", &c9_b_u, 0, 0U, 0U, 0U, 0));
  sf_mex_assign(&c9_y, c9_b_y);
  return c9_y;
}

const mxArray *sf_c9_pruebacontrolador_get_eml_resolved_functions_info(void)
{
  const mxArray *c9_nameCaptureInfo = NULL;
  c9_ResolvedFunctionInfo c9_info[24];
  const mxArray *c9_m0 = NULL;
  int32_T c9_i15;
  c9_ResolvedFunctionInfo *c9_r0;
  c9_nameCaptureInfo = NULL;
  c9_info_helper(c9_info);
  sf_mex_assign(&c9_m0, sf_mex_createstruct("nameCaptureInfo", 1, 24));
  for (c9_i15 = 0; c9_i15 < 24; c9_i15 = c9_i15 + 1) {
    c9_r0 = &c9_info[c9_i15];
    sf_mex_addfield(c9_m0, sf_mex_create("nameCaptureInfo", c9_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c9_r0->context)), "context",
                    "nameCaptureInfo", c9_i15);
    sf_mex_addfield(c9_m0, sf_mex_create("nameCaptureInfo", c9_r0->name, 15, 0U,
      0U, 0U, 2, 1, strlen(c9_r0->name)), "name",
                    "nameCaptureInfo", c9_i15);
    sf_mex_addfield(c9_m0, sf_mex_create("nameCaptureInfo", c9_r0->dominantType,
      15, 0U, 0U, 0U, 2, 1, strlen(c9_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c9_i15);
    sf_mex_addfield(c9_m0, sf_mex_create("nameCaptureInfo", c9_r0->resolved, 15,
      0U, 0U, 0U, 2, 1, strlen(c9_r0->resolved)), "resolved"
                    , "nameCaptureInfo", c9_i15);
    sf_mex_addfield(c9_m0, sf_mex_create("nameCaptureInfo", &c9_r0->fileLength,
      7, 0U, 0U, 0U, 0), "fileLength", "nameCaptureInfo",
                    c9_i15);
    sf_mex_addfield(c9_m0, sf_mex_create("nameCaptureInfo", &c9_r0->fileTime1, 7,
      0U, 0U, 0U, 0), "fileTime1", "nameCaptureInfo", c9_i15
                    );
    sf_mex_addfield(c9_m0, sf_mex_create("nameCaptureInfo", &c9_r0->fileTime2, 7,
      0U, 0U, 0U, 0), "fileTime2", "nameCaptureInfo", c9_i15
                    );
  }

  sf_mex_assign(&c9_nameCaptureInfo, c9_m0);
  return c9_nameCaptureInfo;
}

static void c9_info_helper(c9_ResolvedFunctionInfo c9_info[24])
{
  c9_info[0].context = "";
  c9_info[0].name = "size";
  c9_info[0].dominantType = "double";
  c9_info[0].resolved = "[B]size";
  c9_info[0].fileLength = 0U;
  c9_info[0].fileTime1 = 0U;
  c9_info[0].fileTime2 = 0U;
  c9_info[1].context = "";
  c9_info[1].name = "zeros";
  c9_info[1].dominantType = "double";
  c9_info[1].resolved = "[B]zeros";
  c9_info[1].fileLength = 0U;
  c9_info[1].fileTime1 = 0U;
  c9_info[1].fileTime2 = 0U;
  c9_info[2].context = "";
  c9_info[2].name = "eq";
  c9_info[2].dominantType = "double";
  c9_info[2].resolved = "[B]eq";
  c9_info[2].fileLength = 0U;
  c9_info[2].fileTime1 = 0U;
  c9_info[2].fileTime2 = 0U;
  c9_info[3].context = "";
  c9_info[3].name = "minus";
  c9_info[3].dominantType = "double";
  c9_info[3].resolved = "[B]minus";
  c9_info[3].fileLength = 0U;
  c9_info[3].fileTime1 = 0U;
  c9_info[3].fileTime2 = 0U;
  c9_info[4].context = "";
  c9_info[4].name = "mtimes";
  c9_info[4].dominantType = "double";
  c9_info[4].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c9_info[4].fileLength = 2408U;
  c9_info[4].fileTime1 = 1227613402U;
  c9_info[4].fileTime2 = 0U;
  c9_info[5].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c9_info[5].name = "nargin";
  c9_info[5].dominantType = "";
  c9_info[5].resolved = "[B]nargin";
  c9_info[5].fileLength = 0U;
  c9_info[5].fileTime1 = 0U;
  c9_info[5].fileTime2 = 0U;
  c9_info[6].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c9_info[6].name = "gt";
  c9_info[6].dominantType = "double";
  c9_info[6].resolved = "[B]gt";
  c9_info[6].fileLength = 0U;
  c9_info[6].fileTime1 = 0U;
  c9_info[6].fileTime2 = 0U;
  c9_info[7].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c9_info[7].name = "isa";
  c9_info[7].dominantType = "double";
  c9_info[7].resolved = "[B]isa";
  c9_info[7].fileLength = 0U;
  c9_info[7].fileTime1 = 0U;
  c9_info[7].fileTime2 = 0U;
  c9_info[8].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c9_info[8].name = "isinteger";
  c9_info[8].dominantType = "double";
  c9_info[8].resolved = "[B]isinteger";
  c9_info[8].fileLength = 0U;
  c9_info[8].fileTime1 = 0U;
  c9_info[8].fileTime2 = 0U;
  c9_info[9].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c9_info[9].name = "isscalar";
  c9_info[9].dominantType = "double";
  c9_info[9].resolved = "[B]isscalar";
  c9_info[9].fileLength = 0U;
  c9_info[9].fileTime1 = 0U;
  c9_info[9].fileTime2 = 0U;
  c9_info[10].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c9_info[10].name = "strcmp";
  c9_info[10].dominantType = "char";
  c9_info[10].resolved = "[B]strcmp";
  c9_info[10].fileLength = 0U;
  c9_info[10].fileTime1 = 0U;
  c9_info[10].fileTime2 = 0U;
  c9_info[11].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c9_info[11].name = "class";
  c9_info[11].dominantType = "double";
  c9_info[11].resolved = "[B]class";
  c9_info[11].fileLength = 0U;
  c9_info[11].fileTime1 = 0U;
  c9_info[11].fileTime2 = 0U;
  c9_info[12].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c9_info[12].name = "not";
  c9_info[12].dominantType = "logical";
  c9_info[12].resolved = "[B]not";
  c9_info[12].fileLength = 0U;
  c9_info[12].fileTime1 = 0U;
  c9_info[12].fileTime2 = 0U;
  c9_info[13].context = "";
  c9_info[13].name = "abs";
  c9_info[13].dominantType = "double";
  c9_info[13].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c9_info[13].fileLength = 566U;
  c9_info[13].fileTime1 = 1221267134U;
  c9_info[13].fileTime2 = 0U;
  c9_info[14].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c9_info[14].name = "ischar";
  c9_info[14].dominantType = "double";
  c9_info[14].resolved = "[B]ischar";
  c9_info[14].fileLength = 0U;
  c9_info[14].fileTime1 = 0U;
  c9_info[14].fileTime2 = 0U;
  c9_info[15].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c9_info[15].name = "islogical";
  c9_info[15].dominantType = "double";
  c9_info[15].resolved = "[B]islogical";
  c9_info[15].fileLength = 0U;
  c9_info[15].fileTime1 = 0U;
  c9_info[15].fileTime2 = 0U;
  c9_info[16].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c9_info[16].name = "eml_scalar_abs";
  c9_info[16].dominantType = "double";
  c9_info[16].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  c9_info[16].fileLength = 461U;
  c9_info[16].fileTime1 = 1203447960U;
  c9_info[16].fileTime2 = 0U;
  c9_info[17].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  c9_info[17].name = "isreal";
  c9_info[17].dominantType = "double";
  c9_info[17].resolved = "[B]isreal";
  c9_info[17].fileLength = 0U;
  c9_info[17].fileTime1 = 0U;
  c9_info[17].fileTime2 = 0U;
  c9_info[18].context = "";
  c9_info[18].name = "mrdivide";
  c9_info[18].dominantType = "double";
  c9_info[18].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.m";
  c9_info[18].fileLength = 771U;
  c9_info[18].fileTime1 = 1219752936U;
  c9_info[18].fileTime2 = 0U;
  c9_info[19].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.m";
  c9_info[19].name = "ge";
  c9_info[19].dominantType = "double";
  c9_info[19].resolved = "[B]ge";
  c9_info[19].fileLength = 0U;
  c9_info[19].fileTime1 = 0U;
  c9_info[19].fileTime2 = 0U;
  c9_info[20].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.m";
  c9_info[20].name = "rdivide";
  c9_info[20].dominantType = "double";
  c9_info[20].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c9_info[20].fileLength = 620U;
  c9_info[20].fileTime1 = 1213926766U;
  c9_info[20].fileTime2 = 0U;
  c9_info[21].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c9_info[21].name = "isempty";
  c9_info[21].dominantType = "double";
  c9_info[21].resolved = "[B]isempty";
  c9_info[21].fileLength = 0U;
  c9_info[21].fileTime1 = 0U;
  c9_info[21].fileTime2 = 0U;
  c9_info[22].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c9_info[22].name = "eml_warning";
  c9_info[22].dominantType = "char";
  c9_info[22].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_warning.m";
  c9_info[22].fileLength = 274U;
  c9_info[22].fileTime1 = 1227613396U;
  c9_info[22].fileTime2 = 0U;
  c9_info[23].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c9_info[23].name = "eml_div";
  c9_info[23].dominantType = "double";
  c9_info[23].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  c9_info[23].fileLength = 4269U;
  c9_info[23].fileTime1 = 1227613386U;
  c9_info[23].fileTime2 = 0U;
}

static const mxArray *c9_emlrt_marshallOut(uint8_T c9_u)
{
  const mxArray *c9_y = NULL;
  c9_y = NULL;
  sf_mex_assign(&c9_y, sf_mex_create("y", &c9_u, 3, 0U, 0U, 0U, 0));
  return c9_y;
}

static void c9_emlrt_marshallIn(const mxArray *c9_friction, char *c9_name,
  real_T c9_y[6])
{
  real_T c9_dv1[6];
  int32_T c9_i16;
  sf_mex_import(c9_name, sf_mex_dup(c9_friction), &c9_dv1, 1, 0, 0U, 1, 0U, 1, 6);
  for (c9_i16 = 0; c9_i16 < 6; c9_i16 = c9_i16 + 1) {
    c9_y[c9_i16] = c9_dv1[c9_i16];
  }

  sf_mex_destroy(&c9_friction);
}

static uint8_T c9_b_emlrt_marshallIn(const mxArray
  *c9_b_is_active_c9_pruebacontrolador, char *c9_name)
{
  uint8_T c9_y;
  uint8_T c9_u0;
  sf_mex_import(c9_name, sf_mex_dup(c9_b_is_active_c9_pruebacontrolador), &c9_u0,
                1, 3, 0U, 0, 0U, 0);
  c9_y = c9_u0;
  sf_mex_destroy(&c9_b_is_active_c9_pruebacontrolador);
  return c9_y;
}

static void init_io_bus_offset(void)
{
}

static void init_dsm_address_info(void)
{
}

/* SFunction Glue Code */
void sf_c9_pruebacontrolador_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(537784570U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(471384943U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(1310154454U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(4025270955U);
}

mxArray *sf_c9_pruebacontrolador_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,4,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(504260275U);
    pr[1] = (double)(3138413943U);
    pr[2] = (double)(393309647U);
    pr[3] = (double)(3292483241U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,3,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(12);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  return(mxAutoinheritanceInfo);
}

static mxArray *sf_get_sim_state_info_c9_pruebacontrolador(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[5],T\"friction\",},{M[8],M[0],T\"is_active_c9_pruebacontrolador\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c9_pruebacontrolador_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (_pruebacontroladorMachineNumber_,
           9,
           1,
           1,
           4,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance.chartNumber),
           &(chartInstance.instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_pruebacontroladorMachineNumber_,
            chartInstance.chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (_pruebacontroladorMachineNumber_,chartInstance.chartNumber,1);
          sf_debug_set_chart_event_thresholds(_pruebacontroladorMachineNumber_,
            chartInstance.chartNumber,
            0,
            0,
            0);

          {
            unsigned int dimVector[1];
            dimVector[0]= 6;
            _SFD_SET_DATA_PROPS(0,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"V_tire",0,c9_sf_marshall);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 6;
            _SFD_SET_DATA_PROPS(1,2,0,1,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"friction",0,NULL);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 6;
            _SFD_SET_DATA_PROPS(2,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"Vlong",0,NULL);
          }

          {
            unsigned int dimVector[2];
            dimVector[0]= 12;
            dimVector[1]= 1;
            _SFD_SET_DATA_PROPS(3,1,1,0,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"alfa",0,c9_b_sf_marshall);
          }

          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of EML Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,0,1,0,2,1);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,254);
        _SFD_CV_INIT_EML_IF(0,0,108,144,170,250);
        _SFD_CV_INIT_EML_FOR(0,0,92,104,254);

        {
          static int condStart[] = { 112, 129 };

          static int condEnd[] = { 125, 143 };

          static int pfixExpr[] = { 0, 1, -3 };

          _SFD_CV_INIT_EML_MCDC(0,0,111,144,2,0,&(condStart[0]),&(condEnd[0]),3,
                                &(pfixExpr[0]));
        }

        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          real_T (*c9_V_tire)[6];
          real_T (*c9_friction)[6];
          real_T (*c9_Vlong)[6];
          real_T (*c9_alfa)[12];
          c9_V_tire = (real_T (*)[6])ssGetInputPortSignal(chartInstance.S, 0);
          c9_friction = (real_T (*)[6])ssGetOutputPortSignal(chartInstance.S, 1);
          c9_alfa = (real_T (*)[12])ssGetInputPortSignal(chartInstance.S, 2);
          c9_Vlong = (real_T (*)[6])ssGetInputPortSignal(chartInstance.S, 1);
          _SFD_SET_DATA_VALUE_PTR(0U, c9_V_tire);
          _SFD_SET_DATA_VALUE_PTR(1U, c9_friction);
          _SFD_SET_DATA_VALUE_PTR(2U, c9_Vlong);
          _SFD_SET_DATA_VALUE_PTR(3U, c9_alfa);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration
        (_pruebacontroladorMachineNumber_,chartInstance.chartNumber,
         chartInstance.instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c9_pruebacontrolador(void *chartInstanceVar)
{
  chart_debug_initialization(chartInstance.S,0);
  initialize_params_c9_pruebacontrolador();
  initialize_c9_pruebacontrolador();
}

static void sf_opaque_enable_c9_pruebacontrolador(void *chartInstanceVar)
{
  enable_c9_pruebacontrolador();
}

static void sf_opaque_disable_c9_pruebacontrolador(void *chartInstanceVar)
{
  disable_c9_pruebacontrolador();
}

static void sf_opaque_gateway_c9_pruebacontrolador(void *chartInstanceVar)
{
  sf_c9_pruebacontrolador();
}

static mxArray* sf_opaque_get_sim_state_c9_pruebacontrolador(void
  *chartInstanceVar)
{
  mxArray *st = (mxArray *) get_sim_state_c9_pruebacontrolador();
  return st;
}

static void sf_opaque_set_sim_state_c9_pruebacontrolador(void *chartInstanceVar,
  const mxArray *st)
{
  set_sim_state_c9_pruebacontrolador(sf_mex_dup(st));
}

static void sf_opaque_terminate_c9_pruebacontrolador(void *chartInstanceVar)
{
  if (sim_mode_is_rtw_gen(chartInstance.S) || sim_mode_is_external
      (chartInstance.S)) {
    sf_clear_rtw_identifier(chartInstance.S);
  }

  finalize_c9_pruebacontrolador();
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c9_pruebacontrolador(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c9_pruebacontrolador();
  }
}

static void mdlSetWorkWidths_c9_pruebacontrolador(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("pruebacontrolador","pruebacontrolador",9);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop("pruebacontrolador","pruebacontrolador",9,
                "RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("pruebacontrolador",
      "pruebacontrolador",9,"gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"pruebacontrolador",
        "pruebacontrolador",9,3);
      sf_mark_chart_reusable_outputs(S,"pruebacontrolador","pruebacontrolador",9,
        1);
    }

    sf_set_rtw_dwork_info(S,"pruebacontrolador","pruebacontrolador",9);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(2422949319U));
  ssSetChecksum1(S,(1134086924U));
  ssSetChecksum2(S,(138272924U));
  ssSetChecksum3(S,(1899640658U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c9_pruebacontrolador(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "pruebacontrolador", "pruebacontrolador",9);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c9_pruebacontrolador(SimStruct *S)
{
  chartInstance.chartInfo.chartInstance = NULL;
  chartInstance.chartInfo.isEMLChart = 1;
  chartInstance.chartInfo.chartInitialized = 0;
  chartInstance.chartInfo.sFunctionGateway =
    sf_opaque_gateway_c9_pruebacontrolador;
  chartInstance.chartInfo.initializeChart =
    sf_opaque_initialize_c9_pruebacontrolador;
  chartInstance.chartInfo.terminateChart =
    sf_opaque_terminate_c9_pruebacontrolador;
  chartInstance.chartInfo.enableChart = sf_opaque_enable_c9_pruebacontrolador;
  chartInstance.chartInfo.disableChart = sf_opaque_disable_c9_pruebacontrolador;
  chartInstance.chartInfo.getSimState =
    sf_opaque_get_sim_state_c9_pruebacontrolador;
  chartInstance.chartInfo.setSimState =
    sf_opaque_set_sim_state_c9_pruebacontrolador;
  chartInstance.chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c9_pruebacontrolador;
  chartInstance.chartInfo.zeroCrossings = NULL;
  chartInstance.chartInfo.outputs = NULL;
  chartInstance.chartInfo.derivatives = NULL;
  chartInstance.chartInfo.mdlRTW = mdlRTW_c9_pruebacontrolador;
  chartInstance.chartInfo.mdlStart = mdlStart_c9_pruebacontrolador;
  chartInstance.chartInfo.mdlSetWorkWidths =
    mdlSetWorkWidths_c9_pruebacontrolador;
  chartInstance.chartInfo.extModeExec = NULL;
  chartInstance.chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.storeCurrentConfiguration = NULL;
  chartInstance.S = S;
  ssSetUserData(S,(void *)(&(chartInstance.chartInfo)));/* register the chart instance with simstruct */
  if (!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info();
  }

  chart_debug_initialization(S,1);
}

void c9_pruebacontrolador_method_dispatcher(SimStruct *S, int_T method, void
  *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c9_pruebacontrolador(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c9_pruebacontrolador(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c9_pruebacontrolador(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c9_pruebacontrolador_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
